<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Response;
use App\User;
use App\Otp;
use App\BankerProfile;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Cookie;

use SendGrid\Mail\From;
//use SendGrid\Mail\Mail;
use SendGrid\Mail\To;
use SendGrid\Mail\TypeException;
use App\SessionStore;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;
use Carbon\Carbon;
use App\Mail\SendGridEmail;
use App\GeneralSettings;
use App\Server\ApiUrl;
//use App\Audit_trail;

class UserController extends Controller
{

    public $servicurls ;

    function __construct() {
       $this->servicurls =  new ApiUrl();
     }

    public function saveUser(Request $request)
    {
        DB::enableQueryLog();
        $baseUrl = $this->servicurls->deltaurl;

        $checkPan       = User::where('pan', $request->pan)->get();
        $checkEmail     = User::where('email', $request->email)->get();
        $checkMobile    = User::where('mobile', $request->mobile)->get();

        if (count($checkPan) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Pan Already exists',
                "Data" => ""
            ], 201);
        }
          
        if (count($checkEmail) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Email Already exists',
                "Data" => ""
            ], 201);
        }
        if (count($checkMobile) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Mobile Already exists',
                "Data" => ""
            ], 201);
        }


        $users = User::firstOrNew(['id' => $request->users_id]);
        $users->name = $request->get('name');
        $users->email = $request->get('email');
        $users->mobile = $request->get('mobile');
        $users->pan = $request->get('pan');
        $users->password = $request->get('password');
        $users->country_code = $request->get('country_code');
        $users->role_id = 2;
        //$users->role_id = $request->get('role_id'); 
        $users->enable = 0;
        $users->is_active = 1;
        $timestamp = now();


        if (!empty($request->users_id)) {
            $users->modified_by = 1;
            $users->modified_on = now();
        } else {
            $users->created_by = 1;
            $users->created_on = now();
        }

        $users->save();

        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        // $this->callLogFileStore($request->user_id, "GeneralSettings", "select", $query1[0]['query'], "general_settings","Fetch");
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);

        $data['user'] = $users;


        if ($users) {
            return response()->json([
                "status" => true,
                "message" => 'Successfully inserted',
                "Data" => $data
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }
    }


    public function otp(Request $request)
    {
        $checkEmail     = User::where('email', $request->value)->get();
        $checkMobile    = User::where('mobile', $request->value)->get();
         Log::info($checkEmail);
         Log::info($checkMobile);
        if (count($checkEmail) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Email Already exists',
            ], 201);
        }
        if (count($checkMobile) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Mobile Already exists',
            ], 201);
        }
        $otps = Otp::firstOrNew(['id' => $request->otp_id]);
        $otps->type = $request->get('type');
        $otps->value = $request->get('value');
        $otps->form_id = $request->get('form_id');
        $otps->created_by = 0;
        $otps->created_on = now();

        $otp_type  = rand(100000, 999999);
        $data['otp'] = $otp_type;
        $mobNumber =$request->value;

        if ($request->type == 'mobile') {
            //$response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->value . '&message=' . $otp_type . ' is the OTP for your application');
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "http://api.pinnacle.in/index.php/sms/json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
               
                CURLOPT_POSTFIELDS => '{
              
                      "sender": "aageyM",
                      "message": [
                             {
                                   "number": "' . $mobNumber . '",
                                  "text": "AAGEY.COM ' .  $otp_type. ' is the OTP for your application"
                             }
                       ],
                      "messagetype":"TXT",
                      "dltentityid":"1701161718380850717",
                      "dlttempid":"1007165295648521926"
                
               }',
               CURLOPT_HTTPHEADER => array(
                "content-type: application/json",
                "apikey:476e18-f8b66b-26c69e-afdafb-13c4e5"
            )
              
            ));
            Log::info($curl['CURLOPT_POSTFIELDS']);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($response) {
                $otps->otp = $otp_type;
                $otps->validate_otp = false;
                $otps->save();
                $data['otps'] = $otps;
                return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        } else if ($request->type == 'email') {
            $respo = $this->sendEmail($request->value, $otp_type);
            if ($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202) {
                $otps->otp = $otp_type;
                $otps->validate_otp = false;
                $otps->save();
                $data['otps'] = $otps;
                return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        }
    }

    public function checkuser(Request $request)
    {
        if (!empty($request->email)) {
            $check  = User::where('pan', $request->pan)->where('email', $request->email)->get();
        } else if (!empty($request->mobile)) {
            $check  = User::where('pan', $request->pan)->where('mobile', $request->mobile)->get();
        }

        if (count($check) > 0) {
            return response()->json([
                "status" => true,
                "message" => ' Pan Already exists',
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Enter valid credentials or If not a User please Register',
            ], 201);
        }
    }
    public function resendOtp(Request $request)
    {
      //  echo $request;exit;
        $checkOtp = Otp::where('value', $request->value)->get();
        Log::info("ji");
      
        //dd($checkOtp->all());
        $otps = new Otp();
        $otp_type  = rand(100000, 999999);
        $mobNumber =$request->value;
        $data['otp'] = $otp_type;
        if ($request->type == 'mobile') {
            //$response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->value . '&message=' . $otp_type . ' is the OTP for your application');
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "http://api.pinnacle.in/index.php/sms/json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
               
                CURLOPT_POSTFIELDS => '{
              
                      "sender": "aageyM",
                      "message": [
                             {
                                   "number": "' . $mobNumber . '",
                                  "text": "AAGEY.COM ' .  $otp_type. ' is the OTP for your application"
                             }
                       ],
                      "messagetype":"TXT",
                      "dltentityid":"1701161718380850717",
                      "dlttempid":"1007165295648521926"
                
               }',
               CURLOPT_HTTPHEADER => array(
                "content-type: application/json",
                "apikey:476e18-f8b66b-26c69e-afdafb-13c4e5"
            )
              
            ));
            Log::info($curl['CURLOPT_POSTFIELDS']);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            
            if ($response) {
                $updateotp = Otp::select('otp')
                    ->where('value', $request->value)
                    ->update(['otp' => $otp_type]);
                return response()->json([
                    "status" => true,
                    "message" => 'Resent otp successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        } else if ($request->type == 'email') {
            $respo = $this->sendEmail($request->value, $otp_type);
            if ($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202) {
                $updateotp = Otp::select('otp')
                    ->where('value', $request->value)
                    ->update(['otp' => $otp_type]);
                return response()->json([
                    "status" => true,
                    "message" => 'Resent otp successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        }
    }

    public function getAllUsers(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if ($request->has('enable')) {
            $getAllUsers =  User::where('is_active', '=', true)->where('enable', '=', $request->enable)->get();
        } else {
            $getAllUsers =  User::where('is_active', '=', true)->get();
        }
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($getAllUsers) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $getAllUsers
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }
    }



    public function getOtpByvalue(Request $request)
    {

        $otps = Otp::select('otp')
            ->where('value', $request->value)->get();
        if (!empty($otps)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data" => $otps
            ], 200);
        } else {
            return response()->json([
                "message" => 'No records found'
            ], 403);
        }
    }

    public function verifyOtp(Request $request)
    {
        $checkOtp = Otp::select('otp', 'value')
            ->where('value', '=', $request->value)
            ->where('form_id', '=', $request->form_id)
            ->where('otp', '=', $request->otp)
            ->get();

        Log::info($checkOtp);
        Log::info("hfuhiwh");
        if (!$checkOtp->isEmpty()) {
            $updateUser = Otp::select('otp')
                ->where('value', '=', $request->value)
                ->where('form_id', '=', $request->form_id)
                ->where('otp', '=', $request->otp)
                ->update(['validate_otp' => true]);

            return response()->json([
                "status" => true,
                "message" => 'Otp verified successfully',
                "data" => $checkOtp,
                "user logged_in_time" => date('Y-m-d H:i:s'),

            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Please enter valid otp',
        ], 201);
    }


    public function retrieveMobileOrEmail(Request $request)
    {
        $getMobileEmail = User::where('pan', $request->pan)->first();
        if ($getMobileEmail) {
            $data['email']   = $getMobileEmail->email;
            $data['mobile'] = $getMobileEmail->mobile;
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "Data" => $data
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not found',
            ], 201);
        }
    }

    public function AgreeAndSignUp(Request $request)
    {
        $checkusers = User::where('id', '=', $request->id)->get();

        if (!$checkusers->isEmpty()) {
            $updateusers = User::where('id', '=', $request->id)
                ->update(['enable' => 1]);

            return response()->json([
                "status" => true,
                "message" => 'signup successfull',
                "data" => $updateusers
            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Failed',
        ], 201);
    }



    public function getUserByid(Request $request ,$id)
    {

        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $users = User::find($id);
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if ($users) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "Data" => $users
            ], 200);
        } else {
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }
    }

    public function updateUserByid(Request $request,  $id)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $users = User::find($id);
        $users->name = $request->get('name');
        $users->email = $request->get('email');
        $users->mobile = $request->get('mobile');
        $users->pan = $request->get('pan');
        $users->password = $request->get('password');

        $users->save();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "update"

        ]);
        if ($users) {
            return response()->json([
                "message" => 'Data updated successfully',
                "Data" => $users
            ], 200);
        } else {
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }
    }

    public function deletebyid(Request $request,$id)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $users = User::find($id);

        $users->delete();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "delete"

        ]);
        if ($users) {
            return response()->json([
                "message" => 'Data deleted successfully',
            ], 200);
        } else {
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }
    }
    protected function generateOtp()
    {
        $otp_number = rand(100000, 999999);
        return $otp_number;
    }

    protected function saveOtp($type, $value, $otp_val)
    {
        $otp = new Otp();
        $otp->type = $type;
        $otp->value = $value;
        $otp->created_by = 0;
        $otp->created_on = now();
        $otp->otp = $otp_val;
        $otp->validate_otp = false;
        $otp->form_id = 2;
        $otp->save();
    }

    protected function getPassportToken($user)
    {
        //Auth::UserSignin($user);
        $tokenResult = $user->createToken('aagey');
        $token = $tokenResult->token;
        $token->expires_at = Carbon::now()->addWeeks(5);
        $token->save();

        return $tokenResult;
    }

    //ganashree
    // public function UserSignin(Request $request)
    // {
    //     DB::enableQueryLog();
    //     //Log::info($request);
    //      $type =  $request->type;
    //     $otp = $this->generateOtp();
    //     if (!empty($request->email)) {

    //         $checkUser  = User::where('pan', $request->pan)->where('email', $request->email)->first();
    //         //Log::info( $checkUser);
    //         $name = 'user';
    //         $respo = $this->sendEmail($request->email, $otp, $name, "signin");
    //         if ($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202) {
    //             $type = "email";
    //             $this->saveOtp($type, $request->email, $otp);
    //             // $token_result = $checkUser->createToken('aagey');
    //             // $token['access_token'] =  $token_result->accessToken;
    //             // $token['token_type'] = "Bearer";
    //             // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
    //             $data['email_otp'] = $otp;
    //             $data['user_details'] = $checkUser;
    //             $query1 = DB::getQueryLog();
    //             Log::info($query1[0]['query']);

    //             //$this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Signin");
    //             Http::post('http://164.52.208.120:8082/delta/server.php/api/callLogFileStore1', [
    //                 'user_id' => $request->user_id,
    //                 'form_type' => "User",
    //                 'query_type' => "select",
    //                 'query' => $query1[0]['query'],
    //                 'table_name' => "users",
    //                 'user_action' => "Signin"

    //             ]);
    //             return response()->json([
    //                 "status" => true,
    //                 "message" => 'Otp sent successfully',
    //                 "Data" => $data,
    //                 // "token" => $token
    //             ], 201);
    //         } else {
    //             return response()->json([
    //                 "status" => false,
    //                 "message" => 'Failed to Send OTP',
    //             ], 201);
    //         }
    //     } elseif ($request->mobile) {
    //         $checkUser  = User::where('pan', $request->pan)->where('mobile', $request->mobile)->first();
    //         $res = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->mobile . '&message=' . $otp . ' is the OTP for your application');
    //         $context = json_decode($res->body());
    //         if ($context->status == "OK") {
    //             $type = "mobile";
    //             $this->saveOtp($type, $request->mobile, $otp);

    //             // $token_result = $checkUser->createToken('aagey');
    //             // $token['access_token'] =  $token_result->accessToken;
    //             // $token['token_type'] = "Bearer";
    //             // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();

    //             $data['mobile_otp'] = $otp;
    //             $data['user_details'] = $checkUser;
    //             return response()->json([
    //                 "status" => true,
    //                 "message" => 'Otp sent successfully',

    //                 "Data" => $data,
    //                 // "token" => $token

    //             ], 201);
    //         } else {
    //             return response()->json([
    //                 "status" => false,
    //                 "message" => 'Failed to Send OTP',
    //             ], 201);
    //         }
    //     } else {
    //         return response()->json([
    //             "status" => false,
    //             "message" => 'invalid type',
    //         ], 201);
    //     }

    public function UserSignin(Request $request){
        //Log::info($request);
		//dd($request['email']);
         $type =  $request->type;
        $otp = $this->generateOtp();
        if (!empty($request->email)) {
            $checkUser  = User::where('pan',$request->pan)->where('email',$request->email)->first();
            Log::info( $checkUser);
			//Session::put('$respo', $name);
            $name = 'user';
            $respo = $this->sendEmail($request['email'], $otp, $name,"signin");
			Session::put('$respo', $name);
			Log::info($name);
            if($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202){
                $type = "email";
                $this->saveOtp($type, $request->email, $otp );
                // $token_result = $checkUser->createToken('aagey');
                // $token['access_token'] =  $token_result->accessToken;
                // $token['token_type'] = "Bearer";
                // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
                $data['email_otp'] = $otp;
                $data['user_details'] = $checkUser;
                return response()->json([
                    "status" => true,
                        "message" => 'Otp sent successfully',
                        "Data" => $data,
                        // "token" => $token
                    ],201);
            } else {
                    return response()->json([
                    "status" => false,
                        "message" => 'Failed to Send OTP',
                    ],201);
            }
        } elseif($request->mobile){
            $checkUser  = User::where('pan',$request->pan)->where('mobile',$request->mobile)->first();
			$mobNumber =$request->mobile;
           // $res = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number='.$request->mobile.'&message='. $otp .' is the OTP for your application');
            
			$curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "http://api.pinnacle.in/index.php/sms/json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
               
                CURLOPT_POSTFIELDS => '{
              
                      "sender": "aageyM",
                      "message": [
                             {
                                   "number": "' . $mobNumber . '",
                                  "text": "AAGEY.COM ' .  $otp. ' is the OTP for your application"
                             }
                       ],
                      "messagetype":"TXT",
                      "dltentityid":"1701161718380850717",
                      "dlttempid":"1007165295648521926"
                
               }',
               CURLOPT_HTTPHEADER => array(
                "content-type: application/json",
                "apikey:476e18-f8b66b-26c69e-afdafb-13c4e5"
            )
              
            ));
            Log::info($curl['CURLOPT_POSTFIELDS']);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
			//$context = json_decode($respo->body());
           
                $type="mobile";
                $this->saveOtp($type, $request->mobile, $otp );
                
                    // $token_result = $checkUser->createToken('aagey');
                    // $token['access_token'] =  $token_result->accessToken;
                    // $token['token_type'] = "Bearer";
                    // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
             
                $data['mobile_otp'] = $otp;
                $data['user_details'] = $checkUser;
                  return response()->json([
                    "status" => true,
                        "message" => 'Otp sent successfully',
                        "Data" => $data,
                        // "token" => $token
                       
                    ],201);
            } else {
                    return response()->json([
                    "status" => false,
                        "message" => 'Failed to Send OTP',
                    ],201); 
            
        
        }
       
    }
 

    public function UserSigninForDigitalPull(Request $request){
        DB::enableQueryLog();
       $otp = $this->generateOtp();
	   $mobNumber =$request->value;
                if($request->mobile){
           $checkUser  = User::where('mobile',$request->mobile)->first();
           //$res = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number='.$request->mobile.'&message='. $otp .' is the OTP for your application');
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "http://api.pinnacle.in/index.php/sms/json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
               
                CURLOPT_POSTFIELDS => '{
              
                      "sender": "aageyM",
                      "message": [
                             {
                                   "number": "' . $mobNumber . '",
                                  "text": "AAGEY.COM ' .  $otp. ' is the OTP for your application"
                             }
                       ],
                      "messagetype":"TXT",
                      "dltentityid":"1701161718380850717",
                      "dlttempid":"1007165295648521926"
                
               }',
               CURLOPT_HTTPHEADER => array(
                "content-type: application/json",
                "apikey:476e18-f8b66b-26c69e-afdafb-13c4e5"
            )
              
            ));
            Log::info($curl['CURLOPT_POSTFIELDS']);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);

		   
               $type="mobile";
               $this->saveOtp($type, $request->mobile, $otp );
               $data['mobile_otp'] = $otp;
               $data['user_details'] = $checkUser;
                 return response()->json([
                   "status" => true,
                       "message" => 'Otp sent successfully',
                       "Data" => $data,
                       // "token" => $token
                      
                   ],201);
           } else {
                   return response()->json([
                   "status" => false,
                       "message" => 'Failed to Send OTP',
                   ],201); 
          
       }
      
   }
    public function signin(Request $request)
    {
        $checkUser = User::where('email', $request->email)
            ->where('pan', $request->pan)
            ->get();
            //Session::put('checkUser', $checkUser);  // just checking session 

        if (!$checkUser->isEmpty()) {
            $updateusers = User::where('email', $request->email)
                ->where('pan', '=', $request->pan)
                ->update(['enable' => 1]);

            return response()->json([
                "status" => true,
                "message" => 'signin successfull',
                "data" => $checkUser

            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Failed',
        ], 201);
    }
    public function getUserdetailsbyPan(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $user = User::select('*')
            ->where('pan', $request->pan)->get();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($user) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $user
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }
    /*public function sendEmail($mail, $otp)
    {
        $name = getenv('ADMIN_NAME');
        $htmlContent = "<p>Your OTP is <b>".$otp."</b></p>";
        $textContent = "<p>Your OTP is <b>".$otp."</b></p>";
        $from = new From(getenv('ADMIN_EMAIL'), getenv('ADMIN_NAME'));
        $subject = "OTP Verification";
        $recipient = new To(getenv('ADMIN_EMAIL'), getenv('ADMIN_NAME'));

        $email = new Mail();
        $email->setFrom($from);
        $email->setSubject($subject);
        $email->addto($mail);
        $email->addContent("text/plain", $textContent);
        $email->addContent("text/html", $htmlContent);

        $sendgrid = new \SendGrid(getenv('SENDGRID_API_KEY'));
        try {
            $respo = $sendgrid->send($email);
            $context = json_decode($respo->body());
            return $respo->statusCode();
            /* if ($respo->statusCode() == 202) {
               // echo "Metric email has been sent";
               return $respo;
            } else {
                return $respo;
                //echo "Failed to send metric email";
            } */
    //} //catch (\Exception $e) {
    //  echo "Failed";
    //}
    //}*/



    /*public function sendEmail($to_mail, $otp, $name=null,$emailtype=null)
    {
        //Log::info($to_mail);
      

        $data = [
            'otp' => $otp,
            'name' => $name,
            'subject' => "OTP Verification",
            "type"=>$emailtype
        ];

        Mail::to($to_mail)->send(new SendGridEmail($data));
        if(Mail::failures() != 0) {
            return response()->json([
                "message" => 'Mail sent successfully',
                "status" => true
            ], 202);
        }

        else {
            return response()->json([
                "message" => 'Mail not sent',
                "status" => false
            ], 500);
        }
    }*/

    public function sendEmail($to_mail, $otp, $name = null, $emailtype = null)
    {
		
        // Log::info($to_mail);

        // $SendEmailFlag = false;
        //get flag from envernemt

        //$SendEmailFlag  = getenv('SENDEMAILFLAG');
        // Log::info($SendEmailFlag);

        // if($SendEmailFlag=='true'){
        //   Log::info($SendEmailFlag);
        $data = [
            'otp' => $otp,
            'name' => $name,
            'subject' => "OTP Verification",
            "type" => $emailtype
        ];

        Mail::to($to_mail)->send(new SendGridEmail($data));
        if (Mail::failures() != 0) {
            return response()->json([
                "message" => 'Mail sent successfully',
                "status" => true
            ], 202);
        } else {
            return response()->json([
                "message" => 'Mail not sent',
                "status" => false
            ], 500);
        }

        /* }
        else{
            Log::info("There is a Sendgrid Issue..!");
                return response()->json([
                    "message" => 'There is a Sendgrid Issue..!',
                    "status" => true
                ], 202);
        }*/
    }

    function deleteFromUserTable(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        DB::delete("delete from users where id = " . $request->id);
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "delete"

        ]);
        return response()->json([
            "message" => 'Data deleted successfully',
            "status" => true
        ], 201);
    }

    function getOtpdetails(Request $requset)
    {
        $data = DB::table('otps')->where('value', $requset->value)->first();
        if (!empty($data)) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $data
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'No records found'
            ], 201);
        }
    }

    public function getUserdetailsbyid(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $user = User::select('id', 'name', 'pan', 'email', 'mobile')
            ->where('id', $request->id)->first();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (!empty($user)) {
            return response()->json([
                "status" => true,
                "data" => $user
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function getUsersByRoleid(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $users = User::select('id', 'email', 'mobile', 'pan')->where('role_id', '=', $request->role_id)->get();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($users) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $users
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function getUsersByRole(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $user = User::select('role_id')
            ->where('id', $request->id)->first();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (!empty($user)) {
            return response()->json([
                "status" => true,
                "data" => $user
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function AdminSavingUser(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $users = User::firstOrNew(['id' => $request->users_id]);
        $users->name = $request->get('name');
        $users->email = $request->get('email');
        $users->mobile = $request->get('mobile');
        $users->pan = $request->get('pan');
        $users->password = $request->get('password');
        $users->country_code = $request->get('country_code');
        $users->role_id = $request->get('role_id');
        $users->enable = $request->get('enable');
        $users->is_active = 1;
        //$timestamp = now();
        if (User::where('id', $request->users_id)->count() > 0) {
            $users->modified_on = now();
            $users->modified_by = 1;
        } else {
            $users->created_by = 1;
            $users->created_on = now();
        }
        $users->save();
        $data['user'] = $users;
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if ($users) {
            return response()->json([
                "status" => true,
                "message" => 'Successfully inserted',
                "Data" => $data
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }
    }

    public function deleteUser(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $deleteUser = User::find($request->id);
        $deleteUser->is_active = 0;
        $deleteUser->save();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "delete"

        ]);
        $updateId = $deleteUser->id;
        if ($updateId) {
            return response()->json([
                "message" => 'Data deleted successfully',
                "status" => true
            ], 201);
        } else {
            return response()->json([
                "message" => 'No record found on this id',
                "status" => false
            ], 201);
        }
    }

    //session history login time store
    public function saveLoginTime(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $user_id = $request->user_id;
        //Log::info($user_id);
        $otp = $request->otp;
        //$session_start_time=$request->session_start_time;
        $SessionStore = new SessionStore();
        $SessionStore->user_id = $user_id;
        $SessionStore->otp = $otp;
        $SessionStore->session_start_time = date('Y-m-d H:i:s');
        $SessionStore->is_active = 1;
        $last_access_date_time = DB::table('session_store')->select('session_start_time')
            ->where('user_id', '=', $request->user_id)
            ->orderBy('session_start_time', 'DESC')->limit(1)->get();
            //dd(session()->all());
        $last_access = [];
        foreach ($last_access_date_time as $item) {
            $last_access[] = $item->session_start_time;
        }
        if (!empty($last_access)) {
            $SessionStore->last_access_date_time =  $last_access[0];
        }
        $SessionStore->login_IP_address = $request->getClientIp();
        $SessionStore->save();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        //  $this->callLogFileStore($request->user_id, "Session Store", "select", $query1[0]['query'], "session_store","Insert");
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "Session Store",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "session_store",
            'user_action' => "Insert"

        ]);
        return response()->json([
            "status" => true,
            "message" => 'LoggedIn Successfully',
            "Data" => $last_access,
        ], 201);
    }

    public function updateLogoutTime(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        //User::where('user_id', $userId)
        $otp = $request->otp;
        $session_end_time = date('Y-m-d H:i:s');
        DB::table('session_store')
            ->where('otp', $otp)  // find your user by their email
            ->limit(1)  // optional - to ensure only one record is updated.
            ->update(array('session_end_time' => $session_end_time));
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
  
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "Session Store",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "session_store",
            'user_action' => "update"

        ]);
        return response()->json([
            "status" => true,
            "message" => 'LoggedOut Successfully',
            //"Data" => $data,
        ], 201);
    }


    public function saveUserwithRole(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        //$checkPan       = User::where('pan',$request->pan)->get();
        $checkEmail     = User::where('email', $request->email)->get();
        $checkMobile    = User::where('mobile', $request->mobile)->get();

        if ($request->users_id == null) {

            if (count($checkEmail) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Email Already exists',
                ], 201);
            }
            if (count($checkMobile) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Mobile Already exists',
                ], 201);
            }
        }


        $users = User::firstOrNew(['id' => $request->users_id]);
        $users->name = $request->get('name');
        $users->email = $request->get('email');
        $users->mobile = $request->get('mobile');
        $users->pan = $request->get('pan');
        $users->password = $request->get('password');
        $users->country_code = $request->get('country_code');
        $users->role_id = $request->get('role_id');
        $users->referal_code = $request->get('referal_code');
        $users->enable = 0;
        $users->is_active = 1;
        $timestamp = now();


        if (!empty($request->users_id)) {
            $users->modified_by = 1;
            $users->modified_on = now();
        } else {
            $users->created_by = 1;
            $users->created_on = now();
        }

        $users->save();


        $data['user'] = $users;

        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "Insert"

        ]);

        if ($users) {
            if ($request->users_id) {
                return response()->json([
                    "status" => true,
                    "message" => 'Successfully inserted',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => true,
                    "message" => 'Successfully updated',
                    "Data" => $data
                ], 201);
            }
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }
    }

    //medha

     public function AdminSignin(Request $request)
    {
		 
        Cookie::queue(Cookie::make('name', json_decode("Hello Cookie"), 10080));
		$value = Cookie::get('name');
        //dd(Cookie::get('role_id'));
		 //dd($value);
		   
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if (!empty($request->email)) {
            $checkUser  = User::where('email', 'like', '%' . $request->email . '%')->first();
            $checkBanker = BankerProfile::select('loan_type_id', 'city', 'bank_id', 'id as bankId')->where(['email' => $request->email, 'role_id' => 5])->first();
            //$checkBanker = DB::table('banker_profile')->select('id','loan_type_id','city','bank_id')
            // ->where(['email' => $request->email, 'role_id' => 5])->get();
            //Log::info($checkUser->toArray());
            //Log::info($checkBanker->toArray());
            if (!empty($checkUser)) {
                if ($checkUser->role_id != 2) {
                    if (!empty($checkUser)) {
                        $otp_email = rand(100000, 999999);
                        $data['email_otp'] = $otp_email;
                        //$data['user_details'] = $checkUser;

                        $bankerdata = (!empty($checkBanker)) ? $checkBanker->toArray() : [];
                        $data['user_details'] = array_merge($checkUser->toArray(), $bankerdata);
                        $otps3 = new Otp();
                        $otps3->type = 'email';
                        $otps3->value = $request->get('email');
                        $otps3->created_by = 0;
                        $otps3->created_on = now();

                        //$respo = $this->sendEmail($otps3->value, $otp_email);
                        $respo = $this->sendEmail($otps3->value, $otp_email, null, "signin");

                        if ($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202) {
                            Log::info($otps3->value);
                            $otps3->otp = $otp_email;
                            $otps3->validate_otp = false;
                            $otps3->form_id = 2;
                            $otps3->save();
                            $query1 = DB::getQueryLog();
                            Log::info($query1[0]['query']);

                            //$this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Otp Sent");
                            Http::post($baseUrl.'server.php/api/callLogFileStore1', [
                                'user_id' => $request->user_id,
                                'form_type' => "User",
                                'query_type' => "select",
                                'query' => $query1[0]['query'],
                                'table_name' => "users",
                                'user_action' => "Otp Sent"

                            ]);
                            return response()->json([
                                "status" => true,
                                "message" => 'Otp sent successfully',
                                "Data" => $data
                            ], 201);
                        } else {
                            return response()->json([
                                "status" => false,
                                "message" => 'Failed to Send OTP',
                            ], 201);
                        }
                    } else {
                        return response()->json([
                            "status" => false,
                            "message" => 'User not found',
                        ], 200);
                    }
                } else {
                    return response()->json([
                        "status" => false,
                        "message" => 'Invalid User',
                    ], 200);
                }
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Invalid email',
                ], 200);
            }
        } else if (!empty($request->mobile)) {
            $check  = User::where('mobile', $request->mobile)->first();
            Log::info($check);
            if (!empty($check)) {
                if ($check->role_id != 2) {
                    if (!empty($check)) {
                        $otp_mobile = rand(100000, 999999);
                        $mobNumber =$request->mobile;
                        $data['mobile_otp'] = $otp_mobile;
                        $data['user_details'] = $check;

                        $otps3 = new Otp();
                        $otps3->type = 'mobile';
                        $otps3->value = $request->get('mobile');
                        $otps3->otp = $otp_mobile;
                        $otps3->validate_otp = false;
                        $otps3->form_id = 2;
                        $otps3->save();

                       // $response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->mobile . '&message=' . $otp_mobile . 'is the OTP for your application');
                      
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "http://api.pinnacle.in/index.php/sms/json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
               
                CURLOPT_POSTFIELDS => '{
              
                      "sender": "aageyM",
                      "message": [
                             {
								 
                                   "number": "' . $mobNumber . '",
                                  "text": "AAGEY.COM ' .  $otp_mobile. ' is the OTP for your application"
                             }
                       ],
                      "messagetype":"TXT",
                      "dltentityid":"1701161718380850717",
                      "dlttempid":"1007165295648521926"
                
               }',
               CURLOPT_HTTPHEADER => array(
                "content-type: application/json",
                "apikey:476e18-f8b66b-26c69e-afdafb-13c4e5"
            )
              
            ));
            Log::info($curl['CURLOPT_POSTFIELDS']);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
                        return response()->json([
                            "status" => true,
                            "message" => 'otp sent successfull',
                            "Data" => $data

                        ], 200);
                    } else {
                        return response()->json([
                            "status" => false,
                            "message" => 'User not found',
                        ], 200);
                    }
                } else {
                    return response()->json([
                        "status" => false,
                        "message" => 'Invalid User',
                    ], 200);
                }
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Invalid mobile',
                ], 200);
            }
        }
    }
    public function getAllCpa(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if ($request->has('enable')) {
            $getAllUsers =  User::where('role_id', '=', 1)->where('enable', '=', $request->enable)->get();
        } else {
            $getAllUsers =  User::where('role_id', '=', 1)->get();
        }
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        // $this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Fetch");
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($getAllUsers) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $getAllUsers
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }
    }

    public function getAllSa(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if ($request->has('enable')) {
            $getAllUsers =  User::where('role_id', '=', 3)->where('enable', '=', $request->enable)->get();
        } else {
            $getAllUsers =  User::where('role_id', '=', 3)->get();
        }
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($getAllUsers) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $getAllUsers
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }
    }


    public function getAllDsa(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if ($request->has('enable')) {
            $getAllUsers =  User::where('role_id', '=', 6)->where('enable', '=', $request->enable)->get();
        } else {
            $getAllUsers =  User::where('role_id', '=', 6)->get();
        }
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($getAllUsers) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $getAllUsers
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }
    }
    //ganashree11ju21

    public function getLastLoginLogoutByUserId(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $session = SessionStore::select('user_id', 'last_access_date_time')->where('user_id', $request->user_id)
            ->orderBy('id', 'DESC')->limit(1)->get();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        //Session::put('session', $session);  // just checking 
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($session) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $session
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    //ganashree
    public function saveBankerProfile(Request $request)
    {
        $baseUrl = $this->servicurls->identityurl;
        $baseUrldelta = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $response1 = Http::post($baseUrl.'server.php/api/saveUserwithRole', [
		  'user_id' => $request->user_id,
            'name' => $request->name,
            'email' => $request->email,
            'mobile' => $request->mobile,
            'role_id' => 5,
            'country_code' => $request->country_code
        ]);
        //Log::info($response1);
        $jsonRes = json_decode($response1);
        
        $userId = $jsonRes->Data->user->user_id;
        $name = $jsonRes->Data->user->name;
        $email = $jsonRes->Data->user->email;
        $mobile = $jsonRes->Data->user->mobile;

        $banker = BankerProfile::firstOrNew(['id' => $request->banker_Id]);
        $banker->name = $name;
        $banker->email = $email;
        $banker->mobile = $mobile;
        $banker->user_id = $userId;
        $banker->loan_type_id = $request->get('loan_type_id');
        $banker->city = $request->get('city');
        $banker->bank_id = $request->get('bank_id');
        $banker->role_id = 5;
        $banker->is_active = 1;
        $banker->enable = 1;
        if (!empty($request->banker_Id)) {
            $banker->modified_on = now();
            $banker->modified_by = 1;
        } else {
            $banker->created_by = 1;
            $banker->created_on = now();
        }
        $banker->save();
        $data['bankerprofile'] = $banker;
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        $this->callLogFileStore($request->user_id, "Banker Profile", "select", $query1[0]['query'], "banker_profile","Insert");
        Http::post($baseUrldelta.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "BankerProfile",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "banker_profile",
            'user_action' => "Insert"

        ]);
        if ($banker) {
            return response()->json([
                "status" => true,
                "message" => 'Successfully inserted',
                "Data" => $data
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }
    }

    public function getBankerdetails(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $banker = BankerProfile::select('id', 'user_id', 'email', 'mobile')
            ->where('loan_type_id', $request->loan_type_id)
            ->where('city', $request->city)
            ->where('bank_id', $request->bank_id)
            ->first();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "BankerProfile",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "banker_profile",
            'user_action' => "fetch"

        ]);
        if (!empty($banker)) {
            return response()->json([
                "status" => true,
                "data" => $banker
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function getAllDocumentTeam(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        if ($request->has('enable')) {
            $getAllUsers =  User::where('role_id', '=', 7)->where('enable', '=', $request->enable)->get();
        } else {
            $getAllUsers =  User::where('role_id', '=', 7)->get();
        }
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        //$this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Fetch");
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "User",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "users",
            'user_action' => "fetch"

        ]);
        if (count($getAllUsers) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $getAllUsers
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }
    }

    public function checkemail(Request $request)
    {
        $checkEmail = User::where('email', $request->email)->get();
        if (count($checkEmail) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Email Already exists',
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Email not exists',
            ], 201);
        }
    }

    public function checkmobile(Request $request)
    {
        $checkMobile = User::where('mobile', $request->mobile)->get();
        if (count($checkMobile) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Mobile Already exists',
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Mobile not exists',
            ], 201);
        }
    }



    //ganashree
    public function getAllGeneralsettingvalue(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $parameter = GeneralSettings::select('*')->where('enable', $request->enable)->orderBy('id')->get();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        // $this->callLogFileStore($request->user_id, "GeneralSettings", "select", $query1[0]['query'], "general_settings","Fetch");
        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "General Setting",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "general_settings",
            'user_action' => "fetch"

        ]);
        if (count($parameter) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $parameter
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function getParameterValueByName(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $parameter = GeneralSettings::select('*')->where('parameter_name', $request->parameter_name)->where('is_active', '=', true)->get();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "General Setting",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "general_settings",
            'user_action' => "fetch"

        ]);
        if (count($parameter) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $parameter
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }


    public function generalSettingAddOrEdit(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $generalSetting = GeneralSettings::firstOrNew(['id' => $request->general_setting_id]);
        $generalSetting->parameter_name                 =   $request->parameter_name;
        $generalSetting->parameter_value                =   $request->parameter_value;
        $generalSetting->enable                         =   true;
        $generalSetting->is_active                      =   true;
        $generalSetting->modified_on = now();
        $generalSetting->modified_by = 1;
        $generalSetting->created_by = 1;
        $generalSetting->created_on = now();
        $generalSetting->save();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "General Setting",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "general_settings",
            'user_action' => "Insert"

        ]);
        $data = $generalSetting->getAttributes();
        $insert_id = $generalSetting->id;
        $redis = $this->setReddis($data, 'generalSetting');
        if (!$redis) {
            Log::error('Failed to save in redis general_setting_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['general_setting_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $data
        ], 201);
    }


    public function getAllGeneralSetting(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "General Setting",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "general_settings",
            'user_action' => "fetch"

        ]);
        if ($request->has('enable')) {
            $data = GeneralSettings::where('is_active', '=', 1)->where('enable', '=', $request->enable)->get();
        } else {
            $data = GeneralSettings::where('is_active', '=', 1)->get();
        }
        if (!$data->isEmpty()) {
            return response()->json(
                $data,
                201
            );
        }
        return response()->json([
            "message" => 'Data not available',
        ], 201);
    }
    public function deleteGeneralSetting(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;
        DB::enableQueryLog();
        $deleteGeneralSetting = GeneralSettings::find($request->general_setting_id);
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);

        Http::post($baseUrl.'server.php/api/callLogFileStore1', [
            'user_id' => $request->user_id,
            'form_type' => "General Setting",
            'query_type' => "select",
            'query' => $query1[0]['query'],
            'table_name' => "general_settings",
            'user_action' => "delete"

        ]);
        if (!empty($deleteGeneralSetting)) {
            $deleteGeneralSetting->is_active = 0;
            $deleteGeneralSetting->save();
            return response()->json([
                "message" => 'Deleted successfully',
            ], 200);
        } else {
            return response()->json([
                "message" => 'Data not available',
            ], 201);
        }
    }




    public function getUserIdByPan(Request $request)
    {
        DB::enableQueryLog();
        $query = "select id from users where pan = '" . $request->pan . "'";

        $data =  DB::select($query);
        Log::info($data);
        if (count($data) > 0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        } else {
            return response()->json([
                "message" => 'Data not available',
            ], 201);
        }
    }

  //Pradeep

    public function otpFlagSaveUpdate(Request $request)
    {

        $checkOtp = GeneralSettings::firstOrNew(['parameter_name' => $request->parameter_name]);
        Log::info($checkOtp);
        $checkOtp->parameter_value = $request->parameter_value;
        $checkOtp->save();
        Log::info($checkOtp);
        if ($checkOtp) {
            return response()->json([
                "status" => true,
                "message" => 'Successfully inserted',
                "Data" => $checkOtp
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }
    }


// Pradeep
    public function UserSigninV2(Request $request)
    {
        $baseUrl = $this->servicurls->deltaurl;

        DB::enableQueryLog();
        $type =  $request->type;
        $otpEmailFlag = DB::select("select parameter_value from general_settings where  parameter_name = '" . 'email_otp_flag' . "' ");
        $otp = $this->generateOtp();
        Log::info($otpEmailFlag[0]->parameter_value);
        $Emailflag = $otpEmailFlag[0]->parameter_value; 
        $mobile_otp_flag =  DB::select("select parameter_value from general_settings where  parameter_name = '" . 'mobile_otp_flag' . "' ");
        $mobileFlag =  $mobile_otp_flag[0]->parameter_value;
        if (!empty($request->email)) {
            if ($Emailflag == 'yes') {
                $otpEmailFlag  = User::where('pan', $request->pan)->where('email', $request->email)->first();
                $name = 'user';
                
                $respo = $this->sendEmail($request->email, $otp, $name,"signin");
               
                //Log::info(print_r($respo,true));
               if ($respo->getStatusCode() == 202 || $respo->getStatusCode() == 202) {
                $type = "email";
                $this->saveOtp($type, $request->email, $otp);
                // $token_result = $checkUser->createToken('aagey');
                // $token['access_token'] =  $token_result->accessToken;
                // $token['token_type'] = "Bearer";
                // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
                $data['email_otp'] = $otp;
                $data['user_details'] = $Emailflag;
                $query1 = DB::getQueryLog();
                Log::info($query1[0]['query']);
                
                    //$this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Signin");
                    Http::post($baseUrl.'server.php/api/callLogFileStore1', [
                        'user_id' => $request->user_id,
                        'form_type' => "User",
                        'query_type' => "select",
                        'query' => $query1[0]['query'],
                        'table_name' => "users",
                        'user_action' => "Signin"

                    ]);
                    return response()->json([
                        "status" => true,
                        "message" => ' Email Otp sent successfully',
                        "Data" => $data,
                        // "token" => $token
                    ], 201);
                }
                 } else if ($Emailflag == 'no') {
                        $otpEmailFlag  = User::where('pan', $request->pan)->where('email', $request->email)->first();
                        $name = 'user';
                        
                        //$respo = $this->sendEmail($request->email, $otp, $name,"signin");
                       
                        //Log::info(print_r($respo,true));
                       //if ($respo->getStatusCode() == 202 || $respo->getStatusCode() == 202) {
                         
                        $type = "email";
                        //$this->saveOtp($type, $request->email, $otp);
                        // $token_result = $checkUser->createToken('aagey');
                        // $token['access_token'] =  $token_result->accessToken;
                        // $token['token_type'] = "Bearer";
                        // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
                       // $data['email_otp'] = $otp;
                        $data['user_details'] = $otpEmailFlag;
                        $query1 = DB::getQueryLog();
                        Log::info($query1[0]['query']);
                        
                            //$this->callLogFileStore($request->user_id, "User", "select", $query1[0]['query'], "users","Signin");
                            Http::post($baseUrl,'server.php/api/callLogFileStore1', [
                                'user_id' => $request->user_id,
                                'form_type' => "User",
                                'query_type' => "select",
                                'query' => $query1[0]['query'],
                                'table_name' => "users",
                                'user_action' => "Signin"
        
                            ]);
                        
                            return response()->json([
                                "status" => false,
                                    "message" => ' Email Otp Not sending',
                                    "Data" => $data,
                                    // "token" => $token
                                   
                                ],201);       
                }
           
        } elseif (!empty($request->mobile)) {

            if ($mobileFlag == 'yes') {
                $mobile_otp_flag = User::where('pan', $request->pan)->where('mobile', $request->mobile)->first();
                $mobile_otp_flag= Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->mobile . '&message=' . $otp . ' is the OTP for your application');
                //$mobile_otp_flag= true;
                $context = json_decode( $mobile_otp_flag->body());
                    $type = "mobile";
                    $this->saveOtp($type, $request->mobile, $otp);

                    // $token_result = $checkUser->createToken('aagey');
                    // $token['access_token'] =  $token_result->accessToken;
                    // $token['token_type'] = "Bearer";
                    // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
    
                    $data['mobile_otp'] = $otp;
                    $data['user_details'] = $mobileFlag;
                    return response()->json([
                        "status" => true,
                        "message" => 'Mobile Otp sent successfully',
                        "Data" => $mobileFlag,
                        // "token" => $token
                                                               
                    ], 201);
                
                 } elseif (!empty($request->mobile)) {
                    if ($mobileFlag == 'no') {

                    $mobile_otp_flag = User::where('pan', $request->pan)->where('mobile', $request->mobile)->first();
                    $mobile_otp_flag= Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->mobile . '&message=' . $otp . ' is the OTP for your application');
                    //$mobile_otp_flag=false;
                    //$context = json_decode( $mobile_otp_flag->body());
                
                    $type = "mobile";
                   // $this->saveOtp($type, $request->mobile, $otp);
    
                    // $token_result = $checkUser->createToken('aagey');
                    // $token['access_token'] =  $token_result->accessToken;
                    // $token['token_type'] = "Bearer";
                    // $token['expires_at'] = Carbon::parse($token_result->token->expires_at)->toDateTimeString();
    
                    $data['mobile_otp'] = $otp;
                    $data['user_details'] = $mobileFlag;

                    return response()->json([
                        "status" => false,
                            "message" => ' Mobile Otp Not sending',
                            "Data" => $data,
                            // "token" => $token
                           
                        ],201);
                }
            
            }
        }
    }
    
}

    
