<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class SendGridEmail extends Mailable
{
    use Queueable, SerializesModels;

    /**
     * Email object.
     * 
     * @var data_email
     */
    public $data_email;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($data_email)
    {
        $this->data_email = $data_email;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        //$from = getenv('MAIL_FROM_ADDRESS');
        //$name = getenv('ADMIN_NAME');
		$from = "v.care@aagey.com";
		$name = "v.care@aagey.com";
        $type=$this->data_email['type'];
		//dd($name, $type, $from);
        if($type == "signin"){
             return $this->view('send_email.signinmail')
                    ->from($from, $name)
                    ->replyTo(getenv('MAIL_REPLY_TO'), $name)
                    ->subject($this->data_email['subject'])
                    ->with([ 
                        'otp' => $this->data_email['otp'],
                        "user" => $this->data_email['name'],
                        "siteaddress" => getenv('SITE_ADDRESS'),
                        "type"=>$this->data_email['type']
                        ]);
        } elseif ($type == "notification"){
        return $this->view('send_email.Notification')
        ->from($from, $name)
        ->replyTo(getenv('MAIL_REPLY_TO'), $name)
        ->subject($this->data_email['subject'])
        ->with([ 
            "user" => $this->data_email['name'],
            "mail_body" =>$this->data_email['message'],
            "siteaddress" => getenv('SITE_ADDRESS'),
            "type"=>$this->data_email['type']
            ]);


        } else{
                return $this->view('send_email.mail')
                ->from($from, $name)
                ->replyTo(getenv('MAIL_REPLY_TO'), $name)
                ->subject($this->data_email['subject'])
                ->with([ 
                    'otp' => $this->data_email['otp'],
                    "user" => !empty($this->data_email['name']) ? $this->data_email['name'] : 'user',
                    "siteaddress" => getenv('SITE_ADDRESS'),
                    "type"=>$this->data_email['type']
                    ]);
                }
       
           }
}