<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Str;
use App\Customer;
use App\Comm_phone_email;
use Illuminate\Support\Facades\Redis;
use Jenssegers\Mongodb\Eloquent\Model as Eloquent;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;

use App\Otp;
use App\FolderFileMapping;

use SendGrid\Mail\From;
use SendGrid\Mail\Mail;
use SendGrid\Mail\To;
use App\Audit_trail;
use App\AssetProperty;
use App\AssetType;
use App\PropertyAssetMapping;
use App\PropertyStatus;
use App\ConstructionPropertyPurposeMapping;
use App\TypeOfConstruction;
use App\Display_parameter_header_finance;
use App\IndustryMapping;

use Illuminate\Support\Facades\Http;

class AuthenicationController extends Controller
{

    public $mode;
    public $serverUri;

    public function __construct()
    {
		$this->mode = env('MODE');
        if($this->mode == 'dev'){
            $this->serverUri = env('STAGING_URI');
        } else {
            $this->serverUri = env('PRODUCTION_URI');
        }
    }

    public function customerRegistration(Request $request)
    {
		 DB::enableQueryLog();

        $parent_type = "Business";
        $master_type = "parent_type";
        $data1 = DB::table('master_table')
            ->join('main_master', 'main_master.master_table_id', '=', 'master_table.master_table_id')
            ->where('main_master.name', '=', $master_type)->where('main_master.is_active', '=', 1)->where('master_table.name', '=', $parent_type)
            ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
            ->get();

        $checkPan       = Customer::where('pan', $request->pan)->get();
        $checkEmail     = Comm_phone_email::where('contact_value', $request->email)->where('contact_type', 112)->where('parent_type_id', $data1[0]->id)->get();
        $checkMobile    = Comm_phone_email::where('contact_value', $request->mobile)->where('contact_type', 113)->where('parent_type_id', $data1[0]->id)->get();
		$data['email'] = $request->email;
        $data['mobile'] = $request->mobile;
        /* $checkPan       = Customer::where('mobile', $request->mobile)->get();
        $checkEmail     = Customer::where('mobile', $request->mobile)->get();
        $checkMobile    = Customer::where('mobile', $request->mobile)->get(); */
        if (count($checkPan) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Pan Already exists',
				"data" => $data
            ], 201);
        }
        
        $insert = Customer::firstOrNew(['id' => $request->customer_id]);
        $folder = new FolderFileMapping();
        $insert->business_name = $request->first_name;
        $insert->pin_id = $request->pin_id;
        $insert->pan = $request->pan;
		$insert->primary_user_id = $request->user_id;
		$insert->date_of_incorporation = $request->date_of_incorporation;

        $insert->enable = 1;
        $insert->is_active = 1;
        $insert->created_by = $request->user_id;
        $insert->created_on = now();
        $insert->modified_by = $request->user_id;
        $insert->modified_on = now();
        $insert->token_id = Str::random(32);
        $insert->save();
        $insert_id = $insert->id;

        
        
		
            //DB::enableQueryLog();
			$query1 = DB::getQueryLog();
			$this->callLogFileStore($request->user_id, "Customer", "Select", $query1[0]['query'], "customer","Insert");

           

        $comm_phone_email = new Comm_phone_email();
        $contactType = $this->getMasterTableIdUsingMasterTypeAndName('Email','contact_type');
        $comm_phone_email->contact_type = $contactType;
        $comm_phone_email->contact_value = $request->email;
        $comm_phone_email->parent_type_id = $data1[0]->id;
        $comm_phone_email->parent_id = $insert_id;
        $comm_phone_email->dnd_flag = true;
        $comm_phone_email->enable = 1;
        $comm_phone_email->is_active = 1;
        $comm_phone_email->created_by = $request->user_id;
        $comm_phone_email->created_on = now();
        $comm_phone_email->modified_by = $request->user_id;
        $comm_phone_email->modified_on = now();
        $comm_phone_email->save();

        $comm_phone_email = new Comm_phone_email();
        $contactTypeMob = $this->getMasterTableIdUsingMasterTypeAndName('Mobile','contact_type');
        $comm_phone_email->contact_type = $contactTypeMob;
        $comm_phone_email->contact_value = $request->mobile;
        $comm_phone_email->parent_type_id = $data1[0]->id;
        $comm_phone_email->parent_id = $insert_id;
        $comm_phone_email->dnd_flag = true;
        $comm_phone_email->enable = 1;
        $comm_phone_email->is_active = 1;
        $comm_phone_email->created_by = $request->user_id;
        $comm_phone_email->created_on = now();
        $comm_phone_email->modified_by = $request->user_id;
        $comm_phone_email->modified_on = now();
        $comm_phone_email->save();

				$folder->bpan = $insert->pan;
        $folder->folder_no =  $request->pan.$insert_id;
        $folder->enable = 1;
        $folder->is_active = 1;
        $timestamp = now();
        if (!empty($request->insert_id)) {
            $folder->modified_by = $request->user_id;
            $folder->modified_on = now();
        } else {
            $folder->created_by = $request->user_id;
            $folder->created_on = now();
            $folder->modified_by = $request->user_id;
            $folder->modified_on = now();
        }
        $folder->save();
		
			$otp_mobile = rand(100000, 999999);
        $otp_email  = rand(100000, 999999);
        $data['token_id'] = $insert->token_id;
        $data['mobile_otp'] = $otp_mobile;
        $data['email_otp'] = $otp_email;


        $message = "Registration for ". $request->first_name ." at platform.aagey.com has been completed. You can login and create your loan application. Thank you for registering with Aagey.com";
        //Notification to SCA
        $response = Http::post($this->serverUri . 'Identitymanagement/server.php/api/getUsersByRoleid', [
            'role_id' => 3
        ]);
        $responseBody = $response;
        $dataArray = [];

        for ($i = 0; $i < count($responseBody['data']); $i++) {
            $mobile = $responseBody['data'][$i]['mobile'];
            $email = $responseBody['data'][$i]['email'];
            $this->getnotifications('email', $email, $message, $request->user_id,'Registration Successfull');

            $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Registration Successfull');
        }


        //Notification to cient
        $this->getnotifications('email', $email, $message, $request->user_id,'Registration Successfull');

        $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Registration Successfull'); 

        //Notification to Admin

        $response = Http::post($this->serverUri . 'Identitymanagement/server.php/api/getUsersByRoleid', [
            'role_id' => 4
        ]);
        $responseBody = $response;
        $dataArray = [];

        for ($i = 0; $i < count($responseBody['data']); $i++) {
            $mobile = $responseBody['data'][$i]['mobile'];
            $email = $responseBody['data'][$i]['email'];
            $this->getnotifications('email', $email, $message, $request->user_id,'Registration Successfull');

            $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Registration Successfull');
        }
        if ($insert) {
            return response()->json([
				"status" => true,
                "message" => 'Successfuly inserted',
                "Data" => $data
            ], 201);
        } else {
            return response()->json([
				"status" => false,
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
    }
	
	  public function customerRegistrationByCpa(Request $request){
		   DB::enableQueryLog();

		  Log::info($request);

		$checkPan = Customer::where('pan', $request->pan)->get();
		if (count($checkPan) > 0) {
		return response()->json([
		"status" => false,
		"message" => 'Pan Already exists',
		], 201);
		}
		$response1 = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/saveUser',[
		'email'=> $request->useremail,
		'mobile'=> $request->usermobile,
		'pan' =>$request->pan,
		'country_code' => $request->country_code
		]);
		//Log::info($response1);


		$jsonRes = json_decode($response1->getBody());
       // Log::info(print_r($jsonRes, true));
        //Log::info(print_r($jsonRes->Data,true));
        if (empty($jsonRes->Data)) {
            return response()->json([
                "status" => false,
                "message" => 'User data Already exists',
                ], 201);
        } else {
            $userId = $jsonRes->Data->user->id;
            Log::info($userId);
        }
		///Log::info($jsonRes->Data->user->id);
		//$userId = $jsonRes->Data->user->id;

		// exit();
		Log::info("reached");
		$parent_type = "Business";
		$master_type = "parent_type";

		$data1 = DB::table('master_table')
		->join('main_master', 'main_master.master_table_id', '=', 'master_table.master_table_id')
		->where('main_master.name', '=', $master_type)->where('main_master.is_active', '=', 1)->where('master_table.name', '=', $parent_type)
		->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
		->get();

		$insert = Customer::firstOrNew(['id' => $request->customer_id]);
		Log::info($insert);

		$folder = new FolderFileMapping();
		$insert->business_name = $request->first_name;
		$insert->pin_id = $request->pin_id;
		$insert->pan = $request->pan;
		$insert->primary_user_id = $userId;
		$insert->date_of_incorporation = $request->date_of_incorporation;

		$insert->enable = 1;
		$insert->is_active = 1;
		$insert->created_by = $request->user_id;
		$insert->created_on = now();
		$insert->modified_by = $request->user_id;
		$insert->modified_on = now();
		$insert->token_id = Str::random(32);
		$insert->save();
		// Log::info($insert);
		$insert_id = $insert->id;
		
            //DB::enableQueryLog();
			$query1 = DB::getQueryLog();
			$this->callLogFileStore($request->user_id, "Customer", "Select", $query1[0]['query'], "customer","Insert");

		$comm_phone_email = new Comm_phone_email();
		$contactType = $this->getMasterTableIdUsingMasterTypeAndName('Email','contact_type');
		$comm_phone_email->contact_type = $contactType;
		$comm_phone_email->contact_value = $request->email;
		$comm_phone_email->parent_type_id = $data1[0]->id;
		$comm_phone_email->parent_id = $insert_id;
		$comm_phone_email->dnd_flag = true;
		$comm_phone_email->enable = 1;
		$comm_phone_email->is_active = 1;
		$comm_phone_email->created_by = $request->user_id;
		$comm_phone_email->created_on = now();
		$comm_phone_email->modified_by = $request->user_id;
		$comm_phone_email->modified_on = now();
		$comm_phone_email->save();

		$comm_phone_email = new Comm_phone_email();
		$contactTypeMob = $this->getMasterTableIdUsingMasterTypeAndName('Mobile','contact_type');
		$comm_phone_email->contact_type = $contactTypeMob;
		$comm_phone_email->contact_value = $request->mobile;
		$comm_phone_email->parent_type_id = $data1[0]->id;
		$comm_phone_email->parent_id = $insert_id;
		$comm_phone_email->dnd_flag = true;
		$comm_phone_email->enable = 1;
		$comm_phone_email->is_active = 1;
		$comm_phone_email->created_by = $request->user_id;
		$comm_phone_email->created_on = now();
		$comm_phone_email->modified_by = $request->user_id;
		$comm_phone_email->modified_on = now();
		$comm_phone_email->save();

		$folder->bpan = $insert->pan;
		$folder->folder_no = $request->pan.$insert_id;
		$folder->enable = 1;
		$folder->is_active = 1;
		$timestamp = now();
		if (!empty($request->insert_id)) {
		$folder->modified_by = $request->user_id;
		$folder->modified_on = now();
		} else {
		$folder->created_by = $request->user_id;
		$folder->created_on = now();
		$folder->modified_by = $request->user_id;
		$folder->modified_on = now();
		}
		$folder->save();
		$response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUsersByRoleid', [
                'role_id' => 3
            ]);
            $responseBody = $response;
            $dataArray = [];

            for ($i = 0; $i < count($responseBody['data']); $i++) {
                $mobile = $responseBody['data'][$i]['mobile'];
                $email = $responseBody['data'][$i]['email'];
                $this->getnotifications('email', $email, 'Documents Uploaded Successfully', $request->user_id);

                $this->getnotifications('mobile', $mobile, 'Documents Uploaded Successfully', $request->user_id);
            }
            

        $this->getnotifications('email',$request->email,'Registration Successfull',$request->user_id);

        $this->getnotifications('mobile',$request->mobile,'Registration Successfull',$request->user_id);
		$otp_mobile = rand(100000, 999999);
		$otp_email = rand(100000, 999999);
		$data['token_id'] = $insert->token_id;
		// $data['mobile_otp'] = $otp_mobile;
		//$data['email_otp'] = $otp_email;
		$data['user_id'] = $userId;
		$data['customer_data'] = $insert;
		$data['email'] = $request->email;
        $data['mobile'] = $request->mobile;
		if ($insert) {
		return response()->json([
		"status" => true,
		"message" => 'Successfuly inserted',
		"Data" => $data
		], 201);
		} else {
		return response()->json([
		"status" => false,
		"message" => 'Failed to save in pgsql',
		], 417);
		}
		}
        

     public function getCustomerbyuserid(Request $request){
            DB::enableQueryLog();
            $query = 'select customer.*,pin_codes.pincode as pincode
            from customer
            left join pin_codes on pin_codes.id  = customer.pin_id
            where customer.primary_user_id =' . $request->user_id; 
			
            $data = DB::select($query);
					 Log::info($data);

           
            $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Customer", "select", $query1[0]['query'], "customer","fetch");
    
            if (!empty($data)) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data" => $data
                ], 200);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'No records found'
                ], 201);
            }
        }

    public function signin(Request $request)
    {

        return $checkpan = Customer::where('pan', $request->pan)->Where('email', $request->email)->get();
        if (count($checkpan) > 0) {
            return "Hi";
        } else {

            return response()->json([
                "message" => 'User not found',
            ], 403);
        }
    }
    public function retrieveMobileOrEmail(Request $request)
    {
		 DB::enableQueryLog();
        $getMobileEmail = Customer::where('pan', $request->pan)->first();
		  $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Customer", "select", $query1[0]['query'], "customer","fetch");
    
        if ($getMobileEmail) {
            $data['emai']   = $getMobileEmail->email;
            $data['mobile'] = $getMobileEmail->mobile;
			
            return response()->json([
				"status" => true,
                "message" => 'Data fetched successfully',
                "Data" => $data
            ], 200);
        } else {
            return response()->json([
				"status" => false,
                "message" => 'Data not found',
            ], 403);
        }
    }
    public function sendOtp(Request $request)
    {
        $parent_type = "Business";
        $master_type = "parent_type";
        $data1 = DB::table('master_table')
            ->join('main_master', 'main_master.master_table_id', '=', 'master_table.master_table_id')
            ->where('main_master.name', '=', $master_type)->where('main_master.is_active', '=', 1)->where('master_table.name', '=', $parent_type)
            ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
            ->get();

        $checkEmail     = Comm_phone_email::where('contact_value', $request->value)->where('contact_type', 112)->where('parent_type_id', $data1[0]->id)->get();
        $checkMobile    = Comm_phone_email::where('contact_value', $request->value)->where('contact_type', 113)->where('parent_type_id', $data1[0]->id)->get();
        if (count($checkEmail) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Email Already exists',
            ], 201);
        }
        if (count($checkMobile) > 0) {
            return response()->json([
                "status" => false,
                "message" => 'Mobile Already exists',
            ], 201);
        }

        //Call rest api to check credential in otp table
        $response1 = Http::post($this->serverUri . 'Identitymanagement/server.php/api/getOtpdetails',[
            'value'=> $request->value
        ]);
        //Log::info($response1);
        $jsonRes = json_decode($response1);
        Log::info($jsonRes->status);
        
        if($jsonRes->status == 1) {
            return response()->json([
                "status" => 101,
                "message" => 'already validated'
            ], 201);    
        } else {
        $otps = Otp::firstOrNew(['id' => $request->otp_id]);
        $otps->type = $request->get('type');
        $otps->value = $request->get('value');
        $otps->form_id = $request->get('form_id');
        $otps->created_by = 0;
        $otps->created_on = now();
        $otp_type  = rand(100000, 999999);
        $data['otp'] = $otp_type;

        if ($request->type == 'mobile') {
            $configuration = Configuration_table::where('configuration_name', 'SMS Status')->first();
            $response = null;
            if($configuration->configuration_value == 'Active'){
                $response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->value . '&message=' . $otp_type . ' is the OTP for your application');
            }
            
            if ($response) {
                $otps->otp = $otp_type;
                $otps->validate_otp = false;
                $otps->save();
                $data['otps'] = $otps;
                return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        } else if ($request->type == 'email') {

            $respo = $this->sendEmail($request->value, $otp_type);
            if ($respo == 202 || $respo != 202) {
                $otps->otp = $otp_type;
                $otps->validate_otp = false;
                $otps->save();
                $data['otps'] = $otps;
                return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        }
    }
}
    public function resendOtp(Request $request)
    {
        $checkOtp = Otp::where('value', $request->value)->get();
        $otps = new Otp();
        $otp_type  = rand(100000, 999999);

        $data['otp'] = $otp_type;
        if ($request->type == 'mobile') {
            $response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->value . '&message=' . $otp_type . ' is the OTP for your application');
            if ($response) {
                $updateotp = Otp::select('otp')
                    ->where('value', $request->value)
                    ->update(['otp' => $otp_type]);
                return response()->json([
                    "status" => true,
                    "message" => 'Resent otp successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        } else if ($request->type == 'email') {
            $respo = $this->sendEmail($request->value, $otp_type);
            if ($respo == 202 || $respo != 202) {
                $updateotp = Otp::select('otp')
                    ->where('value', $request->value)
                    ->update(['otp' => $otp_type]);
                return response()->json([
                    "status" => true,
                    "message" => 'Resent otp successfully',
                    "Data" => $data
                ], 201);
            } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to Send OTP',
                ], 201);
            }
        }
    }
    public function verifyCusOtp(Request $request)
    {
        $checkOtp = Otp::select('otp', 'value')
            ->where('value', '=', $request->value)
            ->where('form_id', '=', $request->form_id)
            ->where('otp', '=', $request->otp)
            ->get();

        if (!$checkOtp->isEmpty()) {
            $updateUser = Otp::select('otp')
                ->where('value', '=', $request->value)
                ->where('form_id', '=', $request->form_id)
                ->where('otp', '=', $request->otp)
                ->update(['validate_otp' => true]);


            return response()->json([
                "status" => true,
                "message" => 'Otp verified successfully',
                "data" => $checkOtp
            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Please enter valid otp',
        ], 201);
    }

    public function sendEmail($mail, $otp)
    {
        $name = 'aagey';
        $htmlContent = "<p>Your OTP is <b>" . $otp . "</b></p>";
        $textContent = "<p>Your OTP is <b>" . $otp . "</b></p>";
        $from = new From('v.care@aagey.com', 'V CARE');
        $subject = "OTP Verification";
        $recipient = new To('v.care@aagey.com', 'V CARE');

        $email = new Mail();
        $email->setFrom($from);
        $email->setSubject($subject);
        $email->addto($mail);
        $email->addContent("text/plain", $textContent);
        $email->addContent("text/html", $htmlContent);

        $sendgrid = new \SendGrid('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');
        try {
            $respo = $sendgrid->send($email);
            $context = json_decode($respo->body());
            return $respo->statusCode();
            //  if ($respo->statusCode() == 202) {
            //     echo "Metric email has been sent";
            //   // return $respo;
            // } else {
            //    // return $respo;
            //     echo "Failed to send metric email";
            // }
        } catch (\Exception $e) {
            //echo "Failed";
        }
    }


    public function getMasterTableIdUsingMasterTypeAndName($parent_type,$master_type) {
        $fileTypeData = DB::table('master_table')
            ->join('main_master', 'main_master.master_table_id', '=', 'master_table.master_table_id')
            ->where('main_master.name', '=', $master_type)->where('main_master.is_active', '=', 1)->where('master_table.name', '=', $parent_type)
            ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
            ->get();

        return $fileTypeData[0]->id;
    }
	
	public function getnotifications($type,$value,$notification_body,$user_id){

        //Call rest api to store credentials in notification table for email . 
        $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/saveNotification',[
           'type' => $type,
           'value' => $value,
           'notification_body' => $notification_body,
           'notification_flag' => 'true',
          'ip_address' => $_SERVER['REMOTE_ADDR'],
          'subject' => 'Aagey',
           'form_id' => 112,
           'user_id' => $user_id,
           'enable' => 1,
           'is_active' => 1,
       ]);
       //Log::info($response);
       
   }
   
   public function clientRegOtp(Request $request){
        // Log::info(1);
        //Call rest api to check credential in otp table
        $response1 = Http::post($this->serverUri . 'Identitymanagement/server.php/api/getOtpdetails',[
        'value'=> $request->value
        ]);
        Log::info($response1);
        
        $jsonRes = json_decode($response1);
        // Log::info($jsonRes->status);
    
        if($jsonRes->status ==true){
            return response()->json([
            "status"=>101,
            "message"=>"already validated"
            ]);
        }else{
            Log::info("ne");
            $otp = Otp::firstOrNew(['id' => $request->otp_id]);
            $otp->type = $request->type;
            $otp->value = $request->value;
            $otp->form_id = $request->form_id;
            $otp->created_by = 0;
            $otp->created_on = now();
            //$otp_type = rand(100000, 999999);
            $otp_type = "212223";
            $data['otp'] = $otp_type;
            if($request->type == 'mobile'){
                // $response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number=' . $request->value . '&message=' . $otp_type . 'is the OTP for your application');
                // if($response){
                $otp->otp = $otp_type;
                $otp->validate_otp = false;
                $otp->save();
                $data['otps'] = $otp;
                return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ], 201);
                // } else {
                // return response()->json([
                // "status" => false,
                // "message" => 'Failed to Send OTP',
                // ], 201);
                // }
            }else if($request->type == 'email'){
                //$respo = $this->sendEmail($request->value, $otp_type);
                //if ($respo == 202 || $respo != 202) {
                    $otp->otp = $otp_type;
                    $otp->validate_otp = false;
                    $otp->save();
                    $data['otps'] = $otp;
                    return response()->json([
                    "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                    ], 201);
                // } else {
                //     return response()->json([
                //     "status" => false,
                //     "message" => 'Failed to Send OTP',
                //     ], 201);
                // }
            }
        }
    }
	
	
	public function callLogFileStore($userId, $formType, $queryType, $query, $tableName, $userAction)
    {
        $audit_trail = new Audit_trail();
        $audit_trail->user_id = $userId;
        $audit_trail->ip_address = $_SERVER['REMOTE_ADDR'];
        $audit_trail->form_type = $formType;
        $audit_trail->query_type = $queryType;
        $audit_trail->query = $query;
        $audit_trail->table_name = $tableName;
        $audit_trail->created_by = $userId;
        $audit_trail->created_on = now();
        $audit_trail->modified_by = $userId;
        $audit_trail->modified_on = now();
        $audit_trail->is_active = 1;
        $audit_trail->enable = true;
        $audit_trail->user_action = $userAction;
        $audit_trail->save();
        $mongo_insert_id = $audit_trail->_id;
        Log::info('mongodb insert Id' . $mongo_insert_id);
        if (!$mongo_insert_id) {
            Log::error('Failed to save File In mongodb.' . $mongo_insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save File In mongodb',
                "id" => null
            ], 201);
        }
    }
	
	
	  public function callLogFileStore1(Request $request)
    {
        
        $this->callLogFileStore($request->user_id, $request->form_type, $request->query_type, $request->query, $request->table_name, $request->user_action);
    }
	
	  public function getAllPropertyTypeBasedOnPropertyAssets(Request $request){
        $query ="select property_usage.name as AssetName, asset_property_type.name as AssetPropertyNames,property_usage.id as purposeId
        from asset_property_purpose_mapping
        left join property_usage on property_usage.id = asset_property_purpose_mapping.asset_purpose_id
        left join asset_property_type on asset_property_type.id = asset_property_purpose_mapping.property_type_id 
        where asset_property_purpose_mapping.property_type_id = '" . $request->property_type_id . "'";
        Log::info($query);
        $assetProperty = DB::select($query);
                if(count($assetProperty) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data" => $assetProperty
                ], 200);
                } else {
                return response()->json([
                    "status" => false,
                    "message" => 'no records found'
                ], 200);
                }
                
    }

    public function getAllPropertyAssets(Request $request){
        $propertyasset = AssetProperty::select('*')->where('is_active', $request->is_active)->get();
        if(count($propertyasset) > 0) {
        return response()->json([
            "status" => true,
            "message" => 'Data fetched successfully',
            "data" => $propertyasset
        ], 200);
        } else {
        return response()->json([
            "status" => false,
            "message" => 'no records found'
        ], 200);
        }
    }
    public function getAllAssetTypes(Request $request){
        $assetType = AssetType::select('*')->where('is_active', $request->is_active)->get();
        if(count($assetType) > 0) {
        return response()->json([
            "status" => true,
            "message" => 'Data fetched successfully',
            "data" => $assetType
        ], 200);
        } else {
        return response()->json([
            "status" => false,
            "message" => 'no records found'
        ], 200);
        }
    }
	   public function getAllTypeofConstruction(Request $request){
        $typeofconst = TypeOfConstruction::select('*')->where('is_active', $request->is_active)->get();
        if(count($typeofconst) > 0) {
        return response()->json([
            "status" => true,
            "message" => 'Data fetched successfully',
            "data" => $typeofconst
        ], 200);
        } else {
        return response()->json([
            "status" => false,
            "message" => 'no records found'
        ], 200);
        }
    }
	
	public function saveAssetTypes(Request $request){
		 if (empty($request)) {
            return;
        }
    DB::enableQueryLog();
    $assetType = AssetType::firstOrNew(['id' => $request->id]);
    $query1 = DB::getQueryLog();
    //Log::info($query1[0]['query']);
    $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
    $assetType->name = $request->name;
    $assetType->short_name = $request->short_name;
    $assetType->enable = true;
    $assetType->is_active=true;
    $assetType->created_by=1;
    $assetType->modified_by = 1;
	$assetType->modified_on = now();
	$assetType->created_on = now();
    $assetType->save();

    $insert_id = $assetType->id;
    if($insert_id) {
        return response()->json([
            "status" => true,
            "message" => 'Data saved successfully'
        ], 201);
    } else {
        return response()->json([
            "status" => false,
            "message" => 'Data not saved successfully'
        ], 201);
    }


}

public function saveAssetProperty(Request $request){
	 if (empty($request)) {
            return;
        }
    DB::enableQueryLog();
    $assetpropertyType = AssetProperty::firstOrNew(['id' => $request->id]);
    $query1 = DB::getQueryLog();
    //Log::info($query1[0]['query']);
    $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
    $assetpropertyType->name = $request->name;
    $assetpropertyType->short_name = $request->short_name;
    $assetpropertyType->enable = true;
    $assetpropertyType->is_active=true;
    $assetpropertyType->created_by=1;
    $assetpropertyType->modified_by = 1;
	$assetpropertyType->modified_on = now();
	$assetpropertyType->created_on = now();
    $assetpropertyType->save();

    $insert_id = $assetpropertyType->id;
    if($insert_id) {
        return response()->json([
            "status" => true,
            "message" => 'Data saved successfully'
        ], 201);
    } else {
        return response()->json([
            "status" => false,
            "message" => 'Data not saved successfully'
        ], 201);
    }
}


public function getAssetTypeByid(Request $request){

    $assetType = AssetType::select('*')->where('id', $request->id)->where('is_active','=',true)->get();
    if(count($assetType) > 0) {
    return response()->json([
        "status" => true,
        "message" => 'Data fetched successfully',
        "data" => $assetType
    ], 200);
    } else {
    return response()->json([
        "status" => false,
        "message" => 'no records found'
    ], 200);
    }
    }

    public function deleteAsset(Request $request)
    {
    $assetType = AssetType::find($request->id);
    $assetType->is_active  = 0;
    $assetType->save();
    $updateId = $assetType->id;
         if ($updateId) {
    return response()->json([
        "status" => true,
        "message" => 'Deleted successfully',
    ], 201);
    } else {
    return response()->json([
        "status" => false,
        "message" => 'Failed to delete',
    ], 201);
    }
    }



    public function getAssetPropertyByid(Request $request){

        $assetProperty = AssetProperty::select('*')->where('id', $request->id)->where('is_active','=',true)->get();
        if(count($assetProperty) > 0) {
        return response()->json([
            "status" => true,
            "message" => 'Data fetched successfully',
            "data" => $assetProperty
        ], 200);
        } else {
        return response()->json([
            "status" => false,
            "message" => 'no records found'
        ], 200);
        }
        }
    
        public function deleteAssetProperty(Request $request)
        {
        $assetProperty = AssetProperty::find($request->id);
        $assetProperty->is_active  = 0;
        $assetProperty->save();
        $updateId = $assetProperty->id;
             if ($updateId) {
        return response()->json([
            "status" => true,
            "message" => 'Deleted successfully',
        ], 201);
        } else {
        return response()->json([
            "status" => false,
            "message" => 'Failed to delete',
        ], 201);
        }
        }
		
		
public function saveAssetPropertyMapping(Request $request){
        DB::enableQueryLog();
        $propertyasset = PropertyAssetMapping::firstOrNew(['id' => $request->id]);
        $query1 = DB::getQueryLog();
        //Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
        $propertyasset->property_type_id = $request->property_type_id;
        $propertyasset->asset_purpose_id = $request->asset_purpose_id;
        $propertyasset->enable = true;
        $propertyasset->is_active=true;
        $propertyasset->save();

        $insert_id = $propertyasset->id;
        if($insert_id) {
            return response()->json([
                "status" => true,
                "message" => 'Data saved successfully'
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not saved successfully'
            ], 201);
        }

      }
	  
	   public function getAllConstructionBasedOnAssetProperty(Request $request){
        $query ="select property_usage.name, asset_property_type.name,type_of_construction.name,type_of_construction.id
        from construction_property_purpose
        left join property_usage on property_usage.id = construction_property_purpose.asset_purpose_id
        left join asset_property_type on asset_property_type.id = construction_property_purpose.property_type_id 
		left join type_of_construction on type_of_construction.id = construction_property_purpose.type_const_id 
        where  construction_property_purpose.property_type_id = '" . $request->property_type_id . "' and construction_property_purpose.asset_purpose_id = '" . $request->asset_purpose_id . "'";
        //Log::info($query);
        $assetProperty = DB::select($query);
                if(count($assetProperty) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data" => $assetProperty
                ], 200);
                } else {
                return response()->json([
                    "status" => false,
                    "message" => 'no records found'
                ], 200);
                }
                
    }
	
	public function saveConstrAssetPropertyMapping(Request $request){
        DB::enableQueryLog();
        $constPropertyPurpose = ConstructionPropertyPurposeMapping::firstOrNew(['id' => $request->id]);
        $query1 = DB::getQueryLog();
        //Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
        $constPropertyPurpose->property_type_id = $request->property_type_id;
        $constPropertyPurpose->asset_purpose_id = $request->asset_purpose_id;
		$constPropertyPurpose->type_const_id = $request->type_const_id;
        $constPropertyPurpose->enable = true;
        $constPropertyPurpose->save();

        $insert_id = $constPropertyPurpose->id;
        if($insert_id) {
            return response()->json([
                "status" => true,
                "message" => 'Data saved successfully'
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not saved successfully'
            ], 201);
        }

      }
	  
	  
public function saveTypeOfConstruction(Request $request){
	 if (empty($request)) {
            return;
        }
    DB::enableQueryLog();
    $typeofconst = TypeOfConstruction::firstOrNew(['id' => $request->id]);
    $query1 = DB::getQueryLog();
    //Log::info($query1[0]['query']);
    $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
    $typeofconst->name = $request->name;
    $typeofconst->short_name = $request->short_name;
    $typeofconst->enable = true;
    $typeofconst->is_active=true;
	$typeofconst->created_on = now();
    $typeofconst->save();

    $insert_id = $typeofconst->id;
    if($insert_id) {
        return response()->json([
            "status" => true,
            "message" => 'Data saved successfully'
        ], 201);
    } else {
        return response()->json([
            "status" => false,
            "message" => 'Data not saved successfully'
        ], 201);
    }
}


public function getTypeOfConstructionId(Request $request){

    $typeofconst = TypeOfConstruction::select('*')->where('id', $request->id)->where('is_active','=',true)->get();
    if(count($typeofconst) > 0) {
    return response()->json([
        "status" => true,
        "message" => 'Data fetched successfully',
        "data" => $typeofconst
    ], 200);
    } else {
    return response()->json([
        "status" => false,
        "message" => 'no records found'
    ], 200);
    }
    }

    public function deleteTypeOfConstruction(Request $request)
    {
    $typeofconst = TypeOfConstruction::find($request->id);
    $typeofconst->is_active  = 0;
    $typeofconst->save();
    $updateId = $typeofconst->id;
         if ($updateId) {
    return response()->json([
        "status" => true,
        "message" => 'Deleted successfully',
    ], 201);
    } else {
    return response()->json([
        "status" => false,
        "message" => 'Failed to delete',
    ], 201);
    }
    }
	
	public function getAllDisplayHeaderFinance(Request $request){
        $disp = Display_parameter_header_finance::select('*')->where('is_active',$request->is_active)->get();
        if(count($disp) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $disp
            ], 200);
            } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
            }
                
    }
	
	public function saveIndustryMapping(Request $request){
        if (empty($request)) {
               return;
           }
       DB::enableQueryLog();
       $industryMapping = IndustryMapping::firstOrNew(['id' => $request->id]);
       $query1 = DB::getQueryLog();
       //Log::info($query1[0]['query']);
       $this->callLogFileStore($request->user_id, "let's get start", "Select", $query1[0]['query'], "request","Insert");
       $industryMapping->industry_type = $request->industry_type;
       $industryMapping->industry_group = $request->industry_group;
       $industryMapping->industry_name=$request->industry_name;
       $industryMapping->is_active = 1;
       $industryMapping->save();
   
       $insert_id = $industryMapping->id;
       if($insert_id) {
           return response()->json([
               "status" => true,
               "message" => 'Data saved successfully'
           ], 201);
       } else {
           return response()->json([
               "status" => false,
               "message" => 'Data not saved successfully'
           ], 201);
       }
   }
   
 public function getFoldersNumber(Request $request)
{
    DB::enableQueryLog();
    $query ="select parameter_id,proc_financial_eval_param.parameter_name,parameter_value,year
      from proc_financial_eval_results
     LEFT JOIN proc_financial_eval_param
    ON proc_financial_eval_results.parameter_id = proc_financial_eval_param.id
    where folder_no= '" . $request->folder_no. "'";
    
    $data =  DB::select($query);
    Log::info($data);
    if (count($data) > 0) {
        return response()->json([
            "message" => 'Data fetched successfully',
            "data"    => $data
        ], 201);
    } else {
        return response()->json([
            "message" => 'Data not available',
        ], 201);
    } 
}  
   


}
