<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Form;

class FormController extends Controller
{
    public function saveForm(Request $request){

        $forms = Form::firstOrNew(['id'=> $request->id]);
        $forms->flow = $request->get('flow');
        $forms->form_id = $request->get('form_id');
        $forms->name = $request->get('name');
        $forms->type= $request->get('type');
        $forms->enable = 1;
        $forms->is_active = 1;
        $timestamps = now();
        if(!empty($request->id)){
            $forms->modified_by = 1;
            $forms->modified_on = now();
        }else{
            $forms->created_by = 1;
            $forms->created_on = now();
        }

        $forms->save();
        $insert_id = $forms->id;
        if (!$insert_id){
            Log::error('Failed to save in pgsql. for ' . $request->name );
            return response()->json([
                "message" =>'Failed to save in pgsql',
                "id" =>null
            ], 417)  ;
        }else{
            return response()->json([
                "message" => 'Successfully inserted',
                "Data" =>  $insert_id
            ], 201);
        }
    }

    public function getAllForms(Request $request){

        $forms = DB::select('select id,flow,form_id,name,type from forms');

        if(count($forms)>0){
            return response()->json([
                "message"=>'Data fetched successfully',
                "data" => $forms
            ], 201);
        }
        return response()->json([
            "message" =>'Data not available',
        ], 403);

    }
    public function getFormsByid($id){
        $forms = Form::find($id);
        
        if($forms){
            return response()->json([
                "message" => 'Data fetched successfully',
                "Data" => $forms
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }

    }

    public function updateFormByid(Request $request,  $id){
        $forms = Form::find($id);
        $forms->flow = $request->get('flow');
        $forms->form_id = $request->get('form_id');
        $forms->name = $request->get('name');
        $forms->type = $request->get('type');
        $forms->enable = 1;
        $forms->is_active = 1;

        $forms->save();
    
        if($forms){
            return response()->json([
                "message" => 'Data updated successfully',
                "Data" => $forms
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }    
    }
    public function deletebyid($id){
        $forms = Form::find($id);

        $forms->delete();
        if($forms){
            return response()->json([
                "message" => 'Data deleted successfully',
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }

    }

}
