<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\GeneralSettings;

class GeneralSettingsController extends Controller
{
    

    public function generalSettingAddOrEdit(Request $request){
        $generalSetting =GeneralSettings::firstOrNew(['id'=>$request->general_setting_id]);
        $generalSetting->parameter_name                 =   $request->parameter_name;
        $generalSetting->parameter_value                =   $request->parameter_value;
        $generalSetting->enable                         =   $request->enable;
        $generalSetting->is_active                      =   $request->is_active;
        if (GeneralSettings::where('id',$request->general_setting_id)->count()>0) {
            $generalSetting->modified_on = now();
            $generalSetting->modified_by = 1;
        } else {
            $generalSetting->created_by = 1;
            $generalSetting->created_on = now();
        }
        $generalSetting->save();

        $insert_id = $generalSetting->id; 
        $data = $generalSetting->getAttributes();
        $redis = $this->setReddis($data, 'generalSetting');
        if (!$redis) {
            Log::error('Failed to save in redis general_setting_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        } 
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['general_setting_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getGeneralSettingByParameter(Request $request){
        $data = GeneralSettings::where('is_active', '=', 1)->where('enable', '=', 1)->where('parameter_name', '=', $request->parameter_name)->get();
            if (!$data->isEmpty()) {
                return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
                ], 201);
            }
            return response()->json([
                "message" => 'Data not available',
            ], 201);
        }

      

    public function getAllGeneralSetting(Request $request){
        if($request->has('enable')){
            $data = GeneralSettings::where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = GeneralSettings::where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    public function deleteGeneralSetting(Request $request){
        $deleteGeneralSetting = GeneralSettings::find($request->general_setting_id);
        if (!empty($deleteGeneralSetting)) {
            $deleteGeneralSetting->is_active = 0;
            $deleteGeneralSetting->save();
            return response()->json([
                "message" => 'Deleted successfully',
            ], 200);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
}
