<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Notifications;
use App\Otp;
use Illuminate\Support\Facades\Http;

use Illuminate\Support\Facades\Mail;

use SendGrid\Mail\From;
//use SendGrid\Mail\Mail;
use SendGrid\Mail\To;
use SendGrid\Mail\TypeException;
use App\Mail\SendGridEmail;
use Illuminate\Support\Facades\Log;

class NotificationController extends Controller
{
    public function saveNotification(Request $request){
        $notifications = new Notifications();
        $notifications->type = $request->type;
        $notifications->value = $request->value;
        $notifications->notification_body = $request->notification_body;
        $notifications->notification_flag = $request->notification_flag;
        $notifications->ip_address = $_SERVER['REMOTE_ADDR'];
        $notifications->form_id = $request->form_id;
        $notifications->user_id = $request->user_id;
        $notifications->enable = 1;
        $notifications->is_active = 1;
        $timestamps = now();
        if(!empty($request->id)){
            $notifications->modified_by = $request->user_id;
            $notifications->modified_on = now();
        }else{
            $notifications->created_by = $request->user_id;
            $notifications->created_on = now();
        }

        $data['Notifications'] = $notifications;

        $message  = $request->notification_body;
        $data['message'] = $message ;
		
		$notifications->save();
		$insert_id = $notifications->id;
			if($insert_id){
				if($request->type == 'mobile'){
			
			
			
                    //$response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number='.$request->value.'&message='.$message);
                    //$response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number='.$request->value.'&message='.$message.' is the OTP for your application');
                    //Log::info($response);
					$response =true;
                    if($response){
                        
                        $notifications->notification_flag = true;
                        
                        $notifications->notification_body = $message;
                        //$notifications->update();
                        $notifications->save();
                        $data['message'] = $message;
                        return response()->json([
                        "status" => true,
                            "message" => 'Message sent successfully',
                            "Data" => $data
                        ],201);
                    }else{
                        return response()->json([
                        "status" => false,
                            "message" => 'Failed to Send Message',
                        ],201);
                    }
                }else if($request->type == 'email'){
                    //Log::info($message);
            $respo = $this->sendEmail($request->value,'notification', $message, $request->subject);
            if($respo->getStatusCode() == 202 || $respo->getStatusCode() != 202){
                $notifications->subject= $request->subject;
                $notifications->cc = $request->cc;
                $notifications->notification_body = $message;
				
				$notifications->notification_flag = true;
                $notifications->update();
                
                
				return response()->json([
                "status" => true,
                    "message" => 'Mail sent successfully',
                    "Data" => $data
                ],201);
            }else{
                return response()->json([
                "status" => false,
                    "message" => 'Failed to Send Mail',
                ],201);
            }
        }
			}

        
    }


        
        public function sendEmail($to_mail,$emailtype=null,$notification_body=null, $subject=null)
    {
        Log::info($to_mail);
      

        $data = [
            'name' => "User",
            'subject' => $subject,
            "type"=>$emailtype,
            "message"=>$notification_body
        ];

        Mail::to($to_mail)->send(new SendGridEmail($data));
        if(Mail::failures() != 0) {
            return response()->json([
                "message" => 'Mail sent successfully',
                "status" => true
            ], 202);
        }

        else {
            return response()->json([
                "message" => 'Mail not sent',
                "status" => false
            ], 500);
        }
    }

    function OtpNotification(Request $request){
        $otpnotify = Otp::firstOrNew(['id'=> $request->otp_id]);
        $otpnotify->type = $request ->get('type');
        $otpnotify->value = $request->get('value');
        $otpnotify->form_id = $request->get('form_id');

        $otp_type  = rand(100000,999999);
        $data['otp'] = $otp_type ;

        if($request->type == 'mobile'){
            //$response = Http::get('http://sms2.iissms.co.in/V2/http-api.php?apikey=Aq6qfwIfDz7O3J9M&senderid=AISINF&number='.$request->value.'&message='.$otp_type.'is the OTP for your application');
            $response =true;
			if($response){
                $otpnotify->otp = $otp_type;
                $otpnotify->validate_otp = false;
                $otpnotify->save();
                $data['otps'] = $otpnotify;
                return response()->json([
                "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ],201);
            }else{
                return response()->json([
                "status" => false,
                    "message" => 'Failed to Send OTP',
                ],201);
            }
        }else if($request->type == 'email'){
            $respo = $this->sendEmail($request->value, $otp_type);
            if($respo == 202){
                $otpnotify->otp = $otp_type;
                $otpnotify->validate_otp = false;
                $otpnotify->save();
                $data['otps'] = $otpnotify;
                return response()->json([
                "status" => true,
                    "message" => 'Otp sent successfully',
                    "Data" => $data
                ],201);
            }else{
                return response()->json([
                "status" => false,
                    "message" => 'Failed to Send OTP',
                ],201);
            }
        }
    }

    function getAllNotifications(Request $request) {
   
        if($request->has('enable')){
            $data = DB::table('notifications')->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('notifications')->where('is_active','=',1)->get();
        }
        
        if(!$data->isEmpty()) {
            return response()->json([
                "status"=>true,
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "status"=>false,
            "message" => 'Data not available',
        ], 201);

    }

    function getAllNotificationById(Request $request) {
        $data = Notifications::where('is_active', '=', 1)
        ->where('enable', '=', 1)
        ->where('id', '=', $request->notification_id)
        ->get(); 
        if(!$data->isEmpty()) {
            return response()->json([
                "status"=>true,
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "status"=>false,
            "message" => 'Data not available',
        ], 201);
    
    }

    public function deleteNotificationById(Request $request){
        $deleteNotification = Notifications::find($request->notification_id);
        if (!empty($deleteNotification)) {
            $deleteNotification->delete();
            return response()->json([
                "status"=>true,
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "status"=>false,
                "message" => 'Data not available',
            ], 201);
        }
    }
}

