<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Permission;

class PermissionController extends Controller
{
    public function savePermission(Request $request){
       // echo $request;

        //$permissions = new Permission();
        $permissions = Permission::firstOrNew(['id'=> $request->permission_id]);
        $permissions->name = $request->get('name');
        $permissions->enable = 1;
        $permissions->is_active = 1;
        $timestamps = now();
        if(!empty($request->permission_id)){
            $permissions->modified_by = 1;
            $permissions->modified_on = now();
        }else{
            $permissions->created_by = 1;
            $permissions->created_on = now();
        }

        $permissions->save();
        $insert_id = $permissions->id;
        if (!$insert_id){
            Log::error('Failed to save in pgsql. for ' . $request->name);
            return response()->json([
                "message"=>'Failed to save in pgsql',
                "id" =>null
            ], 417);
        }else{
            return response()->json([
                "message" => 'Successfully inserted',
                "data"=> $insert_id
            ],201);
        }
    }

    public function getAllPermission(Request $request){
        $permissions = DB::select('select id,name,enable,is_active from permissions');
        if(count($permissions)>0){
            return response()->json([
                "message"=> 'Data fetched successfully',
                "data" => $permissions
            ], 201);
        }
        return response()->json([
            "message" =>'Data not available',
        ], 403);
    }

    public function getPermissionByid($id){
        $permissions = Permission::find($id);

        if($permissions){
            return response()->json([
                "message" => 'Data fetched successfully',
                "Data" => $permissions
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }
    }

    public function updatePermissionByid(Request $request, $id){
        $permissions = Permission::find($id);
        $permissions->name = $request->get('name');
        $permissions->enable = 1;
        $permissions->is_active = 1;
        $permissions->save();

        if($permissions){
            return response()->json([
                "message" => 'Data updated successfully',
                "Data" => $permissions
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }   
    }

    public function deletebyid($id){
        $permissions = Permission::find($id);

        $permissions->delete();
        if($permissions){
            return response()->json([
                "message" => 'Data deleted successfully',
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }

    }
    
}
