<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Role;

class RoleController extends Controller
{
    public function saveRole(Request $request){
        //echo $request;

        //$roles = new Role();
        $roles = Role::firstOrNew(['id'=> $request->role_id]);
        $roles->name = $request->get('name');
        $roles->enable = 1;
        $roles->is_active = 1;
        $timestamps = now();
        if(!empty($request->role_id)){
            $roles->modified_by = 1;
            $roles->modified_on = now();
        }else{
            $roles->created_by = 1;
            $roles->created_on = now();
        }

        $roles->save();
        $insert_id = $roles->id;
        if (!$insert_id){
            Log::error('Failed to save in pgsql. for ' . $request->name );
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" =>null
            ], 417);
        }else{
            return response()->json([
                "message" => 'Successfully inserted',
                "Data"=> $insert_id
            ], 201);
        }
        
    }

    public function getAllRole(){

        $roles = DB::select('select id,name,enable,is_active from roles where id != 2');

        if(count($roles)>0){
            return response()->json([
                "message"=> 'Data fetched successfully',
                "data" => $roles
            ], 201);
        }
        return response()->json([
            "message" =>'Data not available',
        ], 403);

    }
   



    public function getRoleByid(Request $request){
        $roles = Role::select('id', 'name')->get();
        if(!empty($roles)){
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"=> $roles
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function updateRolebyid(Request $request, $id){
        $roles =  Role::find($id);
        $roles->name = $request->get('name');
        $roles->enable = 1;
        $roles->is_active = 1;
        $roles->save();

        if($roles){
            return response()->json([
                "message" => 'Data updated successfully',
                "Data" => $roles
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }   

    }
    
    


    public function deletebyid($id){
        $roles = Role::find($id);

        $roles->delete();
        if($roles){
            return response()->json([
                "message" => 'Data deleted successfully',
            ], 200);
        }else{
            return response()->json([
                "message" => 'Data not found',
            ], 403);
        }

    }
}


