-- Table: public.asset_category

-- DROP TABLE public.asset_category;

CREATE TABLE public.asset_category
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0) NOT NULL,
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    asset_type_id bigint,
    CONSTRAINT asset_category_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.asset_category
    OWNER to postgres;
	
	
	
	-- Table: public.asset_size

-- DROP TABLE public.asset_size;

CREATE TABLE public.asset_size
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    asset_type_id bigint,
    CONSTRAINT asset_size_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.asset_size
    OWNER to postgres;
	
	
	-- Table: public.asset_sub_category

-- DROP TABLE public.asset_sub_category;

CREATE TABLE public.asset_sub_category
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    asset_type_id bigint,
    CONSTRAINT asset_sub_category_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.asset_sub_category
    OWNER to postgres;
	
	
-- Table: public.asset_usage_type

-- DROP TABLE public.asset_usage_type;

CREATE TABLE public.asset_usage_type
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default",
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    asset_type_id bigint,
    CONSTRAINT asset_usage_type_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.asset_usage_type
    OWNER to postgres;
	-- Table: public.document_authority

-- DROP TABLE public.document_authority;

CREATE TABLE public.document_authority
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default",
    state_id bigint NOT NULL,
    city_id bigint NOT NULL,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT document_authority_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.document_authority
    OWNER to postgres;
	
	-- Table: public.document

-- DROP TABLE public.document;

CREATE TABLE public.document
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default",
    single text COLLATE pg_catalog."default" NOT NULL,
    digital_verification text COLLATE pg_catalog."default" NOT NULL,
    time_bound bigint NOT NULL,
    short_order text COLLATE pg_catalog."default",
    enable boolean,
    is_active boolean,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT document_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.document
    OWNER to postgres;
	
	-- Table: public.document_list

-- DROP TABLE public.document_list;

CREATE TABLE public.document_list
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT document_list_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.document_list
    OWNER to postgres;
	-- Table: public.industry_segments

-- DROP TABLE public.industry_segments;

CREATE TABLE public.industry_segments
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on time without time zone,
    CONSTRAINT industry_segments_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.industry_segments
    OWNER to postgres;
	
	-- Table: public.loan_types

-- DROP TABLE public.loan_types;

CREATE TABLE public.loan_types
(
    id integer NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 2147483647 CACHE 1 ),
    name text COLLATE pg_catalog."default" NOT NULL,
    short_name text COLLATE pg_catalog."default" NOT NULL,
    description text COLLATE pg_catalog."default" NOT NULL,
    product_type_id bigint NOT NULL,
    sort_order boolean,
    enable boolean NOT NULL,
    is_active boolean NOT NULL,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT loan_types_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.loan_types
    OWNER to postgres;

    -- Table: public.general_settings

-- DROP TABLE public.general_settings;

CREATE TABLE public.general_settings
(
    id bigint NOT NULL,
    parameter_name text COLLATE pg_catalog."default" NOT NULL,
    parameter_value text COLLATE pg_catalog."default" NOT NULL,
    enable boolean,
    is_active boolean,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT general_settings_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.general_settings
    OWNER to postgres;

    -- Table: public.industry_group

-- DROP TABLE public.industry_group;

CREATE TABLE public.industry_group
(
    id bigint NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT 1 START 1 MINVALUE 1 MAXVALUE 9223372036854775807 CACHE 1 ),
    industry_segment text COLLATE pg_catalog."default" NOT NULL,
    "Industry_type_id" bigint NOT NULL,
    sort_order boolean,
    enable boolean,
    is_active boolean,
    created_by numeric(10,0),
    created_on timestamp with time zone,
    modified_by numeric(10,0),
    modified_on timestamp with time zone,
    CONSTRAINT industry_group_pkey PRIMARY KEY (id)
)

TABLESPACE pg_default;

ALTER TABLE public.industry_group
    OWNER to postgres;
	