<?php

namespace App\Http\Controllers;

use App\Asset;
use App\Banking_header;
use App\Business_profile_doc;
use Illuminate\Http\Request;
use App\BusinessInfo;
use App\shareholder_personal_info;
use App\BusinessBankingInfo;
use App\Businessgst;
use App\Promotorinfo;
use App\Company_profile_doc;
use App\Finance_data;
use App\Finance_header;
use App\Loan;
use App\State;
use App\Notes;
use App\RequestTable;
use App\Comm_address;
use App\Bus_partner_mapping;
use App\WorkingCaptial;
use App\GSTHeader;
use App\GstDetails;
use App\BankingDetails;
use Illuminate\Support\Facades\Redis;
use Jenssegers\Mongodb\Eloquent\Model as Eloquent;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;
use App\Document;
use App\DocumentAuthority;
use App\DocumentMaster;
use App\AssetCategory;
use App\AssetSize;
use App\AssetSubCategory;
use App\AssetUsageType;
use App\Banking_parameter;
use App\Industry_segment;
use App\LoanType;
use App\Product;
use App\Financier;
use App\DocumentList;
use App\Nationality;
use App\Bank;
use App\City;
use App\IndustryNames;
use App\IndustryGroup;
use App\GeneralSetting;

class FinanceController extends Controller
{
    public function businessDetails(Request $request)
    {
        $businessInfo = BusinessInfo::firstOrNew(['id'=>$request->bus_id]);
        $businessInfo->name = $request->businessName;
        $businessInfo->user_id = $request->user_id;
        $businessInfo->setup_date = $request->date;
        $businessInfo->gst = $request->gst;
        $businessInfo->BPAN = $request->businesspan;
        $businessInfo->pin_id = $request->pincode;
        $businessInfo->area = $request->area;
        $businessInfo->entity_id = $request->entity;
        $businessInfo->bus_premises_id = $request->business;
        $businessInfo->industry_type_id = $request->industry;
        $businessInfo->industry_name_id = $request->industryname;
        $businessInfo->industry_group_id = $request->industrygrp;
        $businessInfo->bus_premises_area = $request->bparea;
        $businessInfo->govt = $request->govt;
        $businessInfo->grc_no = $request->grcno;
        $businessInfo->bus_desc = $request->descrip;
        $businessInfo->is_draft = $request->is_draft;
        // static
         $timestamp = now();
        if(!empty($request->bus_id)) {
            $businessInfo->modified_by = 1;
            $businessInfo->modified_on = now();
        } else {
            $businessInfo->created_by = 1;
            $businessInfo->created_on = now();
        }
       
        $businessinfoarray = $businessInfo->getAttributes();
        $redis = $this->setReddis($businessinfoarray, 'businessInfo');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" =>null
            ], 417);
        }
        $businessInfo->save();
        $insert_id = $businessInfo->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->businessName . ' ' . $request->gst);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" =>null
            ], 417);
        }
        $req_id  =  $this->request_table($request);
        if(!empty($request->note_description) && !empty($req_id)){
            $notes = $this->notes($request,$req_id);
        }
        if ($request->file()) {
           $image = base64_encode(file_get_contents($_FILES['company_profiles']['tmp_name']));
           $name = $_FILES['company_profiles']['name'];
           $insert['name'] = "$name";
           $insert['file'] = "$image";
           $insert['b_id'] = $insert_id;
           $mongo_id = Business_profile_doc::insertGetId($insert);
//echo "<pre>";print_r($mongo_id);exit;          
 if (!$mongo_id) {
            Log::error('Failed to save File In mongodb.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save File In mongodb',
                "id" =>null
            ], 417);
        }
        DB::table('business_infos')
            ->where('id', $insert_id)
            ->update(['Company_profile_upload_id' => $mongo_id]);
        }
 $businessinfoarray['primary_id'] = $insert_id;
        if(isset($businessinfoarray['modified_by'])) {
             unset($businessinfoarray['modified_by']);
        }
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$businessinfoarray
        ], 201);
     
    }

 function notes($request, $req_id)
    {
        $notes = Notes::firstOrNew(['request_id' => $req_id]);
        $notes->request_id = $req_id;
        $notes->note_description = $request->note_description;
        if (!empty($request->bus_id)) {
            $notes->modified_by = 1;
            $notes->modified_on = now();
        } else {
            $notes->created_by = 1;
            $notes->created_on = now();
        }
        $notes->save();
        return $notes->id;
    }
    function request_table($request)
    {
        $req = RequestTable::firstOrNew(['id' => $request->id]);
        $req->request_type_id =  $request->request_type_id;
        $req->ip_address =  $_SERVER['REMOTE_ADDR'];
        $req->mac_address =  $this->macaddres();
        $req->bus_type_id =  $request->bus_type_id;
        $req->sub_agent_id =  $request->sub_agent_id;
        $req->sales_mgr_id =  $request->sales_mgr_id;
        $req->sub_agent_id =  $request->sub_agent_id;
        $req->bus_type_id =  $request->bus_type_id;
        $req->folder_no =  $request->folder_no;
        $req->status =  $request->status;
        $req->bus_channel_id =  $request->bus_channel_id;
        $req->save();
        return $req->id;
    }

    function macaddres()
    {
        $ipAddress = $_SERVER['REMOTE_ADDR'];

        $macAddr = false;

        #run the external command, break output into lines
        $arp = `arp -a $ipAddress`;
        $lines = explode("\n", $arp);

        #look for the output line describing our IP address
        foreach ($lines as $line) {
            $cols = preg_split('/\s+/', trim($line));
            if ($cols[0] == $ipAddress) {
                $macAddr = $cols[1];
            }
        }
        return $macAddr;
    }
//  function getbusinessInfoByid(Request $request){
//         $data = DB::table('business_infos')->where('id', $request->bus_id)->where('is_active','=',1)->where('enable',$request->enable)->first();
//         if(!empty($data)) {
//             if(!empty($data->Company_profile_upload_id)){
//             $user = Business_profile_doc::find($data->Company_profile_upload_id);
//             $data->document = base64_decode($user->file);
//             } else {
//                 $data->document ="";
//             }
//             return response()->json([
//                 "message" => 'Data fetched successfully',
//                 "data"    => $data
//             ], 201);
//         }
//         return response()->json([
//             "message" => 'Data not available',
//         ], 403);
//     }

function getbusinessInfoByid(Request $request){
    $data = DB::table('business_infos')->where('id', $request->bus_id)->first();
    if(!empty($data)){
        return response()->json([
            "message" => 'Data fetched successfully',
            "data" => $data
        ], 200);
    }else{
        return response()->json([
            "message" =>'No records found'
        ],403);   
    }
}
function getbusinessInfoByFileNo(Request $requset){
    $data = DB::table('business_infos')->where('file_no', $requset->file_no)->first();
    if(!empty($data)){
        return response()->json([
            "message" => 'Data fetched successfully',
            "data" => $data
        ], 200);
    }else{
        return response()->json([
            "message" => 'No records found'
        ], 403);
    }
}

    
 function getAllbusinessInfos(Request $request) {
   
        if($request->has('enable')){
            $data = DB::table('business_infos')->where('is_active','=',1)->where('enable','=',$request->enable)->orderBy('name')->get();
        }else{
            $data = DB::table('business_infos')->where('is_active','=',1)->orderBy('name')->get();
        }
        
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    
    
 function getshareholderorPromotorInfoByid(Request $request){
        $data = DB::table('promoter_info')->where('id', $request->promo_or_shareholder_id)->first();
        if(!empty($data)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data 
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

   function shareholderAndPersonalInfo(Request $request)
    {
        
        $shareholder_info = new Promotorinfo;
        $shareholder_info->first_name = $request->firstname;
        $shareholder_info->middle_name = $request->middlename;
        $shareholder_info->last_name = $request->lastname;
        $shareholder_info->share_percent = $request->share;
        $shareholder_info->type = $request->type;
        $shareholder_info->Mobile  = $request->mobile;
        $shareholder_info->email = $request->email;
       

        // static
        $shareholder_info->modified_by = 1;
       
        $shareholder_info->save();
        $insert_id = $shareholder_info->id;
        if (!$insert_id) {
            Log::error('Failed to save personalinfo in pgsql. for ' . $request->business_info_id . ' ' . $request->lastname);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $req_id  =  $this->request_table($request);
        if(!empty($request->note_description) && !empty($req_id)){
            $notes = $this->notes($request,$req_id);
        }
        $bus_parter_map = new Bus_partner_mapping();
        $bus_parter_map->promoter_id = $insert_id;
        $bus_parter_map->bus_id = $request->business_id;
        $bus_parter_map->enable = 1;
        $bus_parter_map->is_active = 1;
       // static
        $bus_parter_map->created_by = 1;
        $bus_parter_map->save();
        $data = $shareholder_info->getAttributes();
        $redis = $this->setReddis($data, 'shareholderinfo');
        if (!$redis) {
            Log::error('Failed to save in redis.' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
      
        $data['primary_id'] = $insert_id;
        if(isset($data['modified_by'])) {
             unset($data['modified_by']);
        }
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    

 
function getBankingDetails(Request $request){
    $data = DB::table('banking_header AS bbf')
        ->join('master_table AS mt_nature_of_acc', 'mt_nature_of_acc.id', '=', 'bbf.nature_of_account')
        ->join('master_table AS mtbank', 'mtbank.id', '=', 'bbf.bank_id')
        ->where('bbf.parent_id',$request->parent_id)
        ->where('bbf.parent_type_id',$request->parent_type_id)
            ->select('bbf.*', 'mt_nature_of_acc.name AS nature_of_acc', 'mtbank.name AS bankname')
            ->get();
            if(!empty($data)) {
                return response()->json([
                    "message" => 'Data fetched successfully',
                    "data"    => $data
                ], 201);
            }
            return response()->json([
                "message" => 'Data not available',
            ], 403);
}

    function businessBankingInfo(Request $request)
    {
         // static parent_type_id
        $bankinginfo =Banking_header::firstOrNew(['parent_id'=>$request->parent_id, 'parent_type_id'=>1]);
        $bankinginfo->bank_id         = $request->bankname;
        $bankinginfo->account_no        = $request->accountno;
        $bankinginfo->nature_of_account   = $request->natureacc;
        $bankinginfo->edc_pg_id        = $request->edcOrPg;
        $bankinginfo->account_type      = $request->accounttype;
        $bankinginfo->parent_type_id         = $request->parent_type_id;
        $bankinginfo->parent_id         = $request->parent_id;
        // static
        if (Banking_header::where(['parent_id' => $request->parent_id, 'parent_type_id' => 1])->count() > 0) {
            $bankinginfo->modified_on = now();
            $bankinginfo->modified_by = 1;
        } else {
            $bankinginfo->created_by = 1;
            $bankinginfo->created_on = now();
        }
        $data = $bankinginfo->getAttributes();
        $redis = $this->setReddis($data, 'businessbankingInfo');
        if (!$redis) {
            Log::error('Failed to save in redis.' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        $bankinginfo->save();
        $insert_id = $bankinginfo->id;
        if (!$insert_id) {
            Log::error('Failed to save bankinfo in pgsql. for ' . $request->business_id . ' ' . $request->bankname);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }

        $data['primary_id'] = $insert_id;
        if(isset($data['modified_by'])) {
             unset($data['modified_by']);
        }
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
   }
    function getAllState(Request $request) {
        if($request->has('enable')){
           $data = State::select('state_id', 'state_name')->where('is_active', '=', 1)->where('enable', '=',$request->enable)->orderBy('state_name')->get();
         }else{
             $data = State::select('state_id', 'state_name')->where('is_active', '=', 1)->orderBy('state_name')->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    function getAllStateBygstTinId(Request $request) {
        $data = State::select('state_id', 'state_name')
        ->where('is_active', '=', 1)
        ->where('enable', '=', 1)
        ->where('state_id', '=', $request->gst_id)
        ->orderBy('state_name')
        ->get(); 
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    // function getAllPromotorInfos(Request $request) {
    //     $data = DB::table('promoter_info')->skip($request->startlimit)->take($request->endlimit)->orderBy('name')->get();
    //     if(!$data->isEmpty()) {
    //         return response()->json([
    //             "message" => 'Data fetched successfully',
    //             "data"    => $data
    //         ], 201);
    //     }
    //     return response()->json([
    //         "message" => 'Data not available',
    //     ], 403);

    // }

    function getfinanceDetailsbyid(Request $request){
        if($request->has('enable')){
         $data = DB::table('finance_data')->where('bus_id', $request->business_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('finance_data')->where('bus_id', $request->business_id)->where('is_active','=',1)->get();
        }

        if(count($data)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function updateFinanceManually(Request $request)
    {
            $finance_header =Finance_header::firstOrNew(['bus_id'=>$request->business_id]);
            $finance_header->data_submit_type = $request->data_submit_type;
            $finance_header->parent_type_id = $request->parent_type_id;
        $finance_header->bus_id = $request->business_id;
            $finance_header->parent_id = $request->parent_id;
            $finance_header->enable = 1;
            $finance_header->is_active = 1;
             if (Finance_header::where('bus_id', '=', $request->business_id)->count() > 0) {
            $finance_header->modified_on = now();
            $finance_header->modified_by = 1;
        } else {
            $finance_header->created_by = 1;
            $finance_header->created_on = now();
        }

        $finance_header->record_status    = $request->status;

            $finance_header->save();

            $insert_header_id = $finance_header->id;
          if(!$insert_header_id) {
            Log::error('Failed to save finance header in pgsql. for ' . $request->business_id . ' ' . $request->finance_parameter_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
          }
$req_id  =  $this->request_table($request);
          if(!empty($request->note_description) && !empty($req_id)){
              $notes = $this->notes($request,$req_id);
          }
         foreach ($request->finance_parameter_id as $key => $rows) :
            // static
        $finance =Finance_data::firstOrNew(['mstr_finance_parameter_id'=>$rows, 'bus_id'=> $request->business_id]);
         
            $finance->bus_id = $request->business_id;
 $finance->finance_header_id = $insert_header_id;
            $finance->full_flag = $request->full_flag;
            $finance->mstr_finance_parameter_id = $rows;
            if (isset($request->Value[$key])) {
                $finance->value = $request->Value[$key];
            }
            if (isset($request->Year[$key])) {
                $finance->year = $request->Year[$key];
            }
// static
            if (Finance_data::where('bus_id', '=', $request->business_id)->where('bus_id', '=', $request->business_id)->count() > 0) {
                $finance->modified_on = now();
                $finance->modified_by = 1;
            } else {
                $finance->created_by = 1;
                $finance->created_on = now();
            }
            $data = $finance->getAttributes();
        $redis = $this->setReddis($data, 'businessfinanceInfo');
        if (!$redis) {
            Log::error('Failed to save in redis finance.' . $rows->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        $finance->save();
        $insert_id = $finance->id;
       
        if (!$insert_id) {
            Log::error('Failed to save finance in pgsql. for ' . $request->business_id . ' ' . $request->finance_parameter_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
 if(isset($data['modified_by'])) {
            unset($data['modified_by']);
       }
        $data = array_merge($data,array("primary_id" =>$insert_id )) ;
        $res_data[] =$data;
    endforeach;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" =>$res_data
        ], 201);
    }

    function loanForBusiness(Request $request)
    {
        $loan =Loan::firstOrNew(['id'=>$request->loan_id]);
        $loan->b_id = $request->business_id;
        $loan->Financer_id = $request->financer;
        $loan->Loan_type_id = $request->l_type;
        $loan->Loan_amount = $request->l_amount;
        $loan->Original_tenure_id = $request->l_tenture;
        $loan->EMI = $request->emi;
        $loan->Loan_still_open = $request->l_open;
        $loan->EMI_start_date = $request->emi_date;
        $loan->No_of_emi = $request->no_emi;
        $loan->Account_no = $request->acc_no;
        $loan->Remaining_emi = $request->rem_emi;
        $loan->Record_status = $request->status;

        $data = $loan->getAttributes();
        $redis = $this->setReddis($data, 'businessLoanInfo');
        if (!$redis) {
            Log::error('Failed to save in redis loanforbusiness.' . $request->financer);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (Loan::where('id', '=', $request->loan_id)->count() > 0) {
            $loan->modified_on = now();
            $loan->modified_by = 1;
        } else {
            $loan->created_by = 1;
            $loan->created_on = now();
        }
        $loan->save();
        $insert_id = $loan->id;
        if (!$insert_id) {
            Log::error('Failed to save loan in pgsql. for ' . $request->business_id . ' ' . $request->financer);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
$req_id  =  $this->request_table($request);
        if(!empty($request->note_description) && !empty($req_id)){
            $notes = $this->notes($request,$req_id);
        }
        $data['primary_id'] = $insert_id;

        return response()->json([
            "message" => 'Successfuly inserted',
               "Data"=>$data
        ], 201);
    }

    function workingCaptial(Request $request)
    {
        $capital =WorkingCaptial::firstOrNew(['id'=>$request->working_capital_id]);        
        $capital->b_id = $request->business_id;
        $capital->type_id = $request->type;
        $capital->credit_limit = $request->creditlimit;
        $capital->bank_id = $request->bank_id;
        $capital->rate_of_interest = $request->rate_of_intrest;
        $capital->comments = $request->comments;
        if (WorkingCaptial::where('id',$request->working_capital_id)->count()>0) {
            $capital->modified_on = now();
            $capital->modified_by = 1;
        } else {
            $capital->created_by = 1;
            $capital->created_on = now();
        }
        $capital->save();
        $insert_id = $capital->id;
        $data = $capital->getAttributes();
        $redis = $this->setReddis($data, 'businessWorkingCaptial');
        if (!$redis) {
            Log::error('Failed to save in redisworking_capital_id.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        
        if (!$insert_id) {
            //Log::error('Failed to save workingcapital in pgsql. for ' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['working_capital_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
function getWorkingCapitalDetailsbyid(Request $request){
    if($request->has('enable')){
        $working = WorkingCaptial::where('b_id', $request->business_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
    }else{
        $working = WorkingCaptial::where('b_id', $request->business_id)->where('is_active','=',1)->get();
    }
    if(!$working->isEmpty()) {
        return response()->json([
            "message" => 'Data fetched successfully',
            "data"    => $working
        ], 201);
    }
    return response()->json([
        "message" => 'Data not available',
    ], 403);

    }
    function getWorkingCapitalDetailsbyrowid(Request $request){
        $data = WorkingCaptial::where('id', $request->row_id)->get();
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    function businessgst(Request $request)
    {
        $gst =GSTHeader::firstOrNew(['id'=>$request->business_gst_id]);
        $gst->b_id = $request->business_id;
        $gst->gst_no = $request->gst_in;
        $gst->state_id = $request->state;
        if (GSTHeader::where('id', '=', $request->business_gst_id)->count() > 0) {
            $gst->modified_on = now();
            $gst->modified_by = 1;
        } else {
            $gst->created_by = 1;
            $gst->created_on = now();
        }
        $data = $gst->getAttributes();
        $redis = $this->setReddis($data, 'businessGst');
        if (!$redis) {
            Log::error('Failed to save in redis businessgst.' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        $gst->save();
        $insert_id = $gst->id;
        if (!$insert_id) {
            Log::error('Failed to save businessGst in pgsql. for ' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['primary_id'] = $insert_id;

        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    function assets(Request $request){
        $asset = Asset::firstOrNew(['id'=> $request->assets_id]);
        $asset->b_id         = $request->business_id;
        $asset->a_type       = $request->type;
        $asset->a_sub_type   = $request->sub_type;
        $asset->a_usage_type = $request->usage_type;
        $asset->a_category   = $request->category;
        $asset->pincode      = $request->pincode;
         // static
         if (Asset::where('id', '=', $request->assets_id)->count() > 0) {
            $asset->modified_on = now();
            $asset->modified_by = 1;
        } else {
            $asset->created_by = 1;
            $asset->created_on = now();
        }
       
        $data = $asset->getAttributes();
        $redis = $this->setReddis($data, 'businessAsset');
        if (!$redis) {
            Log::error('Failed to save in redis asset.' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        $asset->save();
        $insert_id = $asset->id;
        if (!$insert_id) {
            Log::error('Failed to save Asset in pgsql. for ' . $request->business_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['primary_id'] = $insert_id;

        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    function getAssetsDetails(Request $request){

        if($request->has('enable')){

          $data = Asset::where('b_id', $request->business_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = Asset::where('b_id', $request->business_id)->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    function getAssetsDetailsbyRowid(Request $request){
        $data = Asset::where('id', $request->row_id)->get();
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    
    function addpromotorinfo(Request $request){
        $promotor =Promotorinfo::firstOrNew(['id'=>$request->promotor_id]);
        $address = Comm_address::firstOrNew(['parent_id'=> $request->promotor_id, 'parent_type_id'=>1]);

        $promotor->first_name       = $request->first_name;
        $promotor->last_name        = $request->last_name;
        $promotor->PAN              = $request->PAN;
        $promotor->panname          = $request->panname;
        $promotor->dob              = $request->dob;
        $promotor->nationality_id   = $request->nationality_id;
        $promotor->Mobile           = $request->Mobile;
        $promotor->email            = $request->email;
        $address->add_line_1         = $request->add_line_1;
        $address->add_line_2         = $request->add_line_2;
        $address->pin_id            = $request->pin_id;
        $address->landmark          = $request->landmark;
        $promotor->gender_id        = $request->gender_id;
        $promotor->edu_qual_id      = $request->edu_qual_id;
        $promotor->father_name      = $request->father_name;
        $promotor->mother_name      = $request->mother_name;
        
        // static
        $promotor->modified_by = 1;
               $promotor->record_status    = $request->status;

        $data = $promotor->getAttributes();
        $redis = $this->setReddis($data, 'promotorinfo');
        if (!$redis) {
            Log::error('Failed to save promotor in redis.' . $request->firstname);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
          $promotor->save();
        // static parent_type_id
        $address->parent_id = $request->promotor_id;
        $address->parent_type_id = 1;
         if (Comm_address::where(['parent_id' => $request->promotor_id, 'parent_type_id' => 1])->count() > 0) {
            $address->modified_on = now();
            $address->modified_by = 1;
        } else {
            $address->created_by = 1;
            $address->created_on = now();
        }
        $address->save();
        $insert_id = $promotor->id;
        if (!$insert_id) {
            Log::error('Failed to save promotor in pgsql. for ' . $request->firstname);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $req_id  =  $this->request_table($request);
            if(!empty($request->note_description) && !empty($req_id)){
                $notes = $this->notes($request,$req_id);
            }
        $data['primary_id'] = $insert_id;

        return response()->json([
            "message" => 'Successfuly inserted',
                    "Data"=>$data

        ], 201);
}
function getFinanceParameterDetails(Request $request) {
        if($request->has('enable')){
           $data = DB::table('mstr_finance_parameter')->where('is_active','=',1)->where('enable','=',$request->enable)->orderBy('sort_order')->get();
        }else{
            $data = DB::table('mstr_finance_parameter')->where('is_active','=',1)->orderBy('sort_order')->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }    

    function getLoanDetails(Request $request){
        if($request->has('enable')){

           $loan = Loan::where('b_id', $request->business_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $loan = Loan::where('b_id', $request->business_id)->where('is_active','=',1)->get();
        }
        if(!$loan->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $loan
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    function getLoanRowDetailsByloanid(Request $request){
        $loan = Loan::where('id', $request->row_id)->get();
        if(!$loan->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $loan
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }

    function getGstHeaderDetails(Request $request){
        $gstHeader = GSTHeader::where('b_id', $request->business_id)->get();
        if(!$gstHeader->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $gstHeader
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }
    function getGstHeaderDetailsbyid(Request $request){
        $gstHeader = GSTHeader::where('id', $request->header_id)->get();
        if(!$gstHeader->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $gstHeader
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function addGstDetails(Request $request){
           
       foreach ($request->Calendar_grain as $key => $rows) :
       $gst =GstDetails::firstOrNew(['gst_header_id'=>$request->GST_header_id, 'calendar_grain'=> $rows]);
        $gst->gst_header_id         = $request->GST_header_id;
        $gst->calendar_grain       = $rows;
        if(isset($request->GST_turnover_3b[$key])){
            $gst->gst_turnover_3b   = $request->GST_turnover_3b[$key];
        }
        if(isset($request->GST_paid_3b[$key])){
            $gst->gst_paid_3b   = $request->GST_paid_3b[$key];
        }
         // static
         if (GstDetails::where(['gst_header_id'=>$request->GST_header_id, 'calendar_grain'=> $rows])->count() > 0) {
            $gst->modified_on = now();
            $gst->modified_by = 1;
        } else {
            $gst->created_by = 1;
            $gst->created_on = now();
        }
     $data = $gst->getAttributes();
        $redis = $this->setReddis($data, 'gstdetails');
        if (!$redis) {
            Log::error('Failed to save  gst details in redis.' . $rows->GST_header_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        $gst->save();
        $insert_id = $gst->id;
        if (!$insert_id) {
            Log::error('Failed to save gst details in pgsql. for ' . $rows->GST_header_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        } 
        $data = array_merge($data,array("primary_id" =>$insert_id )) ;
      $res_data[] =$data;
       endforeach;
       return response()->json([
           "message" => 'Successfuly inserted',
           "Data"=>$res_data
       ], 201);
    }

    function getGstDetailsByid(Request $request) {
        if($request->has('enable')){
           $gstHeader = GstDetails::where('gst_header_id', $request->header_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $gstHeader = GstDetails::where('gst_header_id', $request->header_id)->where('is_active','=',1)->get();
        }
        if(!$gstHeader->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $gstHeader
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function addBankingDetails(Request $request){
        foreach ($request->Calendar_grain as $key => $rows) :
       $banking =BankingDetails::firstOrNew(['bank_header_id'=>$request->Bank_header_id, 'calendar_grain'=> $rows]);
         $banking->bank_header_id         = $request->Bank_header_id;
         $banking->calendar_grain         = $rows;
         if(isset($request->Parameter_name[$key])) {
            $banking->parameter_name         = $request->Parameter_name[$key];
        }
        if(isset($request->Parameter_value[$key])) {
            $banking->parameter_value        = $request->Parameter_value[$key];
        }
          // static
          if (BankingDetails::where(['bank_header_id'=>$request->Bank_header_id, 'calendar_grain'=> $rows])->count() > 0) {
            $banking->modified_on = now();
            $banking->modified_by = 1;
        } else {
            $banking->created_by = 1;
            $banking->created_on = now();
        }
                 $banking->record_status = $request->status;

         $data = $banking->getAttributes();
         $redis = $this->setReddis($data, 'Bankingdetails');
         if (!$redis) {
             Log::error('Failed to save  Banking details in redis.' . $rows->Bank_header_id);
             //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
             return response()->json([
                 "message" => 'Failed to save in redis',
             ], 417);
         }
         $banking->save();
         $insert_id = $banking->id;
         if (!$insert_id) {
             Log::error('Failed to save Banking details in pgsql. for ' . $rows->Bank_header_id);
             //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
             return response()->json([
                 "message" => 'Failed to save in pgsql',
             ], 417);
         }
 $req_id  =  $this->request_table($request);
         if(!empty($request->note_description) && !empty($req_id)){
             $notes = $this->notes($request,$req_id);
         }
       $data = array_merge($data,array("primary_id" =>$insert_id )) ;
      $res_data[] =$data;
       endforeach;
       return response()->json([
           "message" => 'Successfuly inserted',
           "Data"=>$res_data
       ], 201);
     }

     function getBankDetailsByid(Request $request) {
        if($request->has('enable')){
          $data = BankingDetails::where('bank_header_id', $request->header_id)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = BankingDetails::where('bank_header_id', $request->header_id)->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }


    function getMastertableDetails(Request $request)
    {
        if($request->has('enable')){
            $data = DB::table('master_table')
            ->join('main_master', 'main_master.form_id', '=', 'master_table.form_id')
            ->where('main_master.name', '=', $request->type)->where('is_active','=',1)->where('enable','=',$request->enable)
                ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
                ->get();
        }else{
            $data = DB::table('master_table')
            ->join('main_master', 'main_master.form_id', '=', 'master_table.form_id')
            ->where('main_master.name', '=', $request->type)->where('is_active','=',1)
                ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
                ->get();
        }
        if (count($data)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    public function getMastertableDetailsById(Request $request){
        $data = DB::table('master_table')
        ->join('main_master', 'main_master.form_id', '=', 'master_table.form_id')
        ->where('main_master.name', '=', $request->type)->where('master_table.id',$request->master_table_id)
            ->select('master_table.id', 'master_table.name', 'master_table.short_name', 'master_table.description')
            ->get();
        if (!empty($data)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
function getDetailsbyPincode(Request $request){
    if($request->has('enable')){
        $data = DB::table('pin_codes')->where('pincode', '=', $request->pincode)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
    }else{
        $data = DB::table('pin_codes')->where('pincode', '=', $request->pincode)->where('is_active','=',1)->get();
    }     
    if(count($data)>0) {
        return response()->json([
            "message" => 'Data fetched successfully',
            "data"    => $data
        ], 201);
    }
    return response()->json([
        "message" => 'Data not available',
    ], 403);
    }

 function getEntityTypes(Request $request){
    if($request->has('enable')){
        $data = DB::table('entity_types')
            ->select('id','entity','business','sort_order','type','share_percentage','is_active','enable')
            ->where('is_active','=',1)->where('enable','=',$request->enable)
            ->get();
        }else{
            $data = DB::table('entity_types')
            ->select('id','entity','business','sort_order','type','share_percentage','is_active','enable')
            ->where('is_active','=',1)
            ->get();
        }
        if(count($data)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    function setReddis($array,$setname) {
        $redis = Redis::connection();
        $res =  $redis->set($setname, json_encode([
            $array
        ]));
        return $res;
    }

    public function addDocuments(Request $request){
        $addDoc = new Document();
        $addDoc->name                   =   $request->name;
        $addDoc->short_name             =   $request->short_name;
        $addDoc->description            =   $request->description;
        $addDoc->single                 =   $request->single;
        $addDoc->digital_verification   =   $request->digital_verification;
        $addDoc->time_bound             =   $request->time_bound;
        $addDoc->short_order            =   $request->short_order;
        $addDoc->enable                 =   1;
        $addDoc->is_active              =   1;
        $addDoc->created_by             =   1;
        $addDoc->created_on             =   now();
        $addDoc->modified_by            =   1;
        $addDoc->modified_on            =   now();
        $addDoc->save();
        $data['document_id']            = $addDoc->id;
        if($data['document_id']){
            return response()->json([
               "message" => 'Successfuly inserted',
               "Data"=>$data
           ], 201);
        }else{

            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
    } 

    public function editDocuments(Request $request){
        //return $request;
        $update = Document::find($request->document_id);
        $update->name                   =   $request->name;
        $update->short_name             =   $request->short_name;
        $update->description            =   $request->description;
        $update->single                 =   $request->single;
        $update->digital_verification   =   $request->digital_verification;
        $update->time_bound             =   $request->time_bound;
        $update->short_order            =   $request->short_order;
        $update->enable                 =   1;
        $update->is_active              =   1;
        $update->created_by             =   1;
        $update->created_on             =   now();
        $update->modified_by            =   1;
        $update->modified_on            =   now();
        $update->save();
        $data['document_id']            = $request->document_id;
        if($data['document_id']){
            return response()->json([
               "message" => 'Successfuly updated',
               "Data"=>$data
           ], 201);
        }else{

            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
    }

    public function getDocuments(Request $request){
        $getDocuments = Document::get();
        if(!empty($getDocuments)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getDocuments
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    public function deleteDocument(Request $request){

        $deleteDoc = Document::find($request->document_id);
        if (!empty($deleteDoc)) {
            $deleteDoc->delete();
            return response()->json([
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function documentAuthorityAddOrEdit(Request $request){
        //return $request->all();
        $docAuth =DocumentAuthority::firstOrNew(['id'=>$request->document_authority_id]);
        $docAuth->name                       = $request->name;
        $docAuth->short_name                 = $request->short_name;
        $docAuth->description                = $request->description;
        $docAuth->state_id                   = $request->state_id;
        $docAuth->city_id                    = $request->city_id;
        $docAuth->enable                     =   1;
        $docAuth->is_active                  =   1;
        if (DocumentAuthority::where('id',$request->document_authority_id)->count()>0) {
            $docAuth->modified_on = now();
            $docAuth->modified_by = 1;
        } else {
            $docAuth->created_by = 1;
            $docAuth->created_on = now();
        }
        $docAuth->save();
        $insert_id = $docAuth->id;    
        $data = $docAuth->getAttributes();
        $redis = $this->setReddis($data, 'document_authority');
        if (!$redis) {
            Log::error('Failed to save in redis document_authority_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['document_authority_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getDocumentAuthorityById(Request $request){
        $getDocumentAuthority = DocumentAuthority::where('id',$request->document_authority_id)->first();
        if(!empty($getDocumentAuthority)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getDocumentAuthority
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    public function deleteDocumentAuthorityById(Request $request){
        $deleteDocAuth = DocumentAuthority::find($request->document_authority_id);
        if (!empty($deleteDocAuth)) {
            $deleteDocAuth->delete();
            return response()->json([
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function addDocumentMasterData(Request $request){
        //return $request;
        $addDocMaster = new DocumentMaster();
        $addDocMaster->document_id            = $request->document_id;
        $addDocMaster->document_authority_id  = $request->document_authority_id;
        $addDocMaster->sort_order             = $request->sort_order;
        $addDocMaster->enable                 =   1;
        $addDocMaster->is_active              =   1;
        $addDocMaster->created_by             =   1;
        $addDocMaster->created_on             =   now();
        $addDocMaster->modified_by            =   1;
        $addDocMaster->modified_on            =   now();
        $addDocMaster->save();
        $data['document_master_id']           =   $addDocMaster->id;
        if($data['document_master_id']){
            return response()->json([
               "message" => 'Successfuly inserted',
               "Data"=>$data
           ], 201);
        }else{
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
    }
    public function updateDocumentMasterData(Request $request){

        $updateDocMaster = DocumentMaster::find($request->document_master_id);
        $updateDocMaster->document_id            = $request->document_id;
        $updateDocMaster->document_authority_id  = $request->document_authority_id;
        $updateDocMaster->sort_order             = $request->sort_order;
        $updateDocMaster->enable                 =   1;
        $updateDocMaster->is_active              =   1;
        $updateDocMaster->created_by             =   1;
        $updateDocMaster->created_on             =   now();
        $updateDocMaster->modified_by            =   1;
        $updateDocMaster->modified_on            =   now();
        $updateDocMaster->save();
        $data['document_master_id']           =   $updateDocMaster->id;
        if($data['document_master_id']){
            return response()->json([
               "message" => 'Successfuly update',
               "Data"=>$data
           ], 201);
        }else{
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
    }


    public function getDocumentMasterDataById(Request $request){
       $getMasterData          =  DocumentMaster::where('id',$request->document_master_id)->first();
       if (!empty($getMasterData)) {
           $documents              =  Document::where('id',$getMasterData->document_id)->get();
           $documentsAuthority     =  DocumentAuthority::where('id',$getMasterData->document_authority_id)->get();
           $data['document_master_id'] = $getMasterData->id;
           $data['document_data'] = $documents;
           $data['documentsAuthority'] = $documentsAuthority;
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 
    }

    public function assetCategory(Request $request){
        $assetCat =AssetCategory::firstOrNew(['id'=>$request->asset_category_id]);
        $assetCat->name = $request->name;
        $assetCat->short_name = $request->short_name;
        $assetCat->description = $request->description;
        $assetCat->asset_type_id = $request->asset_type_id;
        $assetCat->sort_order             = $request->sort_order;
        $assetCat->enable                 =   1;
        $assetCat->is_active              =   1;
        $assetCat->save();
        $insert_id = $assetCat->id;
        if (!empty($request->asset_category_id)) {
            $assetCat->modified_on = now();
            $assetCat->modified_by = 1;
        } else {
            $assetCat->created_by = 1;
            $assetCat->created_on = now();
        }
        $data = $assetCat->getAttributes();
        $redis = $this->setReddis($data, 'asset_category');
        if (!$redis) {
            Log::error('Failed to save in redis asset Category.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['asset_category_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getAssetCategoryById(Request $request){

       $getAssetCategory =  AssetCategory::where('id',$request->asset_category_id)->first();
       if (!empty($getAssetCategory)) {
           
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getAssetCategory
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 
    }
    public function assetSize(Request $request){
        //return $assetSize =AssetSize::get();
        $assetSize =AssetSize::firstOrNew(['id'=>$request->asset_size_id]);
        $assetSize->name = $request->name;
        $assetSize->short_name = $request->short_name;
        $assetSize->description = $request->description;
        $assetSize->asset_type_id = $request->asset_type_id;
        $assetSize->sort_order             = $request->sort_order;
        $assetSize->enable                 =   1;
        $assetSize->is_active              =   1;
        if (!empty($request->asset_size_id)) {
            $assetSize->modified_on = now();
            $assetSize->modified_by = 1;
        } else {
            $assetSize->created_by = 1;
            $assetSize->created_on = now();
        }
        $assetSize->save();
        $insert_id = $assetSize->id;
        $data = $assetSize->getAttributes();
        $redis = $this->setReddis($data, 'assetSize');
        if (!$redis) {
            Log::error('Failed to save in redis asset Size Id.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['asset_size_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAssetSizeById(Request $request){

      $getSizeCategory =  AssetSize::where('id',$request->asset_size_id)->first();
       if (!empty($getSizeCategory)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getSizeCategory
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 

    }
    public function assetSubCategory(Request $request){
        $assetSubCategory =AssetSubCategory::firstOrNew(['id'=>$request->asset_sub_cat_id]);
        $assetSubCategory->name = $request->name;
        $assetSubCategory->short_name = $request->short_name;
        $assetSubCategory->description = $request->description;
        $assetSubCategory->asset_type_id = $request->asset_type_id;
        $assetSubCategory->sort_order             = $request->sort_order;
        $assetSubCategory->enable                 =   1;
        $assetSubCategory->is_active              =   1;
        if (!empty($request->asset_sub_cat_id)) {
            $assetSubCategory->modified_on = now();
            $assetSubCategory->modified_by = 1;
        } else {
            $assetSubCategory->created_by = 1;
            $assetSubCategory->created_on = now();
        }
        $assetSubCategory->save();
        $insert_id = $assetSubCategory->id;
        $data = $assetSubCategory->getAttributes();
        $redis = $this->setReddis($data, 'assetSubCategory');
        if (!$redis) {
            Log::error('Failed to save in redis asset Sub Category Id.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['asset_sub_cat_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAssetSubCategoryById(Request $request){

      $getAssetSubCategory =  AssetSubCategory::where('id',$request->asset_sub_cat_id)->first();
       if (!empty($getAssetSubCategory)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getAssetSubCategory
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 
    }
    public function AssetUsageType(Request $request){
        $assetUsage =AssetUsageType::firstOrNew(['id'=>$request->asset_usage_id]);
        $assetUsage->name = $request->name;
        $assetUsage->short_name = $request->short_name;
        $assetUsage->description = $request->description;
        $assetUsage->asset_type_id = $request->asset_type_id;
        $assetUsage->sort_order             = $request->sort_order;
        $assetUsage->enable                 =   1;
        $assetUsage->is_active              =   1;
        if (!empty($request->asset_usage_id)) {
            $assetUsage->modified_on = now();
            $assetUsage->modified_by = 1;
        } else {
            $assetUsage->created_by = 1;
            $assetUsage->created_on = now();
        }
        $assetUsage->save();
        $insert_id = $assetUsage->id;
        $data = $assetUsage->getAttributes();
        $redis = $this->setReddis($data, 'AssetUsageType');
        if (!$redis) {
            Log::error('Failed to save in redis asset usage Id.' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['asset_usage_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAssetUsageTypeById(Request $request){

       $getAssetUsage =  AssetUsageType::where('id',$request->asset_usage_type_id)->first();
       if (!empty($getAssetUsage)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getAssetUsage
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 

    }
    public function addbankingParameters(Request $request){
        $assetSize =Banking_parameter::firstOrNew(['id'=>$request->banking_parameters_id]);
        $assetSize->name = $request->name;
        $assetSize->short_name = $request->short_name;
        $assetSize->description = $request->description;
        $assetSize->level = $request->level;
        $assetSize->sort_order             = $request->sort_order;
        $assetSize->enable                 =   1;
        $assetSize->is_active              =   1;
        if (Banking_parameter::where('id',$request->banking_parameters_id)->count()>0) {
            $assetSize->modified_on = now();
            $assetSize->modified_by = 1;
        } else {
            $assetSize->created_by = 1;
            $assetSize->created_on = now();
        }
        $assetSize->save();
        $insert_id = $assetSize->id;    
        $data = $assetSize->getAttributes();
        $redis = $this->setReddis($data, 'bankingParameters');
        if (!$redis) {
            Log::error('Failed to save in redis banking_parameters_id .' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['banking_parameters_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getbankingParametersById(Request $request){
        $bankingParameters =  Banking_parameter::where('id',$request->get_banking_parameter_id)->first();
       if (!empty($bankingParameters)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $bankingParameters
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 
    }
    public function addIndustrySegment(Request $request){

        $addSegment =Industry_segment::firstOrNew(['id'=>$request->industry_segment_id]);
        $addSegment->name = $request->name;
        $addSegment->short_name = $request->short_name;
        $addSegment->description = $request->description;
        $addSegment->sort_order             = $request->sort_order;
        $addSegment->enable                 =   1;
        $addSegment->is_active              =   1;
        if (Industry_segment::where('id',$request->industry_segment_id)->count()>0) {
            $addSegment->modified_on = now();
            $addSegment->modified_by = 1;
        } else {
            $addSegment->created_by = 1;
            $addSegment->created_on = now();
        }
        $addSegment->save();
        $insert_id = $addSegment->id;    
        $data = $addSegment->getAttributes();
        $redis = $this->setReddis($data, 'asset_category');
        if (!$redis) {
            Log::error('Failed to save in redis industry_segment_id .' . $insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['industry_segment_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getIndustrySegmentById(Request $request){

    $getIndustrySegmentById =  Industry_segment::where('id',$request->industry_segment_id)->first();
       if (!empty($getIndustrySegmentById)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getIndustrySegmentById
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 
    }
    public function loanType(Request $request){
        $loanType =LoanType::firstOrNew(['id'=>$request->loan_type_id]);
        $loanType->name                       = $request->name;
        $loanType->short_name                 = $request->short_name;
        $loanType->description                = $request->description;
        $loanType->product_type_id            = $request->product_type_id;
        $loanType->sort_order                 = $request->sort_order;
        $loanType->enable                     =   1;
        $loanType->is_active                  =   1;
        if (LoanType::where('id',$request->loan_type_id)->count()>0) {
            $loanType->modified_on = now();
            $loanType->modified_by = 1;
        } else {
            $loanType->created_by = 1;
            $loanType->created_on = now();
        }
        $loanType->save();
        $insert_id = $loanType->id;    
        $data = $loanType->getAttributes();
        $redis = $this->setReddis($data, 'loanType');
        if (!$redis) {
            Log::error('Failed to save in redis loan_type_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['loan_type_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getAllloanType(Request $request){
        if($request->has('enable')){
           $getloanType =  LoanType::where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $getloanType =  LoanType::where('is_active','=',1)->get();
        }
       if (count($getloanType)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getloanType
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        } 

    }

    public function getAllPromotorInfos(Request $request){
        if($request->has('enable')){
            $getpromotor = Promotorinfo::where('is_active','=',1)->where('enable','=',$request->enable)->get();

        }else{
            $getpromotor = Promotorinfo::where('is_active','=',1)->get();
        }
        if(count($getpromotor)>0){
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getpromotor
            ], 201);  
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    
    public function addProduct(Request $request){

        $addProducts =Product::firstOrNew(['id'=>$request->product_id]);
        $addProducts->name                       = $request->name;
        $addProducts->description                = $request->description;
        $addProducts->financier_id               = $request->financier_id;
        $addProducts->sort_order                 = $request->sort_order;
        $addProducts->enable                     =   1;
        $addProducts->is_active                  =   1;
        if (Product::where('id',$request->product_id)->count()>0) {
            $addProducts->modified_on = now();
            $addProducts->modified_by = 1;
        } else {
            $addProducts->created_by = 1;
            $addProducts->created_on = now();
        }
        $addProducts->save();
        $insert_id = $addProducts->id;    
        $data = $addProducts->getAttributes();
        $redis = $this->setReddis($data, 'addProducts');
        if (!$redis) {
            Log::error('Failed to save in redis product_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['product_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getProductById(Request $request){
       $getProductById =  Product::where('id',$request->product_id)->first();
       if (!empty($getProductById)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getProductById
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function addFinancier(Request $request){
        $addFinancier =Financier::firstOrNew(['id'=>$request->financier_id]);
        $addFinancier->name                       = $request->name;
        $addFinancier->short_name                 = $request->short_name;
        $addFinancier->description                = $request->description;
        $addFinancier->category                   = $request->category;
        $addFinancier->sort_order                 = $request->sort_order;
        $addFinancier->enable                     =   1;
        $addFinancier->is_active                  =   1;
        if (Financier::where('id',$request->financier_id)->count()>0) {
            $addFinancier->modified_on = now();
            $addFinancier->modified_by = 1;
        } else {
            $addFinancier->created_by = 1;
            $addFinancier->created_on = now();
        }
        $addFinancier->save();
        $insert_id = $addFinancier->id;    
        $data = $addFinancier->getAttributes();
        $redis = $this->setReddis($data, 'addFinancier');
        if (!$redis) {
            Log::error('Failed to save in redis financier_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['financier_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getFinancierById(Request $request){
       $getFinancierById =  Financier::where('id',$request->financier_id)->first();
       if (!empty($getFinancierById)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getFinancierById
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function documentListAddOrUpdate(Request $request){
        $DocumentList =DocumentList::firstOrNew(['id'=>$request->document_list_id]);
        $DocumentList->name                       = $request->name;
        $DocumentList->short_name                 = $request->short_name;
        $DocumentList->description                = $request->description;
        $DocumentList->sort_order                 = $request->sort_order;
        $DocumentList->enable                     =   1;
        $DocumentList->is_active                  =   1;
        if (DocumentList::where('id',$request->document_list_id)->count()>0) {
            $DocumentList->modified_on = now();
            $DocumentList->modified_by = 1;
        } else {
            $DocumentList->created_by = 1;
            $DocumentList->created_on = now();
        }
        $DocumentList->save();
        $insert_id = $DocumentList->id;    
        $data = $DocumentList->getAttributes();
        $redis = $this->setReddis($data, 'DocumentList');
        if (!$redis) {
            Log::error('Failed to save in redis Document List id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['document_list_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getdocumentListById(Request $request){
        $getdocument_listById =  DocumentList::where('id',$request->document_list_id)->first();
       if (!empty($getdocument_listById)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getdocument_listById
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function nationalityAddOrEdit(Request $request){
        $addoreditNatinality =Nationality::firstOrNew(['id'=>$request->nationality_id]);
        $addoreditNatinality->country                       = $request->country;
        $addoreditNatinality->alpha_2_code                 = $request->alpha_2_code;
        $addoreditNatinality->alpha_3_code                = $request->alpha_3_code;
        $addoreditNatinality->sort_order                 = $request->sort_order;
        $addoreditNatinality->country_code                =$request->country_code;
        $addoreditNatinality->currency                   =$request->currency;
        $addoreditNatinality->enable                     =   1;
        $addoreditNatinality->is_active                  =   1;
        if (Nationality::where('id',$request->nationality_id)->count()>0) {
            $addoreditNatinality->modified_on = now();
            $addoreditNatinality->modified_by = 1;
        } else {
            $addoreditNatinality->created_by = 1;
            $addoreditNatinality->created_on = now();
        }
        
        $addoreditNatinality->save();
        $insert_id = $addoreditNatinality->id;    
        $data = $addoreditNatinality->getAttributes();
        $redis = $this->setReddis($data, 'addoreditNatinality');
        if (!$redis) {
            Log::error('Failed to save in redis Natinality id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['nationality_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAllnationality(Request $request){
        if($request->has('enable')){
           $data = DB::table('nationality')->where('is_active','=',1)->where('enable','=',$request->enable)->skip($request->startlimit)->take($request->endlimit)->orderBy('sort_order')->get();
        }else{
            $data = DB::table('nationality')->where('is_active','=',1)->skip($request->startlimit)->take($request->endlimit)->orderBy('sort_order')->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    public function getNationalityById(Request $request){
        $nationality =  Nationality::where('id',$request->id)->first();
       if (!empty($nationality)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $nationality
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function getCurrencyByCountryCode(Request $request){
        $currency = Nationality::where('country_code',$request->country_code)->first();
            if(!empty($currency)) {
                return response()->json([
                "message" =>'Data fetched successfully',
                "data"=> $currency
                ], 201);
                }else{
                return response()->json([
                    "message" => 'Data not available', 
                    ], 403);
                }   
            }
    

     public function getAllCountrycode(Request $request){
         return Nationality::all();
     }

    public function bankAddOrEdit(Request $request){
        $bankAddOrEdit =Bank::firstOrNew(['id'=>$request->bank_id]);
        $bankAddOrEdit->name                       =   $request->name;
        $bankAddOrEdit->short_name                 =   $request->short_name;
        $bankAddOrEdit->description                =   $request->description;
        $bankAddOrEdit->category                   =   $request->category;
        $bankAddOrEdit->financier_flag             =   $request->financier_flag;
        $bankAddOrEdit->enable                     =   $request->enable;
        $bankAddOrEdit->sort_order                 =   $request->sort_order;
        $bankAddOrEdit->is_active                  =   $request->is_active;
        if (Bank::where('id',$request->bank_id)->count()>0) {
            $bankAddOrEdit->modified_on = now();
            $bankAddOrEdit->modified_by = 1;
        } else {
            $bankAddOrEdit->created_by = 1;
            $bankAddOrEdit->created_on = now();
        }
        $bankAddOrEdit->save();
        $insert_id = $bankAddOrEdit->id;    
        $data = $bankAddOrEdit->getAttributes();
        $redis = $this->setReddis($data, 'bankAddOrEdit');
        if (!$redis) {
            Log::error('Failed to save in redis bank_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['bank_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getAllbank(Request $request){
        if($request->has('enable')){
            $data = DB::table('bank')->where('financier_flag',1)->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('bank')->where('financier_flag',1)->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    public function getBankById(Request $request){
       $bankdata =  Bank::where('id',$request->bank_id)->first();
       if (!empty($bankdata)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $bankdata
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function deleteBankById(Request $request){
        $disabledBank = Bank::find($request->bank_id);
        $disabledBank->is_active  = 0;
        $disabledBank->save();
        if (!empty($disabledBank)) {
            return response()->json([
                "message" => 'Deleted successfully',
            ], 201);
        }else{
            return response()->json([
                "message" => 'Failed to delete',
            ], 403);
        }
    }
    public function cityAddOrEdit(Request $request){

        $addOrUpdateCity =City::firstOrNew(['id'=>$request->city_id]);
        $addOrUpdateCity->city                       =   $request->city;
        $addOrUpdateCity->gst_id                     =   $request->gst_id;
        $addOrUpdateCity->tier                       =   $request->tier;
        $addOrUpdateCity->hra_classification         =   $request->hra_classification;
        $addOrUpdateCity->enable                     =   $request->enable;
        $addOrUpdateCity->sort_order                 =   $request->sort_order;
        $addOrUpdateCity->is_active                  =   $request->is_active;
        if (City::where('id',$request->city_id)->count()>0) {
            $addOrUpdateCity->modified_on = now();
            $addOrUpdateCity->modified_by = 1;
        } else {
            $addOrUpdateCity->created_by = 1;
            $addOrUpdateCity->created_on = now();
        }
        $addOrUpdateCity->save();
        $insert_id = $addOrUpdateCity->id;    
        $data = $addOrUpdateCity->getAttributes();
        $redis = $this->setReddis($data, 'addOrUpdateCity');
        if (!$redis) {
            Log::error('Failed to save in redis city_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['city_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAllCity(Request $request){
        if($request->has('enable')){
            $data = DB::table('city')->where('is_active','=',1)->where('enable','=',$request->enable)->orderBy('sort_order')->get();
        }else{
            $data = DB::table('city')->where('is_active','=',1)->orderBy('sort_order')->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    public function getCityById(Request $request){
        $getCity =  City::where('id',$request->city_id)->first();
       if (!empty($getCity)) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $getCity
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function deleteCityById(Request $request){
        $disabledCity = City::find($request->city_id);
        $disabledCity->is_active  = 0;
        $disabledCity->save();
        if (!empty($disabledCity)) {
            return response()->json([
                "message" => 'Deleted successfully',
            ], 201);
        }else{
            return response()->json([
                "message" => 'Failed to delete',
            ], 403);
        }
    }
    public function industryNamesAddOrEdit(Request $request){
        $industry_name =IndustryNames::firstOrNew(['id'=>$request->industry_name_id]);
        $industry_name->name                           =   $request->name;
        $industry_name->industry_group_id               =   $request->industry_group_id;
        $industry_name->enable                         =   $request->enable;
        $industry_name->sort_order                     =   $request->sort_order;
        $industry_name->is_active                      =   $request->is_active;
        if (IndustryNames::where('id',$request->industry_name_id)->count()>0) {
            $industry_name->modified_on = now();
            $industry_name->modified_by = 1;
        } else {
            $industry_name->created_by = 1;
            $industry_name->created_on = now();
        }
        $industry_name->save();
        $insert_id = $industry_name->id;    
        $data = $industry_name->getAttributes();
        $redis = $this->setReddis($data, 'industry_name');
        if (!$redis) {
            Log::error('Failed to save in redis city_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['industry_name_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }

    public function getAllIndustryNames(Request $request){
    if($request->has('enable')){

      $industry_name =  DB::table('industry_names')
      ->join('industry_group', 'industry_group.id', '=', 'industry_names.industry_group_id')
      ->select('industry_names.id', 'industry_names.name', 'industry_names.industry_group_id', 'industry_names.sort_order','industry_names.enable','industry_names.is_active')
      ->where('industry_names.is_active','=',1)->where('industry_names.enable','=',$request->enable)
      ->get();

    }else{

        $industry_name =  DB::table('industry_names')
      ->join('industry_group', 'industry_group.id', '=', 'industry_names.industry_group_id')
      ->select('industry_names.id', 'industry_names.name', 'industry_names.industry_group_id', 'industry_names.sort_order','industry_names.enable','industry_names.is_active')
      ->where('industry_names.is_active','=',1)
      ->get();
    }
       if (count($industry_name)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $industry_name
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function industryGroupAddOrEdit(Request $request){
        $industrygroup =IndustryGroup::firstOrNew(['id'=>$request->industry_group_id]);
        $industrygroup->name                           =   $request->name;
        $industrygroup->industry_type_id               =   $request->industry_type_id;
        $industrygroup->enable                         =   $request->enable;
        $industrygroup->sort_order                     =   $request->sort_order;
        $industrygroup->is_active                      =   $request->is_active;
        if (IndustryGroup::where('id',$request->industry_group_id)->count()>0) {
            $industrygroup->modified_on = now();
            $industrygroup->modified_by = 1;
        } else {
            $industrygroup->created_by = 1;
            $industrygroup->created_on = now();
        }
        $industrygroup->save();
        $insert_id = $industrygroup->id;    
        $data = $industrygroup->getAttributes();
        $redis = $this->setReddis($data, 'industrygroup');
        if (!$redis) {
            Log::error('Failed to save in redis industry_group_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['industry_group_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }
    public function getAllIndustryGroup(Request $request){
        if($request->has('enable')){
         $industry_group = DB::table('industry_group')
            ->join('master_table', 'master_table.id', '=', 'industry_group.industry_type_id')
            ->select('industry_group.id', 'industry_group.name', 'industry_group.industry_type_id', 'industry_group.sort_order','industry_group.enable','industry_group.is_active')
            ->where('industry_group.is_active','=',1)->where('industry_group.enable','=',$request->enable)
            ->get();
        }else{

            $industry_group = DB::table('industry_group')
            ->join('master_table', 'master_table.id', '=', 'industry_group.industry_type_id')
            ->select('industry_group.id', 'industry_group.name', 'industry_group.industry_type_id', 'industry_group.sort_order','industry_group.enable','industry_group.is_active')
            ->where('industry_group.is_active','=',1)
            ->get();
        }
       if (count($industry_group)>0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $industry_group
            ], 201);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function deleteIndustryNames(Request $request){
        $deleteName = IndustryNames::find($request->industry_name_id);
        if (!empty($deleteName)) {
            $deleteName->is_active=0;
            $deleteName->save();
            return response()->json([
                "message" => 'Deleted successfully',
            ], 200);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
        
    }
    public function deleteIndustryGroup(Request $request){
        $deleteIndustryGroup = IndustryGroup::find($request->industry_group_id);
        if (!empty($deleteIndustryGroup)) {
            $deleteIndustryGroup->delete();
            return response()->json([
                "message" => 'Deleted successfully',
            ], 200);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function generalSettingAddOrEdit(Request $request){
        
        $generalSetting =GeneralSetting::firstOrNew(['id'=>$request->general_setting_id]);
        $generalSetting->parameter_name                 =   $request->parameter_name;
        $generalSetting->parameter_value                =   $request->parameter_value;
        $generalSetting->enable                         =   $request->enable;
        $generalSetting->is_active                      =   $request->is_active;
        if (GeneralSetting::where('id',$request->general_setting_id)->count()>0) {
            $generalSetting->modified_on = now();
            $generalSetting->modified_by = 1;
        } else {
            $generalSetting->created_by = 1;
            $generalSetting->created_on = now();
        }
        $generalSetting->save();
        $insert_id = $generalSetting->id;    
        $data = $generalSetting->getAttributes();
        $redis = $this->setReddis($data, 'generalSetting');
        if (!$redis) {
            Log::error('Failed to save in redis general_setting_id .' . $insert_id);
            return response()->json([
                "message" => 'Failed to save in redis',
            ], 417);
        }
        if (!$insert_id) {
            return response()->json([
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['general_setting_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$data
        ], 201);
    }


    public function getAllGeneralSetting(Request $request){
        if($request->has('enable')){
            $data = GeneralSetting::where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = GeneralSetting::where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    public function deleteGeneralSetting(Request $request){
        $deleteGeneralSetting = GeneralSetting::find($request->general_setting_id);
        if (!empty($deleteGeneralSetting)) {
            $deleteGeneralSetting->is_active = 0;
            $deleteGeneralSetting->save();
            return response()->json([
                "message" => 'Deleted successfully',
            ], 200);
       }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }
    public function myTestAddToLog()
    {
        //\LogActivity::addToLog('getAllbusinessInfos',$request->user_id);
        \LogActivity::addToLog('My Testing Add To Log.');
        dd('log insert successfully.');
    }


    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function logActivity()
    {
        //return $logs = \LogActivity::logActivityLists();
      return "test";
    }
    

    function getAllWorkingCapitalDetails(Request $request) {
   
        if($request->has('enable')){
            $data = DB::table('working_capital')->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('working_capital')->where('is_active','=',1)->get();
        }
        
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);

    }

    public function deleteworkingcapital(Request $request){

        $deleteDoc = WorkingCaptial::find($request->working_capital_id);
        if (!empty($deleteDoc)) {
            $deleteDoc->delete();
            return response()->json([
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function deletebusinessinfo(Request $request){

        $deleteDoc = BusinessInfo::find($request->bus_id);
        if (!empty($deleteDoc)) {
            $deleteDoc->delete();
            return response()->json([
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }

    public function deletepromotorinfo(Request $request){

        $deleteDoc = Promotorinfo::find($request->promotor_id);
        if (!empty($deleteDoc)) {
            $deleteDoc->delete();
            return response()->json([
                "message" => 'Data deleted successfully'
            ], 201);
        }else{
            return response()->json([
                "message" => 'Data not available',
            ], 403);
        }
    }




}
