<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Employee_onboarding;
use App\Bankstaff_onboarding;
use App\Comm_address;
use App\Comm_phone_email;
use App\Dsa_onboarding_profile ;
use App\DsaOnboarding;
use App\Employeapprovalworkflow;
use App\Employee_approval_dsa_bank;
use App\MainMaster;
use App\Mastertable;
use App\PinBanking;
use App\PinBusiness;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Redis;
use Jenssegers\Mongodb\Eloquent\Model as Eloquent;


class Onboarding extends Controller
{
    function emplyeeOnboardingAddOrEdit(Request $request)
    {
        $employee                 = Employee_onboarding::firstOrNew(['id' => $request->primary_id]);
        $employee->first_name     = $request->first_name;
        $employee->middle_name    = $request->middle_name;
        $employee->last_name      = $request->last_name;
        $employee->dob            = $request->dob;
        $employee->gender_id      = $request->gender_id;
        $employee->pan            = $request->pan;
        $employee->nationality_id = $request->nationality_id;
        $employee->father_name    = $request->father_name;
        if(!empty($request->primary_id)) {
            $employee->modified_by = 1;
            $employee->modified_on = now();
        } else {
            $employee->created_by = 1;
            $employee->created_on = now();
        }
        $employeeinfoarray = $employee->getAttributes();
        $redis = $this->setReddis($employeeinfoarray, 'employeeOnboarding');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" =>null
            ], 417);
        }
        $employee->save();
        $insert_id = $employee->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->first_name . ' ' . $request->dob);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" =>null
            ], 417);
        }
        $com_phone_email = $this->comm_phone($request->email,$request->mobile,$request->parent_type_id,$insert_id );

         $employeeinfoarray['primary_id'] = $insert_id;

         return response()->json([
            "message" => 'Successfuly inserted',
            "Data"=>$employeeinfoarray
        ], 201);

    }
function bankstaffOnboardingadd(Request $request){
    $employee                 = Bankstaff_onboarding::firstOrNew(['id' => $request->primary_id]);
    $employee->first_name     = $request->first_name;
    $employee->last_name      = $request->last_name;
    $employee->bank_id        = $request->bank_id;
    $employee->ifsc           = $request->ifsc;

    if(!empty($request->primary_id)) {
        $employee->modified_by = 1;
        $employee->modified_on = now();
    } else {
        $employee->created_by = 1;
        $employee->created_on = now();
    }
    $employeeinfoarray = $employee->getAttributes();
    $redis = $this->setReddis($employeeinfoarray, 'bankStaffOnboarding');
    if (!$redis) {
        Log::error('Failed to save in redis.');
        //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
        return response()->json([
            "message" => 'Failed to save in redis',
            "id" =>null
        ], 417);
    }
    $employee->save();
    $insert_id = $employee->id;
    if (!$insert_id) {
        Log::error('Failed to save in pgsql. for ' . $request->first_name . ' ' . $request->last_name);
        //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
        return response()->json([
            "message" => 'Failed to save in pgsql',
            "id" =>null
        ], 417);
    }
    $com_phone_email = $this->comm_phone($request->email,$request->mobile,$request->parent_type_id,$insert_id );
    $employeeinfoarray['primary_id'] = $insert_id;
    return response()->json([
       "message" => 'Successfuly inserted',
       "Data"=>$employeeinfoarray
   ], 201);
}

    function dsaOnboardingAddOrEdit(Request $request)
    {
        //  echo "<pre>";print_r($_FILES['employee_profile']);exit;
        //  $user = Employee_onboarding_profile::find('5f3a205c2746c13ce5422354');
        //  $doc = base64_decode(file_get_contents($user->file)); 
        // echo "<pre>";print_r($doc);exit;

        // static parent_type_id
        $employee                 = DsaOnboarding::firstOrNew(['id' => $request->primary_id]);
        $employee->first_name     = $request->first_name;
        $employee->last_name      = $request->last_name;
        $employee->dob            = $request->dob;
        $employee->gender_id      = $request->gender_id;
        $employee->pan            = $request->pan;
        // $employee->city_id            = $request->city_id;
        // $employee->state_id            = $request->state_id;
        $employee->nationality_id = $request->nationality_id;
        $employee->father_name    = $request->father_name;
        $employee->edu_qual_id    = $request->edu_qual_id;

        if (!empty($request->primary_id)) {
            $employee->modified_by = 1;
            $employee->modified_on = now();
        } else {
            $employee->created_by = 1;
            $employee->created_on = now();
        }
        $employeeinfoarray = $employee->getAttributes();
        $redis = $this->setReddis($employeeinfoarray, 'employeeOnboarding');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $employee->save();
        $insert_id = $employee->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->first_name . ' ' . $request->dob);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }

        if ($request->file()) {
            $image = base64_encode(file_get_contents($_FILES['dsa_profile']['tmp_name']));
            $name = $_FILES['dsa_profile']['name'];
            $insert['name'] = "$name";
            $insert['file'] = "$image";
            $insert['emp_id'] = $insert_id;
            $mongo_id = Dsa_onboarding_profile::insertGetId($insert);
            //  $user = Employee_onboarding_profile::find($mongo_id);
            //   $doc = base64_decode($user->file); 
            //  echo "<pre>";print_r($doc);exit;     
            if (!$mongo_id) {
                Log::error('Failed to save File In mongodb.' . $insert_id);
                //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
                return response()->json([
                    "message" => 'Failed to save File In mongodb',
                    "id" => null
                ], 417);
            }
            DB::table('dsa_onboarding')
            ->where('id', $insert_id)
                ->update(['add_proof_id' => $mongo_id]);
        }

        $com_phone_email = $this->comm_phone($request->email,$request->mobile,$request->parent_type_id,$insert_id );
        $com_addres = $this->comm_address($request->address1,$request->address2,$request->pincode,$request->area,$request->parent_type_id,$insert_id );
        $employeeinfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $employeeinfoarray
        ], 201);
    }

    function comm_address($address1, $address2,$pincode,$area, $parent_type_id, $parent_id) {
        $address =Comm_address::firstOrNew(['parent_id'=>$parent_id, 'parent_type_id'=>$parent_type_id]);
        $address->add_line_1         = $address1;
        $address->add_line_2         = $address2;
        $address->pin_id            = $pincode;
        $address->landmark          = $area;
        $address->save();
        return $address->id;

    }

    function comm_phone($email, $phone,$parent_type_id, $parent_id) {
       $phone_email =Comm_phone_email::firstOrNew(['parent_id'=>$parent_id, 'parent_type_id'=>$parent_type_id]);
       $phone_email->contact_type = true;
       $phone_email->contact_value =$email;
       $phone_email->contact_type = false;
       $phone_email->contact_value =$phone;
       $phone_email->parent_type_id =$parent_type_id;
       $phone_email->parent_id =$parent_id;
        if (Comm_phone_email::where(['parent_id' => $parent_id, 'parent_type_id' => $parent_type_id])->count() > 0) {
            $phone_email->modified_on = now();
            $phone_email->modified_by = 1;
        } else {
            $phone_email->created_by = 1;
            $phone_email->created_on = now();
        }
        $phone_email->save();
        return $phone_email->id;
    }

    function getpinbanking(Request $request) {
    if($request->has('enable')){
        $data = DB::table('pin_bank_mapping')
        ->join('pin_codes', 'pin_codes.id', '=', 'pin_bank_mapping.pincode_id')
        ->select('pin_bank_mapping.*', 'pin_codes.area', 'pin_codes.locality')
        ->where('pin_bank_mapping.is_active', 1)->where('pin_bank_mapping.enable', $request->enable)->orderBy('id','desc')
        ->get();
    }else{
        $data = DB::table('pin_bank_mapping')
        ->join('pin_codes', 'pin_codes.id', '=', 'pin_bank_mapping.pincode_id')
        ->select('pin_bank_mapping.*', 'pin_codes.area', 'pin_codes.locality')
        ->where('pin_bank_mapping.is_active', 1)->orderBy('id','desc')
        ->get();
    }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function pinbankingadd(Request $request)
    {
        $banking = PinBanking::firstOrNew(['id' => $request->primary_id]);
        $banking->bank_id = $request->bank_id;
        $banking->is_active = 1;
        $banking->ifsc_id = $request->ifsc_id;
        $banking->pincode_id = $request->pincode_id;
        if (!empty($request->primary_id)) {
            $banking->modified_by = 1;
            $banking->modified_on = now();
        } else {
            $banking->created_by = 1;
            $banking->created_on = now();
        }
        $bankinginfoarray = $banking->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'Pinbanking');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $banking->save();
        $insert_id = $banking->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->bank_id . ' ' . $request->ifsc_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
    }

    function getpinbusiness(Request $request) {
       if($request->has('enable')){
            $data = DB::table('pin_business_channel_mapping AS pbcm')
             ->join('pin_codes', 'pin_codes.id', '=', 'pbcm.pincode_id')
            ->where('pbcm.is_active', 1)->where('pbcm.enable', $request->enable)->orderBy('id','desc')
            ->select('pbcm.*', 'pin_codes.area', 'pin_codes.locality')
            ->get();
        }else{
            $data = DB::table('pin_business_channel_mapping AS pbcm')
             ->join('pin_codes', 'pin_codes.id', '=', 'pbcm.pincode_id')
            ->where('pbcm.is_active', 1)->orderBy('id','desc')
            ->select('pbcm.*', 'pin_codes.area', 'pin_codes.locality')
            ->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function pinbusinessadd(Request $request)
    {
        $banking = PinBusiness::firstOrNew(['id' => $request->primary_id]);
        $banking->partner_id = $request->partner_id;
        $banking->pincode_id = $request->pincode_id;
        if (!empty($request->primary_id)) {
            $banking->modified_by = 1;
            $banking->modified_on = now();
        } else {
            $banking->created_by = 1;
            $banking->created_on = now();
        }
        $bankinginfoarray = $banking->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'PinBusiness');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $banking->save();
        $insert_id = $banking->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->partner_id . ' ' . $request->pincode_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
    }
    function getEmployeeApprovalWorkflow(Request $request) {
        if($request->has('enable')){
            $data = DB::table('employee_approval_workflow')->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('employee_approval_workflow')->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }
    function employeeapprovalworkflowAddOrEdit(Request $request)
    {
        $banking = Employeapprovalworkflow::firstOrNew(['id' => $request->primary_id]);
        $banking->employee_onboarding_id = $request->employee_onboarding_id;
        $banking->joining_date = $request->joining_date;
        $banking->role = $request->role;
        $banking->approval_date = $request->approval_date;
        if (!empty($request->primary_id)) {
            $banking->modified_by = 1;
            $banking->modified_on = now();
        } else {
            $banking->created_by = 1;
            $banking->created_on = now();
        }
        $bankinginfoarray = $banking->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'employeeworkflow');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $banking->save();
        $insert_id = $banking->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->employee_onboarding_id . ' ' . $request->joining_date);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
    }

    function getEmployeeapprovalDsaBankworkflow(Request $request) {
        
       if($request->has('enable')){
          $data = DB::table('employee_approval_dsa_bank')->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('employee_approval_dsa_bank')->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function employeeapprovalDsaBankworkflowAddOrEdit(Request $request)
    {
        $banking = Employee_approval_dsa_bank::firstOrNew(['id' => $request->primary_id]);
        $banking->dsa_bank_flag = $request->dsa_bank_flag;
        $banking->onboarding_id = $request->onboarding_id;
        $banking->joining_date = $request->joining_date;
        $banking->role = $request->role;
        $banking->approval_date = $request->approval_date;
        if (!empty($request->primary_id)) {
            $banking->modified_by = 1;
            $banking->modified_on = now();
        } else {
            $banking->created_by = 1;
            $banking->created_on = now();
        }
        $bankinginfoarray = $banking->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'employeeDsaBankworkflow');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $banking->save();
        $insert_id = $banking->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->employee_onboarding_id . ' ' . $request->joining_date);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
    }
    // function createMasteTable(){
    //     $banking = Employee_approval_dsa_bank::firstOrNew(['id' => $request->primary_id]);
    //     $banking->dsa_bank_flag = $request->dsa_bank_flag;
    // }

    function createMainMasterTable(Request $request){
         $mainmaster = MainMaster::firstOrNew(['id' => $request->primary_id]);
         $mainmaster->name = $request->name;
         $mainmaster->master_tables = $request->group_name;
         $mainmaster->description = $request->description;
        
        $bankinginfoarray = $mainmaster->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'MainMaster');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $mainmaster->save();
        $insert_id = $mainmaster->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->name . ' ' . $request->name);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
        
        }

    function createMasterTable(Request $request)
    {
        $mainmaster = Mastertable::firstOrNew(['id' => $request->primary_id]);
        $mainmaster->form_id = $request->master_id;
        $mainmaster->name = $request->name;
        $mainmaster->short_name = $request->short_name;
        $mainmaster->sort_order = $request->sort_order;
        $mainmaster->enable = $request->enable;
        $mainmaster->description = $request->description;
        if (!empty($request->primary_id)) {
            $mainmaster->modified_by = 1;
            $mainmaster->modified_on = now();
        } else {
            $mainmaster->created_by = 1;
            $mainmaster->created_on = now();
        }
        $bankinginfoarray = $mainmaster->getAttributes();
        $redis = $this->setReddis($bankinginfoarray, 'masterTable');
        if (!$redis) {
            Log::error('Failed to save in redis.');
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in redis',
                "id" => null
            ], 417);
        }
        $mainmaster->save();
        $insert_id = $mainmaster->id;
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->name . ' ' . $request->short_name);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "id" => null
            ], 417);
        }
        $bankinginfoarray['primary_id'] = $insert_id;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $bankinginfoarray
        ], 201);
    }

    function get_mastertable(Request $request) {
        if($request->has('enable')){
            $data = DB::table('master_table')->where('is_active','=',1)->where('enable','=',$request->enable)->get();
        }else{
            $data = DB::table('master_table')->where('is_active','=',1)->get();
        }
        if(!$data->isEmpty()) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
        ], 403);
    }

    function setReddis($array,$setname) {
        $redis = Redis::connection();
        $res =  $redis->set($setname, json_encode([
            $array
        ]));
        return $res;
    }
}
