<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateFinancesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('finances', function (Blueprint $table) {
            $table->id();
            $table->integer('b_id');
            $table->integer('isBusiness')->comment('business = 1, promotor = 0');
            $table->bigInteger('turn_over_year_one')->nullable();
            $table->bigInteger('turn_over_year_two')->nullable();
            $table->bigInteger('depreciation_year_one')->nullable();
            $table->bigInteger('depreciation_year_two')->nullable();
            $table->bigInteger('bad_debit_year_one')->nullable();
            $table->bigInteger('bad_debit_year_two')->nullable();
            $table->bigInteger('intrest_on_bank_year_one')->nullable();
            $table->bigInteger('intrest_on_bank_year_two')->nullable();
            $table->bigInteger('mgt_remuneration_year_one')->nullable();
            $table->bigInteger('mgt_remuneration_year_two')->nullable();
            $table->bigInteger('profit_year_one')->nullable();
            $table->bigInteger('profit_year_two')->nullable();
            $table->bigInteger('tax_paid_year_one')->nullable();
            $table->bigInteger('tax_paid_year_two')->nullable();
            $table->bigInteger('total_equity_year_one')->nullable();
            $table->bigInteger('total_equity_year_two')->nullable();
            $table->bigInteger('load_out_standing_year_one')->nullable();
            $table->bigInteger('load_out_standing_year_two')->nullable();
            $table->bigInteger('l_promotors_year_one')->nullable();
            $table->bigInteger('l_promotors_year_two')->nullable();
            $table->bigInteger('debitors_year_one')->nullable();
            $table->bigInteger('debitors_year_two')->nullable();
            $table->bigInteger('creditors_year_one')->nullable();
            $table->bigInteger('creditors_year_two')->nullable();
            $table->date('itr_fill_date_year_one')->nullable();
            $table->date('itr_fill_date_year_two')->nullable();
            $table->bigInteger('promotor_income_rent_agri_year_one')->nullable();
            $table->bigInteger('promotor_income_rent_agri_year_two')->nullable();
            $table->tinyInteger('active')->default('1');
            $table->tinyInteger('enable')->default('1');
            $table->tinyInteger('is_draft')->default('1');
            $table->integer('modified_by');
            $table->timestamp('modified_on')->useCurrent = true;
            $table->timestamps();
        });
    }
   
    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('finances');
    }
}
