<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAssetsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('assets', function (Blueprint $table) {
            $table->id();
            $table->integer('b_id');
            $table->integer('a_type');
            $table->integer('a_sub_type');
            $table->integer('a_usage_type');
            $table->integer('a_category');
            $table->integer('pincode');
            $table->tinyInteger('active')->default('1');
            $table->tinyInteger('enable')->default('1');
            $table->integer('modified_by');
            $table->timestamp('modified_on')->useCurrent = true;
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('assets');
    }
}
