<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});


Route::post('businessDetails', 'FinanceController@businessDetails');
Route::post('getbusinessInfoByid', 'FinanceController@getbusinessInfoByid');
//Route::post('getbusinessInfoByuserid','FinanceController@getbusinessInfoByuserid');
Route::post('getEntityTypes', 'FinanceController@getEntityTypes');

Route::post('shareholderAndPersonalInfo', 'FinanceController@shareholderAndPersonalInfo');
Route::post('businessBankingInfo', 'FinanceController@businessBankingInfo');
Route::post('updateFinanceManually', 'FinanceController@updateFinanceManually');
Route::post('loanForBusiness', 'FinanceController@loanForBusiness');
Route::post('workingCaptial', 'FinanceController@workingCaptial');
Route::post('getWorkingCapitalDetailsbyrowid', 'FinanceController@getWorkingCapitalDetailsbyrowid');
Route::post('businessgst', 'FinanceController@businessgst');
Route::post('assets', 'FinanceController@assets');
Route::post('getAssetsDetails', 'FinanceController@getAssetsDetails');
Route::post('getAssetsDetailsbyRowid', 'FinanceController@getAssetsDetailsbyRowid');
Route::post('addPromotorInfo', 'FinanceController@addpromotorinfo');
Route::post('getLoanDetails', 'FinanceController@getLoanDetails');
Route::post('getLoanRowDetailsByloanid', 'FinanceController@getLoanRowDetailsByloanid');
Route::post('getWorkingCapitalDetailsbyid', 'FinanceController@getWorkingCapitalDetailsbyid');
Route::post('getGstHeaderDetails', 'FinanceController@getGstHeaderDetails');
Route::post('getGstHeaderDetailsbyid', 'FinanceController@getGstHeaderDetailsbyid');
Route::post('getGstDetailsByid', 'FinanceController@getGstDetailsByid');
Route::post('addGstDetails', 'FinanceController@addGstDetails');
Route::post('addBankingDetails', 'FinanceController@addBankingDetails');
Route::post('getBankDetailsByid', 'FinanceController@getBankDetailsByid');
Route::post('getAllbusinessInfos', 'FinanceController@getAllbusinessInfos');
Route::post('getFinanceParameterDetails', 'FinanceController@getFinanceParameterDetails');
Route::post('getAllState', 'FinanceController@getAllState');
Route::post('getAllStateBygstTinId', 'FinanceController@getAllStateBygstTinId');
Route::post('getMastertableDetails', 'FinanceController@getMastertableDetails');
Route::post('getMastertableDetailsById', 'FinanceController@getMastertableDetailsById');

Route::post('getDetailsbyPincode', 'FinanceController@getDetailsbyPincode');
Route::post('getshareholderorPromotorInfoByid', 'FinanceController@getshareholderorPromotorInfoByid');
Route::post('getfinanceDetailsbyid', 'FinanceController@getfinanceDetailsbyid');
Route::post('getBankingDetails', 'FinanceController@getBankingDetails');


Route::post('emplyeeOnboardingAddOrEdit', 'Onboarding@emplyeeOnboardingAddOrEdit');
Route::post('bankstaffOnboardingadd', 'Onboarding@bankstaffOnboardingadd');
Route::post('dsaOnboardingAddOrEdit', 'Onboarding@dsaOnboardingAddOrEdit');
Route::post('createMainMasterTable', 'Onboarding@createMainMasterTable');
Route::post('createMasterTable', 'Onboarding@createMasterTable');
Route::post('get_mastertable', 'Onboarding@get_mastertable');
Route::post('pinbankingadd', 'Onboarding@pinbankingadd');
Route::post('getpinbanking', 'Onboarding@getpinbanking');
Route::post('pinbusinessadd', 'Onboarding@pinbusinessadd');
Route::post('getpinbusiness', 'Onboarding@getpinbusiness');
Route::post('employeeapprovalworkflowAddOrEdit', 'Onboarding@employeeapprovalworkflowAddOrEdit');
Route::post('getEmployeeApprovalWorkflow', 'Onboarding@getEmployeeApprovalWorkflow');
Route::post('employeeapprovalDsaBankworkflowAddOrEdit', 'Onboarding@employeeapprovalDsaBankworkflowAddOrEdit');
Route::post('getEmployeeapprovalDsaBankworkflow', 'Onboarding@getEmployeeapprovalDsaBankworkflow');


// document
Route::post('addDocuments', 'FinanceController@addDocuments');
Route::post('editDocuments', 'FinanceController@editDocuments');
Route::post('getDocuments', 'FinanceController@getDocuments');
Route::post('deleteDocument', 'FinanceController@deleteDocument');
// document document_authority 
Route::post('documentAuthorityAddOrEdit', 'FinanceController@documentAuthorityAddOrEdit');

Route::post('getDocumentAuthorityById', 'FinanceController@getDocumentAuthorityById');
Route::post('deleteDocumentAuthorityById', 'FinanceController@deleteDocumentAuthorityById');
// document Master
Route::post('addDocumentMasterData', 'FinanceController@addDocumentMasterData');
Route::post('updateDocumentMasterData', 'FinanceController@updateDocumentMasterData');
Route::post('getDocumentMasterDataById', 'FinanceController@getDocumentMasterDataById');

// Customer Authenication Api
Route::post('customerRegistration', 'AuthenicationController@customerRegistration');
Route::post('signin', 'AuthenicationController@signin');
Route::post('retrieveMobileOrEmail','AuthenicationController@retrieveMobileOrEmail');
Route::post('sendOtp','AuthenicationController@sendOtp');
Route::post('resendOtp','AuthenicationController@resendOtp');
// Asset
Route::post('assetCategory', 'FinanceController@assetCategory');
Route::post('getAssetCategoryById', 'FinanceController@getAssetCategoryById');
Route::post('assetSize', 'FinanceController@assetSize');
Route::post('getAssetSizeById', 'FinanceController@getAssetSizeById');
Route::post('assetSubCategory', 'FinanceController@assetSubCategory');
Route::post('getAssetSubCategoryById', 'FinanceController@getAssetSubCategoryById');

Route::post('AssetUsageType', 'FinanceController@AssetUsageType');
Route::post('getAssetUsageTypeById', 'FinanceController@getAssetUsageTypeById');

Route::post('addbankingParameters', 'FinanceController@addbankingParameters');
Route::post('getbankingParametersById', 'FinanceController@getbankingParametersById');

Route::post('addIndustrySegment', 'FinanceController@addIndustrySegment');
Route::post('getIndustrySegmentById', 'FinanceController@getIndustrySegmentById');

Route::post('loanType', 'FinanceController@loanType');
Route::post('getAllloanType', 'FinanceController@getAllloanType');

Route::post('addProduct', 'FinanceController@addProduct');
Route::post('getProductById', 'FinanceController@getProductById');

Route::post('addFinancier', 'FinanceController@addFinancier');
Route::post('getFinancierById', 'FinanceController@getFinancierById');


Route::post('documentListAddOrUpdate', 'FinanceController@documentListAddOrUpdate');
Route::post('getdocumentListById', 'FinanceController@getdocumentListById');

Route::post('nationalityAddOrEdit', 'FinanceController@nationalityAddOrEdit');
Route::post('getAllnationality', 'FinanceController@getAllnationality');
Route::post('getNationalityById', 'FinanceController@getNationalityById');
Route::post('getCurrencyByCountryCode','FinanceController@getCurrencyByCountryCode');
Route::post('getAllCountrycode','FinanceController@getAllCountrycode');

Route::post('bankAddOrEdit', 'FinanceController@bankAddOrEdit');
Route::post('getAllbank', 'FinanceController@getAllbank');
Route::post('getBankById', 'FinanceController@getBankById');
Route::post('deleteBankById', 'FinanceController@deleteBankById');

Route::post('cityAddOrEdit', 'FinanceController@cityAddOrEdit');
Route::post('getAllCity', 'FinanceController@getAllCity');
Route::post('getCityById', 'FinanceController@getCityById');
Route::post('deleteCityById', 'FinanceController@deleteCityById');

Route::post('industryNamesAddOrEdit', 'FinanceController@industryNamesAddOrEdit');
Route::post('getAllIndustryNames', 'FinanceController@getAllIndustryNames');
Route::post('deleteIndustryNames', 'FinanceController@deleteIndustryNames');
Route::post('industryGroupAddOrEdit', 'FinanceController@industryGroupAddOrEdit');
Route::post('getAllIndustryGroup', 'FinanceController@getAllIndustryGroup');
Route::post('deleteIndustryGroup', 'FinanceController@deleteIndustryGroup');

Route::post('generalSettingAddOrEdit', 'FinanceController@generalSettingAddOrEdit');
Route::post('getAllGeneralSetting', 'FinanceController@getAllGeneralSetting');
Route::post('deleteGeneralSetting', 'FinanceController@deleteGeneralSetting');
// Activity Log
Route::get('add-to-log', 'FinanceController@myTestAddToLog');
Route::get('logActivity', 'FinanceController@logActivity');

Route::post('getAllshareholderAndPersonalInfo', 'FinanceController@getAllshareholderAndPersonalInfo');
Route::post('getAllPromotorInfos','FinanceController@getAllPromotorInfos');
Route::post('getAllWorkingCapitalDetails','FinanceController@getAllWorkingCapitalDetails');
Route::post('deleteworkingcapital','FinanceController@deleteworkingcapital');
Route::post('deletebusinessinfo','FinanceController@deletebusinessinfo');
Route::post('deletepromotorinfo','FinanceController@deletepromotorinfo');










