<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateGeneralSettingsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('general_settings', function (Blueprint $table) {
            $table->id();
            $table->string('parameter_name');
            $table->string('parameter_value');
            $table->tinyInteger('is_active');
            $table->tinyInteger('enable');
            $table->integer('modified_by');
            $table->timestamp('modified_on')->useCurrent = true;
            $table->integer('created_by');
            $table->timestamp('created_on')->useCurrent = true;
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('general_settings');
        
        
    }
}
