<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

// Route::middleware('auth:api')->get('/user', function (Request $request) {
//     return $request->user();
// });
Route::get('getAccessTokenByUserId/{id}','UserController@getAccessTokenByUserId');
Route::group(['middleware' => ['auth:api']], function () {

    // public routes
    Route::get('getUserByid/{id}','UserController@getUserByid');
    Route::post('getAllUsers','UserController@getAllUsers');
    // ...

});

Route::post('saveRole','RoleController@saveRole');
Route::post('getAllRole', 'RoleController@getAllRole');
Route::post('getRoleByid','RoleController@getRoleByid');
Route::put('updateRolebyid/{id}','RoleController@updateRolebyid');
Route::delete('deletebyid/{id}','RoleController@deletebyid');

Route::post('savePermission','PermissionController@savePermission');
Route::get('getAllPermission','PermissionController@getAllPermission');
Route::get('getPermissionByid/{id}','PermissionController@getPermissionByid');
Route::put('updatePermissionByid/{id}','PermissionController@updatePermissionByid');
Route::delete('deletebyid/{id}','PermissionController@deletebyid');

Route::post('saveUser','UserController@saveUser');
Route::post('retrieveMobileOrEmail','UserController@retrieveMobileOrEmail');
//Route::post('getAllUsers','UserController@getAllUsers');
// Route::get('getUserByid/{id}','UserController@getUserByid');
Route::put('updateUserByid/{id}','UserController@updateUserByid');
Route::delete('deletebyid/{id}','UserController@deletebyid');
Route::delete('deletebyid/{id}','UserController@deletebyid');
Route::post('UserSignin','UserController@UserSignin');

Route::post('sendotp','UserController@sendotp');
Route::post('resendOtp','UserController@resendOtp');
Route::post('verifyOtp','UserController@verifyOtp');
Route::post('getOtpByvalue','UserController@getOtpByvalue');

Route::post('saveForm','FormController@saveForm');
Route::get('getAllForms','FormController@getAllForms');
Route::get('getFormsByid/{id}','FormController@getFormsByid');
Route::put('updateFormByid/{id}','FormController@updateFormByid');
Route::delete('deletebyid/{id}','FormController@deletebyid');

Route::post('generalSettingAddOrEdit', 'GeneralSettingsController@generalSettingAddOrEdit');
Route::post('getAllGeneralSetting','GeneralSettingsController@getAllGeneralSetting');
Route::post('deleteGeneralSetting','GeneralSettingsController@deleteGeneralSetting');


Route::post('saveFormrolepermission','FormRolePermissionController@saveFormrolepermission');
Route::post('AgreeAndSignUp','UserController@AgreeAndSignUp');
Route::post('otp','UserController@otp');
Route::post('Mobileotp','UserController@Mobileotp');
Route::post('getGeneralSettingByParameter','GeneralSettingsController@getGeneralSettingByParameter');
Route::post('signin','UserController@signin');
Route::post('checkuser','UserController@checkuser');
Route::post('getUserdetailsbyPan','UserController@getUserdetailsbyPan');
Route::post('deleteFromUserTable','UserController@deleteFromUserTable');

Route::post('saveNotification','NotificationController@saveNotification');
Route::post('getAllNotifications','NotificationController@getAllNotifications');
Route::post('getAllNotificationById','NotificationController@getAllNotificationById');
Route::post('deleteNotificationById','NotificationController@deleteNotificationById');
Route::post('OtpNotification','NotificationController@OtpNotification');


Route::post('getOtpdetails','UserController@getOtpdetails');
Route::post('getUserdetailsbyid','UserController@getUserdetailsbyid');
Route::post('getUsersByRoleid','UserController@getUsersByRoleid');
Route::post('getUsersByRole','UserController@getUsersByRole');
Route::post('getdetailsbyuserIds','UserController@getdetailsbyuserIds');


Route::post('AdminSavingUser','UserController@AdminSavingUser');
Route::post('deleteUser','UserController@deleteUser');


Route::post('saveLoginTime','UserController@saveLoginTime');
Route::post('updateLogoutTime','UserController@updateLogoutTime');
        Route::post('saveUserwithRole','UserController@saveUserwithRole');
        Route::post('AdminSignin','UserController@AdminSignin');        
        Route::post('getAllCpa','UserController@getAllCpa');
        Route::post('getAllSa','UserController@getAllSa');
        Route::post('getAllDsa','UserController@getAllDsa');



        Route::post('getLastLoginLogoutByUserId','UserController@getLastLoginLogoutByUserId');


      //  Route::post('getLastLoginLogoutByUserId','UserController@getLastLoginLogoutByUserId');


        Route::post('saveBankerProfile','UserController@saveBankerProfile');
        Route::post('getBankerdetails','UserController@getBankerdetails');
Route::post('getAllDocumentTeam','UserController@getAllDocumentTeam');
Route::post('checkemail','UserController@checkemail');
Route::post('checkmobile','UserController@checkmobile');
Route::post('getAllAnalyst','UserController@getAllAnalyst');


Route::post('getAllGeneralsettingvalue','UserController@getAllGeneralsettingvalue');
Route::post('getParameterValueByName','UserController@getParameterValueByName');
Route::post('generalSettingAddOrEdit', 'UserController@generalSettingAddOrEdit');
Route::post('getAllGeneralSetting', 'UserController@getAllGeneralSetting');
Route::post('deleteGeneralSetting', 'UserController@deleteGeneralSetting');

Route::post('UserSigninForDigitalPull', 'UserController@UserSigninForDigitalPull');

Route::post('getUserIdByPan', 'UserController@getUserIdByPan');
 //Pradeep
Route::post('otpFlagSaveUpdate','UserController@otpFlagSaveUpdate');

Route::post('UserSigninV2','UserController@UserSigninV2');

Route::post('saveTemplate','NotificationController@saveTemplate');
