<?php

namespace App\Http\Controllers;


use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Redis;
use Illuminate\Database\Eloquent\Model;
use Jenssegers\Mongodb\Eloquent\Model as Eloquent;
use Illuminate\Support\Facades\Storage;
use Illuminate\Database\Query\Builder;
use App\Jobs\ProcessPodcast;

use App\Upload_document_doc;
use App\DocumentStore;
use App\Book_appointment_details;
use App\Book_appointment_header;
use App\Request_history;
use App\Application_summary;
use App\Proc_financial_eval_results;
use Liip\ImagineBundle\Model\Binary;	
use App\Audit_trail;
use App\DocMaster;
use App\BusinessInfo;
use App\DocumentCheckListNew;


class UploadController extends Controller
{

    public $mode;
    public $serverUri;

    public function __construct()
    {
		$this->mode = env('MODE');
        if($this->mode == 'dev'){
            $this->serverUri = env('STAGING_URI');
        } else {
            $this->serverUri = env('PRODUCTION_URI');
        }
    }

    public function getAllDocumentListByFormId(Request $request)
    {
        DB::enableQueryLog();

        //echo Config::get('global.Business_Form');

        $query = "select document_check_list.id
        from document_check_list
        left join document_master on document_master.id = document_check_list.document_master_id
        where form = '" . $request->form . "'";

        $data = DB::select($query);
        $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Document_check_list", "select", $query1[0]['query'], "document_check_list","fetch");

        if (count($data) > 0) {
            return response()->json([
                "message" => 'Data fetched successfully',
                "status" => true,
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "message" => 'Data not available',
            "status" => false
        ], 403);
    }

    public function saveDocumentStoreDetails(Request $request)
    {
		 DB::enableQueryLog();
        foreach ($request->document as $i => $i_value) {
            $docStore = DocumentStore::firstOrNew(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id]);
            $docStore->parent_type_id = $request->parent_type_id;
            $docStore->parent_id = $request->parent_id;
            $docStore->document_checklist_id = $i_value['document_checklist_id'];
            $docStore->storage_id = 3; // storage id of mongoDB is 3 hardcoded for time being.

            if (DocumentStore::where(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id])->count() > 0) {
                $docStore->modified_on = now();
                $docStore->modified_by = 1;
            } else {
                $docStore->created_by = 1;
                $docStore->created_on = now();
            }
            $documentstorearray = $docStore->getAttributes();
            $docStore->save();
			   $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Document Store", "select", $query1[0]['query'], "document_store","Insert");
    
            $insert_id = $docStore->id;
            if (!$insert_id) {
                Log::error('Failed to save document in pgsql. for ' . $request->parent_id . ' ' . $i_value['document_checklist_id']);
                //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
                return response()->json([
                    "message" => 'Failed to save in pgsql',
                ], 417);
            }


            // $req_id  =  $this->request_table($request);
            // if (!empty($request->note_description) && !empty($req_id)) {
            //     $notes = $this->notes($request, $req_id);
            // }

            if ($request->document_checklist_id != '') {
                $upload_document_doc = Upload_document_doc::where(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id, 'file' => $i_value['file']]);
                $upload_document_doc->name = $i_value['documentName'];
                $upload_document_doc->parent_type_id = $request->parent_type_id;
                $upload_document_doc->parent_id = $request->parent_id;
                $upload_document_doc->storage_id = 3; // storage id of mongoDB is 3 hardcoded for time being.
                $upload_document_doc->file = $i_value['file'];
                $upload_document_doc->save();
                $mongo_insert_id = $upload_document_doc->_id;
                //Log::info('mongodb insert Id' . $mongo_insert_id);
                if (!$mongo_insert_id) {
                    Log::error('Failed to save File In mongodb.' . $insert_id);
                    //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
                    return response()->json([
                        "message" => 'Failed to save File In mongodb',
                        "id" => null
                    ], 417);
                }
                DB::table('document_store')
                    ->where('id', $insert_id)
                    ->update(['document_upload_id' => $mongo_insert_id]);
            }
			 $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Document Upload", "select", $query1[0]['query'], "upload_document_doc","Insert");
    
            $documentstorearray['primary_id'] = $insert_id;
            if (isset($documentstorearray['modified_by'])) {
                unset($documentstorearray['modified_by']);
            }
        }
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $documentstorearray
        ], 201);
    }

    function saveDocDetails(Request $request)
    {
		
		 DB::enableQueryLog();
        foreach ($request->document as $i => $i_value) {
            $docStore = DocumentStore::firstOrNew(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id]);
            $docStore->parent_type_id         = $request->parent_type_id;
            $docStore->parent_id         = $request->parent_id;
            $docStore->document_checklist_id         = $i_value['document_checklist_id'];
            //$docStore->file_no         = $i_value['file_no'];

            if (DocumentStore::where(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id])->count() > 0) {
                $docStore->modified_on = now();
                $docStore->modified_by = 1;
            } else {
                $docStore->created_by = 1;
                $docStore->created_on = now();
            }
            //$gst->record_status = $request->status;
            $data = $docStore->getAttributes();
            $docStore->save();
			
			 $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Document Store", "select", $query1[0]['query'], "document_store","Insert");
    
            $insert_id = $docStore->id;
            if (!$insert_id) {
                Log::error('Failed to save gst details in pgsql. for ' . $docStore->document_checklist_id);
                //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
                return response()->json([
                    "message" => 'Failed to save in pgsql',
                ], 417);
            }

            if ($request->document_checklist_id != '') {
                $upload_document_doc = Upload_document_doc::where(['parent_type_id' => $request->parent_type_id, 'parent_id' => $request->parent_id, 'file' => $i_value['file']]);
                $upload_document_doc->name = $i_value['documentName'];
                $upload_document_doc->parent_type_id = $request->parent_type_id;
                $upload_document_doc->parent_id = $request->parent_id;
                $upload_document_doc->file = $i_value['file'];
                $upload_document_doc->save();
                $mongo_insert_id = $upload_document_doc->_id;
                //Log::info('mongodb insert Id' . $mongo_insert_id);
                if (!$mongo_insert_id) {
                    Log::error('Failed to save File In mongodb.' . $insert_id);
                    //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
                    return response()->json([
                        "message" => 'Failed to save File In mongodb',
                        "id" => null
                    ], 417);
                }
                DB::table('document_store')
                    ->where('id', $insert_id)
                    ->update(['document_upload_id' => $mongo_insert_id]);
            }
			$query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Document Upload", "select", $query1[0]['query'], "upload_document_doc","Insert");
    

            //$data = array_merge($data, array("primary_id" => $insert_id));

        }
        $res_data[] = $data;
        return response()->json([
            "message" => 'Successfuly inserted',
            "Data" => $res_data
        ], 201);
    }


   
   
    public function savedocuments(Request $request)
    {
        $document_store = DocumentStore::firstOrNew(['id' => $request->doc_id]);
        $document_store->parent_type_id = $request->parent_type_id;
        $document_store->parent_id = $request->parent_id;
        $document_store->document_checklist_id = $request->document_checklist_id;
        $document_store->storage_id = 3;
        $document_store->created_by = $request->user_id;
		$document_store->interval_flag = $request->interval_flag;
        $document_store->created_on = now();
        $document_store->modified_by = $request->user_id;
        $document_store->modified_on = now();
        $document_store->calendar_id = $request->calender_id;
 	    $document_store->calendar_name = $request->calendar_name;

        
        // $baseimage = base64_decode($request->file('document'));
        // $baseimage = base64_decode($request->document);
        // $extension = mime_content_type($baseimage);
        $base_image_replace = preg_replace('#data:[^;]+;base64,#', '', $request->document);
        $baseimage = base64_decode($base_image_replace);
        $f = finfo_open();
        $mime_type = finfo_buffer($f, $baseimage, FILEINFO_MIME_TYPE);
		//Log::info($mime_type);
        $extension = explode("/", $mime_type)[1];
        if($extension == 'octet-stream' || $extension == 'vnd.openxmlformats-officedocument.spreadsheetml.sheet') {
            $extension = "xlsx";          
        }
		else {
			$extension = $request->file_type;
		}
		
		$extension = explode("/",$request->file_type)[1];
		if($extension == "vnd.openxmlformats-officedocument.spreadsheetml.sheet"){
			$extension = "xlsx";
		}
		if($mime_type == "text/plain"){
			$extension = "text";
		}
		//Log::info($extension);
        //to store document in folder
        //if($request->hasFile('document')){
        //$destination_path = 'app/public/images';
        //$image = $baseimage;
        $date = date("YMDHis");
        $image_name = "document" . "_" . $date . "." . $extension;
        //$baseimage->storeAs('public/licenses', $profileImageSaveAsName);
        //Storage::disk('public')->put($image_name, $baseimage);
        //Log::info($mime_type);
        // file_put_contents(public_path('/images/' . $image_name), $baseimage);
        $destination_path = 'http://164.52.207.42/delta/public/images/'.$image_name;
        //Log::info(public_path('/images/' . $image_name), $baseimage);

        Log::info( $destination_path);
        $input['document'] = $image_name;
        $input['path'] = $destination_path;
        //Log::info($image_name);
        // }
 
        $document_store->document = $destination_path;
        $document_store->save();
        $insert_id = $document_store->id;
 
        if (!$insert_id) {
            Log::error('Failed to save in pgsql. for ' . $request->parent_type_id . ' ' . $request->parent_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save in pgsql',
                "status" => false,
                "id" => null
            ], 417);
        }
        echo $request->document_checklist_id;
        if ($request->document_checklist_id != '') {
            echo $request->document_checklist_id;
            $upload_document_doc = new Upload_document_doc();
            $upload_document_doc->name = $request->name;
            $upload_document_doc->file_base64 = $request->document;
            $upload_document_doc->file_type = $request->file_type;
            $upload_document_doc->date_and_time = date("d-m-Y");
            //$upload_document_doc->doc_id = $insert_id;
			$upload_document_doc->document= $destination_path;
            $upload_document_doc->save();
 
            $mongo_insert_id = $upload_document_doc->_id;
            Log::info('mongodb insert Id' . $mongo_insert_id);
            echo $mongo_insert_id;
            // if (!$mongo_insert_id) {
            //     Log::error('Failed to save File In mongodb.' . $insert_id);
            //     //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            //     return response()->json([
            //         "message" => 'Failed to save File In mongodb',
            //         "id" => null
            //     ], 417);
            // }
            $insert_id = $document_store->id;
            DB::table('document_store')
                ->where('id', $insert_id)
                ->update(['document_upload_id' => $mongo_insert_id]);
 
            $message = "Document Uploaded Successfully";

            
            $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/getUserdetailsbyid', [
                'id' => $request->user_id
            ]);
            $responseBody = json_decode($response->getBody());
            //Log::info($responseBody);
            if($responseBody->status == 1){
            $data['email'] = $responseBody->data->email;
            $email = $data['email'];
            $data['mobile'] = $responseBody->data->mobile;
            $mobile = $data['mobile'];
            $this->getnotifications('email', $email, $message ,
            $request->user_id,'Document Uploaded Successfully');;

            $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Document Uploaded Successfully');
            }else{
                return response()->json([
                    "message" => 'No record found on this user id',
                    "status" => false
                ], 201);
            }
 
            $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/getUsersByRoleid', [
                'role_id' => 3
            ]);
            $responseBody = $response;
            $dataArray = [];
        
            for ($i = 0; $i < count($responseBody['data']); $i++) {
                $mobile = $responseBody['data'][$i]['mobile'];
                $email = $responseBody['data'][$i]['email'];
                $this->getnotifications('email', $email, $message ,
                $request->user_id,'Document Uploaded Successfully');;
                $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Document Uploaded Successfully');
            }
 
               
            //notification to CPA
            $getCPA = DB::select("select owner_id from request where user_id =". $request->user_id);
            if($getCPA != null){
            Log::info($getCPA);
            $cpa = $getCPA[0];
            $pro = json_encode($cpa);
            $obj = json_decode($pro);
    
            $data['cpa']=$obj->owner_id;
            // Log::info($obj->owner_id);
        
            if($obj->owner_id != null){
                $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/getUserdetailsbyid', [
                    'id' => $obj->owner_id
                ]);
                $responseBody = json_decode($response->getBody());
                Log::info($responseBody->status);
                if($responseBody->status == 1){
                    $email = $responseBody->data->email;
                    //$email = $data['email'];
                    $mobile = $responseBody->data->mobile;
                    //$mobile = $data['mobile'];
                    $this->getnotifications('email', $email, $message ,
                    $request->user_id,'Document Uploaded Successfully');
                    
                    $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Document Uploaded Successfully');
                }
        
            }else{
                return response()->json([
                    "message" => 'CPA not yet assigned this user_ id',
                    "status" => false
                ], 201);
            } 
        }
        if ($mongo_insert_id) {
            return response()->json([
                "message" => 'successfully saved',
                "status" => true,
                "data" => $input
            ], 201);
        } else {
            return response()->json([
                "message" => 'failed to save',
                "status" => false
            ], 201);
        }
        }
    }

    public function deleteRecordAgainstUserPan(Request $request)
    {
		 DB::enableQueryLog();

        $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyPan', [
            'pan' => $request->pan
        ]);
        $responseBody = json_decode($response->getBody());
        if (count($responseBody->data) != 0) {
            $userId = $responseBody->data[0]->id;  //User Id
            DB::delete("delete from folder_file_mapping where bpan = '" . $request->pan . "'");
            DB::delete("delete from comm_phone_email where parent_type_id = 1 and parent_id in(select id from customer where primary_user_id = '" . $userId . "')");
            DB::delete("delete from customer where primary_user_id = '" . $userId . "'");
            $businessData = DB::select("select array_to_string(array_agg(id),  ',') as id from business_infos where user_id =" . $userId);
            $businessId = $businessData[0]->id; //Business Id
            if ($businessId != '') {
                $parentIds = $businessId;
                $promoterData = DB::select("select array_to_string(array_agg(promoter_id), ',') as id from business_promoter_mapping where business_id in(" . $businessId . ")");
                if (count($promoterData) != 0) {
                    $promoterId = $promoterData[0]->id; //Promoter Id
                    $parentIds = $businessId . "," . $promoterId;
                }
                DB::delete("delete from finance_details where finance_header_id in(select id from finance_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . "))");
                DB::delete("delete from finance_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from banking_details where bank_header_id in(select id from banking_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . "))");
                DB::delete("delete from banking_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from loan where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from working_capital where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from gst_detail where gst_header_id in(select id from gst_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . "))");
                DB::delete("delete from gst_header where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from asset_details where asset_header_id in(select id from asset_headers where parent_type_id in(1,2) and parent_id in(" . $parentIds . "))");
                DB::delete("delete from asset_headers where parent_type_id in(1,2) and parent_id in(" . $parentIds . ")");
                DB::delete("delete from request where user_id = " . $userId);
                DB::delete("delete from promoter_info where id in(" . $promoterId . ")");
                DB::delete("delete from comm_phone_email where parent_type_id = 2 and parent_id in(" . $promoterId . ")");
                DB::delete("delete from business_promoter_mapping where business_id in(" . $businessId . ")");
                DB::delete("delete from business_infos where user_id =" . $userId);
            }
            $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/deleteFromUserTable', [
                'id' => $userId
            ]);
			
			 $query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Customer", "select", $query1[0]['query'], "customer","delete");
			
            return response()->json([
                "message" => 'Data deleted successfully',
                "status" => true,
                "data"    => $request->pan
            ], 201);
        }
        return response()->json([
            "message" => 'No record on this pan',
            "status" => false,
            "data" => $request->pan
        ], 201);
    }


    //side panal menu
    public function getRecordByUserid(Request $request)
    {
 DB::enableQueryLog();

        if ($request->has('user_id')) {

            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Application Summary' as menu,0 as count,false as status
            UNION
            select 11 as id, 'Documents Uploaded' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from document_store
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id,'Schedule Document Collection' as menu,0 as count,false as status
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 14 as id,'Financial Scoring' as menu,0 as count,false as status 
            UNION
            select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id");
        }
		
		

        return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data"    => $getRecord
        ], 201);
    }
	
	
	

        //NOT USED ANYWHERE
    public function getRecordFromFilefolderByUserid(Request $request)
    {
 DB::enableQueryLog();

        if ($request->has('user_id')) {

            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
                UNION
                select 1 as id,'Business Information' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Business' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 2 as id ,'Promoter Information' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Promoter' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 3 as id,'Lets Get Started' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from request where user_id = " . $request->user_id . "
                UNION
                select 4 as id, 'Financial' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Finance' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 5 as id, 'Bank Accounts' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Bank' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 6 as id, 'Loans' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Loans' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 7 as id, 'Working Capital' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Working Capital' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 8 as id, 'GST Details' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'GST' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 9 as id, 'Asset' as menu,count(*),
                case
                when count(*) > 0 then TRUE
                ELSE FALSE
                END as status
                from folder_file_mapping
                left join customer on customer.pan = folder_file_mapping.bpan
                left join master_table on master_table.id = folder_file_mapping.file_type
                where master_table.name = 'Assets' and customer.primary_user_id = " . $request->user_id . "
                UNION
                select 10 as id,'Fat Check' as menu,0 as count,false as status
                UNION
                select 11 as id,'Financial Scoring' as menu,0 as count,false as status
                UNION
                select 12 as id,'Loan Elegibility' as menu,0 as count,false as status
                UNION
                select 14 as id,'Status' as menu,0 as count,false as status order by id");
        }

        return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data"    => $getRecord
        ], 201);
    }


    public function findDocsOfUser(Request $request)
    {

 DB::enableQueryLog();

        if($request->form == 10){
            $query1 = "select document_check_list.id,document_master.name,master_table.name as required_phase  from document_check_list
        left join document_authority_mapping on document_authority_mapping.id = document_check_list.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list.required_phase
                where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ") and required_phase = ". $request->required_phase ."";
        $DocumentList = DB::select($query1);
        }else{
        DB::enableQueryLog();
        $query = "select document_check_list.id,document_master.name,master_table.name as required_phase  from document_check_list
        left join document_authority_mapping on document_authority_mapping.id = document_check_list.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list.required_phase
                where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ") and required_phase = ". $request->required_phase ." and form = '" . $request->form . "'";
        $DocumentList = DB::select($query);
        //Log::info($DocumentList);
		$query1 = DB::getQueryLog();
            Log::info($query1[0]['query']);
    
            $this->callLogFileStore($request->user_id, "Document_check_list", "select", $query1[0]['query'], "document_check_list","fetch");
        //Log::info($qq);
    }
        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . "and is_active =1");
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        //Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = $docMongoId->file_base64;
							$fileData['docPath'] = $docMongoId->document;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    $fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
                //Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found',
				"data"=> []
            ], 200);
        }
    }

    public function deleteDocById(Request $request)
    {
		
        DB::enableQueryLog();
        $query = "update document_store set is_active = 0 where document_upload_id = '" . $request->id . "' ";
        //Log::info($query);
		$query1 = DB::getQueryLog();
            // Log::info($query1[0]['query']);
    
            // $this->callLogFileStore($request->user_id, "Document Store", "select", $query1[0]['query'], "document_store","delete");
        $response = DB::update($query);
        if ($response) {
            return response()->json([
                "status" => true,
                "message" => "successfully deleted"
            ]);
        } else {
            return response()->json([
                "status" => false,
                "message" => ""
            ]);
        }
    }

    public function callQueueMethod(Request $request)
    {
        /*$details['request_id'] = $request->request_id;
        $details['folder_no'] = $request->folder_no;
        $details['product_category_code'] = "BS";
        $details['product_cd'] = "ABB";
        ProcessPodcast::dispatch($details);
        Log::info($details);
        Log::info("Call Happen"); */
    }

    public function getnotifications($type, $value, $notification_body, $user_id,$subject=null)
    {

        //Call rest api to store credentials in notification table for email .
        $response = Http::post($this->serverUri . 'Identitymanagement/server.php/api/saveNotification', [
            'type' => $type,
            'value' => $value,
            'notification_body' => $notification_body,
            'notification_flag' => 'true',
            'ip_address' => $_SERVER['REMOTE_ADDR'],
            'subject' =>  $subject,
            'form_id' => 112,
            'user_id' => $user_id,
            'enable' => 1,
            'is_active' => 1,
        ]);
       // Log::info($response);
    }

    //Summary view API for Application
    public function getSummaryView(Request $request){
         DB::enableQueryLog();

		$getSummary = DB::select("select 1 as id,'Business Information' as menu,10 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join business_infos on business_infos.file_no = folder_file_mapping.file_no
        where business_infos.is_active = 1 and  master_table.name = 'Business' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,10 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join promoter_info on promoter_info.file_no = folder_file_mapping.file_no
        where promoter_info.is_active = 1 and master_table.name = 'Promoter' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 3 as id, 'Financial' as menu,6 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join finance_header on finance_header.file_no = folder_file_mapping.file_no
        where finance_header.is_active = 1 and  master_table.name = 'Finance' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Bank Accounts' as menu,5 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join banking_header on banking_header.file_no = folder_file_mapping.file_no
        where banking_header.is_active = 1 and master_table.name = 'Bank' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 5 as id, 'Loans' as menu,4 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join loan on loan.file_no = folder_file_mapping.file_no
        where loan.is_active = 1
        and master_table.name = 'Loans' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 6 as id, 'Working Capital' as menu,3 as profile_stepper_flag,count(*),
        case
        when count(*) > (select count(*) from business_infos where business_infos.user_id = " . $request->user_id . ") then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join working_capital on working_capital.file_no = folder_file_mapping.file_no
        where working_capital.is_active = 1
        and working_capital.parent_type_id = 1 and working_capital.parent_id in(select id from business_infos where business_infos.user_id = " . $request->user_id . ")
        and master_table.name = 'Working Capital' and customer.primary_user_id =" . $request->user_id . "
        UNION
        select 7 as id, 'GST Details' as menu,2 as profile_stepper_flag,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join gst_header on gst_header.file_no = folder_file_mapping.file_no
        where gst_header.is_active = 1 and master_table.name = 'GST' and customer.primary_user_id = " . $request->user_id . "
        UNION
        select 8 as id, 'Asset' as menu,1 as profile_stepper_flag,count(*),
        case
        when count(*) > (select count(*) from business_infos where business_infos.user_id = " . $request->user_id . ") then TRUE
        ELSE FALSE
        END as status
        from folder_file_mapping
        left join customer on customer.pan = folder_file_mapping.bpan
        left join master_table on master_table.id = folder_file_mapping.file_type
        left join asset_headers on asset_headers.file_no = folder_file_mapping.file_no
        where asset_headers.is_active = 1
        and asset_headers.parent_type_id = 1 and asset_headers.parent_id in(select id from business_infos where business_infos.user_id=" . $request->user_id . ")
        and master_table.name = 'Assets' and customer.primary_user_id =" . $request->user_id . "
        order by id");
        return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data"    => $getSummary
        ], 201);
    }


    //time being saves
    /*public function summaryView(Request $request){
        if ($request->has('request_id')) {

            $response = Http::post('http://164.52.208.120:8082/coderscorner/server.php/api/getuserByRequest',[
                'id' => $request->request_id
            ]);
            $responseBody = json_decode($response->getBody());
            $data['user_id'] = $responseBody->data->user_id;
            $user_id = $data['user_id'];
            $data['folder_no'] = $responseBody->data->folder_no;
            $folder_no = $data['folder_no'];
            //CHECING WETHER ALL FORMS FILLED AND THEN SENDING MSG.
            $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyid', [
                'id' => $user_id
            ]);
            
            $responseBody = json_decode($response->getBody());
            $data['email'] = $responseBody->data->email;
            $email = $data['email'];
            $data['mobile'] = $responseBody->data->mobile;
            $mobile = $data['mobile'];
            $this->getnotifications('email',$email,'Application Completed',$request->user_id);
            $this->getnotifications('mobile',$mobile,'Application Completed',$request->user_id); 

            $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUsersByRoleid', [
                'role_id' => 3
            ]);

            $responseBody = $response;
            $dataArray = [];
            for ($i = 0; $i < count($responseBody['data']); $i++) {
                $mobile = $responseBody['data'][$i]['mobile'];
                $email = $responseBody['data'][$i]['email'];
                $this->getnotifications('email', $email, 'Application Completed', $request->user_id);
                $this->getnotifications('mobile', $mobile, 'Application Completed', $request->user_id);
            }

        $details['request_id'] = $request->request_id;
        $details['folder_no'] = $folder_no;
        $details['product_category_code'] = "BL";
        $details['product_cd'] = "GST";
        ProcessPodcast::dispatch($details);
        //$this->saveRequestHistory($request->request_id,$folder_no,'Submitted','no remarks',$user_id);
            return response()->json([
                "message" => 'Saved Successfully',
                "status" => true,
								"data" =>$details
            ], 201);   
        } else {
            return response()->json([
                "message" => 'Please pass id for saving',
                "status" => false
            ], 201);
        }
    }*/
	public function summaryView(Request $request){
         DB::enableQueryLog();

		if ($request->has('request_id')) {

            $response = Http::post($this->serverUri . 'delta/server.php/api/getuserByRequest',[
                'id' => $request->request_id
            ]);
            $responseBody = json_decode($response->getBody());
            if($responseBody->status == 1){
            $data['user_id'] = $responseBody->data->user_id;
            $user_id = $data['user_id'];
            $data['folder_no'] = $responseBody->data->folder_no;
            $folder_no = $data['folder_no'];
			$data['reference_id'] = $responseBody->data->reference_id;
            $refernce_id = $data['reference_id'];
			$data['business_channel_id'] = $responseBody->data->business_channel_id;
            $business_channel_id = $data['business_channel_id'];
            }else{
                return response()->json([
                    "message" => 'Please pass valid req_id for saving',
                    "status" => false
                ], 201);
            }
			
			$loan_type = DB::select("select short_name from loan_types where id = " . $business_channel_id);
            //Log::info($loan_type);
            $loan = $loan_type[0];
            $pro = json_encode($loan);
            $obj = json_decode($pro);

            $loan_type_name = $obj->short_name;
			
			
            //CHECING WETHER ALL FORMS FILLED AND THEN SENDING MSG.
            /*$response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyid', [
                'id' => $user_id
            ]);
            
            $responseBody = json_decode($response->getBody());
            if($responseBody->status == 1){
            $data['email'] = $responseBody->data->email;
            $email = $data['email'];
            $data['mobile'] = $responseBody->data->mobile;
            $mobile = $data['mobile'];
            $this->getnotifications('email',$email,'Application Completed',$request->user_id);
            $this->getnotifications('mobile',$mobile,'Application Completed',$request->user_id); 
            }else{
                return response()->json([
                    "message" => 'No record found on this user_ id',
                    "status" => false
                ], 201);
            }*/
            /*$message = "The eligibility computation for application ". $refernce_id . " has been completed.";
            $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUsersByRoleid', [
                'role_id' => 3
            ]);

            $responseBody = $response;
            $dataArray = [];
            for ($i = 0; $i < count($responseBody['data']); $i++) {
                $mobile = $responseBody['data'][$i]['mobile'];
                $email = $responseBody['data'][$i]['email'];
                $this->getnotifications('email', $email, $message, $request->user_id,'Computation completed Successfully');
                $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Computation completed Successfully');
            }*/
        $details = array();
        $details['request_id'] = $request->request_id;
        $details['folder_no'] = $folder_no;
        //$details['product_category_code'] = "BL";
        $details['product_cd'] = "GST";
		$details['product_category_code'] = $loan_type_name;
        // ProcessPodcast::dispatch($details);
        echo json_encode($details);
        $process = new ProcessPodcast($details);
        dispatch($process);
        //$this->saveRequestHistory($request->request_id,$folder_no,'Submitted','no remarks',$user_id);
            return response()->json([
                "message" => 'Saved Successfully',
                "status" => true
            ], 201);   
        } else {
            return response()->json([
                "message" => 'Please pass id for saving',
                "status" => false
            ], 201);
        }
    }

	

    public function callFinFatEligibiltyProcedure($data) {
        echo $data['product_category_code'];
        echo $data['request_id'];
        echo $data['folder_no'];
        DB::select("call sp_fat_check_calc('".$data['folder_no']."')");
        DB::select("call sp_fin_scorning_calc('".$data['folder_no']."', '".$data['product_category_code']."')");
        DB::select("call sp_eligibility_calc('".$data['product_category_code']."', '".$data['request_id']."', '".$data['folder_no']."')");
    }



  
    public function bookAppointment(Request $request){
      //ganashree
	  $appointmentheader = Book_appointment_header::firstOrNew(['created_by' => $request->created_by,'start_date'=>$request->start_date]);
        $appointmentheader->title = $request->title;
        $appointmentheader->start_date = $request->start_date;
        $appointmentheader->start_time = $request->start_time;
        $appointmentheader->request_id = $request->request_id;
		$appointmentheader->parent_id = $request->parent_id;
          $appointmentheader->parent_type_id = $request->parent_type_id;
        $appointmentheader->enable = true;
        $appointmentheader->is_active = true;
        if (Book_appointment_header::where(['id' => $request->id])->count() > 0) {
            $appointmentheader->modified_on = now();
            if ($request->has('created_by')){
                $appointmentheader->modified_by = $request->created_by;
            }else{
                $appointmentheader->modified_by = $request->user_id;
            }
        } else {
            if ($request->has('created_by')){
                $appointmentheader->created_by = $request->created_by;
            }else{
                $appointmentheader->created_by = $request->user_id;
            }
            $appointmentheader->created_on = now();
            $appointmentheader->modified_on = now();
            $appointmentheader->modified_by =  $request->created_by;
        }
        if($request->id){
            $appointmentheader->status = 'Rescheduled';
        }else{
            $appointmentheader->status = 'scheduled'; 
        }
		if($request->role_id == 7){
            $appointmentheader->assaigned_to = $request->user_id;
        }
		
		 $appointmentheader->address = $request->address;
        $appointmentheader->pincode = $request->pincode;
        $appointmentheader->phone = $request->phone;
        $appointmentheader->longitude = $request->longitude;
        $appointmentheader->latitude = $request->latitude;
        
       
        $appointmentheader->save();
        $reference_details = [];
        $insert_data = [];
            foreach ($request->reference_document_checklist_id as $i => $i_value) {
                $reference_details[] = $i_value;
                if ($request->has('created_by')){
                    $created_by = $request->created_by;
                }else{
                    $created_by = $request->user_id;  
                }   
                $insert_data[$i] = [
                    'created_on' =>  now(),
                    'modified_on' => now(),
                    'modified_by' => $created_by,
                    'is_active' =>  true,
                    'enable' => true,
                    'reference_header_id' => $appointmentheader->id,
                    'reference_document_checklist_id' => $i_value,
                    'is_collected' => true,
                    'created_by' =>$request->created_by
                ];

            }
            
            if (Book_appointment_details::where('reference_header_id', '=', $appointmentheader->id)->whereIn('reference_document_checklist_id', $reference_details)->exists()) {
                if (!empty($reference_details)) {
                    $appointmentdetails_select = new Book_appointment_details();
                    $appointmentdetails_select = Book_appointment_details::select('reference_document_checklist_id')->where('reference_header_id', $appointmentheader->id)->get();
                    foreach($appointmentdetails_select as $item) {
                        if (!in_array($item->reference_document_checklist_id,$reference_details )) {
                            DB::table('book_appointment_details')
                            ->where('reference_document_checklist_id', $item->reference_document_checklist_id)
                            ->where('reference_header_id', $appointmentheader->id)
                            ->update(['is_collected' => false]);
                        } else {
                            DB::table('book_appointment_details')
                            ->where('reference_document_checklist_id', $item->reference_document_checklist_id)
                            ->where('reference_header_id', $appointmentheader->id)
                            ->update(['is_collected' => true]);
                        }

                    }
                }
            } 
            // else {
            //     foreach($insert_data as $item) {
            //         Book_appointment_details::insert($item);
            //     }
            //}
             $insert_appoint_detail = [];
            foreach ($reference_details as $i=> $checklist_id) {
                if (Book_appointment_details::where('reference_header_id', '=', $appointmentheader->id)->where('reference_document_checklist_id', $checklist_id)->exists()) {
                    //Log::info("reference_document_checklist_id existis: " . $checklist_id);
                } else {

                    if ($request->has('created_by')){
                        $created_by = $request->created_by;
                    }else{
                        $created_by = $request->user_id;  
                    }   
                    $insert_appoint_detail[$i] = [
                        'created_on' =>  now(),
                        'modified_on' => now(),
                        'modified_by' => $created_by,
                        'is_active' =>  true,
                        'enable' => true,
                        'reference_header_id' => $appointmentheader->id,
                        'reference_document_checklist_id' => $checklist_id,
                        'is_collected' => true,
                        'created_by' =>$request->created_by
                    ];
                   

                }
            }
            if(!empty($insert_appoint_detail)){
                foreach($insert_appoint_detail as $item ){
                    Book_appointment_details::insert($item);
                }
            }
             $data['Book_appointment_header'] = $appointmentheader->getAttributes();
        $data['appointment_detail'] = $insert_data;
        $data['appointmentdetails']['reference_document_checklist_id']  = $request->reference_document_checklist_id;
        $insert_id = $appointmentheader->id;
        if (!$insert_id) {
            Log::error('Failed to save Asset in pgsql. for ' . $request->file_no);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 417);
        }

 
        if ($request->start_date && $request->created_by != null) {

            return response()->json([
                "status" => true,
                "message" => 'Appointment Inserted Successfuly',
                "Data" => $data
               // "insert_appoint_detail" => $insert_appoint_detail
            ], 201);
        } else {
            return response()->json([
                "status" => true,
                "message" => 'Appointment Updated Successfuly',
                "Data" => $data
            ], 201);
        }
    } 

    public function getAppointmentDetailsByRequestId(Request $request){
			 DB::enableQueryLog();

	   $appointmentdetails = Book_appointment_header::select('*')->where('request_id', $request->request_id)->where('is_active','=',true)->get();
		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Header", "select", $query1[0]['query'], "book_appointment_header","fetch");

 	
		   if(count($appointmentdetails) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $appointmentdetails
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    public function deleteAppointmentById(Request $request)
    {
					 DB::enableQueryLog();

        $disabledAppointment = Book_appointment_header::find($request->id);
        $disabledAppointment->is_active  = 0;
        $disabledAppointment->save();
        $updateId = $disabledAppointment->id;
				 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Header", "select", $query1[0]['query'], "book_appointment_header","delete");

        if ($updateId) {
            return response()->json([
                "status" => true,
                "message" => 'Deleted successfully',
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Failed to delete',
            ], 201);
        }
    }

    public function getAppointmentDetailsByAppointmentId(Request $request){
         DB::enableQueryLog();

		$appointmentheader = Book_appointment_header::select('*')->where('id', $request->id)->get();
        $appointmentdetails = Book_appointment_details::select('*')->where('reference_header_id', $request->id)->get();
        $data['appointmentheader'] = $appointmentheader;
        $data['appointmentdetails']= $appointmentdetails;
				 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Header", "select", $query1[0]['query'], "book_appointment_header","fetch");
		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Details", "select", $query1[0]['query'], "book_appointment_details","fetch");

            if(count($data) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $data
            ], 200);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'no records found'
            ], 200);
        }
    }

    //save function for request history
    public function saveRequestHistory($requestId,$folder_no,$status,$remarks,$createdBy){
         DB::enableQueryLog();

		$requestHistory = new Request_history();
        $requestHistory->request_id = $requestId;
        $requestHistory->folder_no = $folder_no;
        $requestHistory->status = $status;
        $requestHistory->remarks = $remarks;
        $requestHistory->created_by = $createdBy;
        $requestHistory->created_on = now();
        $requestHistory->modified_by = $createdBy;
        $requestHistory->modified_on = now();
        $requestHistory->is_active = true;
        $requestHistory->enable = true;
        $requestHistory->save();
				 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Request History", "select", $query1[0]['query'], "request_history","Insert");

        $data['requestHistory_id'] = $requestHistory->id;
        if ($data['requestHistory_id']) {
            return response()->json([
                "status" => true,
                "message" => 'Successfuly inserted',
                "Data" => $requestHistory
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 201);
        }

    }

    public function assaignCpaToCollectDocument(Request $request){
 DB::enableQueryLog();
          
		  $count = 0;
         
            for ($i = 0; $i < count($request->request_id); $i++) {
            $assigncpa = DB::select('select * from book_appointment_header where request_id ='.$request->request_id[$i]);
                 $object =  json_encode($assigncpa[0]);
                 $object = json_decode($object);
                 $newData = Book_appointment_header::find($object->id);
                 //Log::info($newData);

                if ($newData->id != null) {
                    $newData->assaigned_to = $request->user_id;
                    $newData->save();
                    $count++;
                }
            }
            /*$response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyid', [
                'id' => $request->user_id
            ]);
            $responseBody = json_decode($response->getBody());
            $data['email'] = $responseBody->data->email;
            $email = $data['email'];
            $data['mobile'] = $responseBody->data->mobile;
            $mobile = $data['mobile'];
            $this->getnotifications('email',$email,'You are Assigned to Collect Documents',$request->user_id);
            $this->getnotifications('mobile',$mobile,'You are Assigned to Collect Documents',$request->user_id);*/

            if ($count > 0) {
                return response()->json([
                "message" => 'document collector assigned successfully',
                "status" => true
                ], 201);
            } else {
                return response()->json([
                "message" => 'No record found on this id',
                "status" => false
                ], 201);
            }
    }

    /*public function getAllAppointments(Request $request){
        if ($request->has('enable')) {
            $data = DB::table('book_appointment_header')->where('is_active', '=', 1)->where('enable', '=', $request->enable)->orderBy('id')->get();
        } else {
            $data = DB::table('book_appointment_header')->where('is_active', '=', 1)->orderBy('id')->get();
        }

        if (!$data->isEmpty()) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data"    => $data
            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Data not available',
        ], 201);

    }*/
	
	public function getUserDetail($id) {
        $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyid', [
          'id' => $id,
                    ]);
                    
         return $response;
    }
	
	public function getAllAppointments(Request $request){
        /* if ($request->has('enable')) {
            $data = DB::table('book_appointment_header')->where('is_active', '=', 1)->where('enable', '=', $request->enable)->orderBy('id')->get();
        } else {
            $data = DB::table('book_appointment_header')->where('is_active', '=', 1)->orderBy('id')->get();
        } */
		 DB::enableQueryLog();

        $getAllAppointments = DB::table('book_appointment_header')->where('is_active', '=', 1)->where('enable', '=', $request->enable)->orderBy('id')->get();
        $data = [];
        foreach($getAllAppointments as $i => $i_value){
            $user_data = $this->getUserDetail($i_value->assaigned_to);

            $id = (is_null($i_value->assaigned_to)) ? "" : $i_value->assaigned_to;
            if(empty($id)){
                $email = "";
                $mobile = "";
            }else if (!empty($id)){
                $response = Http::post('http://164.52.208.120:8082/Identitymanagement/server.php/api/getUserdetailsbyid', [
                    'id' => $id
                ]);
                 
                    $json_array = json_decode($response->getBody()->getContents());
                    $email = ($json_array!=null) ? $json_array->data->email : '';
                    $mobile = ($json_array!=null) ? $json_array->data->mobile: ''; 
                }
            
            $data[$i] = [
            "id"=>$i_value->id,
			"title"=>$i_value->title,
			"start_date"=> ($i_value->start_date !=null) ? $i_value->start_date: '',
			"start_time"=>($i_value->start_time !=null) ? $i_value->start_time:'',
			"request_id"=>($i_value->request_id !=null) ? $i_value->request_id:'',
            "status"=>($i_value->status !=null) ? $i_value->status:'',
            "assaigned_to"=>($i_value->assaigned_to !=null) ? $i_value->assaigned_to:'',
            "address"=>($i_value->address !=null) ? $i_value->address:'',
            "pincode"=>($i_value->pincode !=null) ? $i_value->pincode:'',
            "phone"=>($i_value->phone !=null) ? $i_value->phone:'',
            "longitude"=>($i_value->longitude !=null) ? $i_value->longitude:'',
            "latitude"=>($i_value->latitude !=null) ? $i_value->latitude:'',
            "enable"=>($i_value->enable !=null) ? $i_value->enable:'',
            "is_active"=>($i_value->is_active !=null) ? $i_value->is_active:'',
            "created_by"=>($i_value->created_by !=null) ? $i_value->created_by:'',
            "created_on"=>($i_value->created_on !=null) ? $i_value->created_on:'',
            "modified_by"=>($i_value->modified_by !=null) ? $i_value->modified_by:'',
            "modified_on"=>($i_value->modified_on !=null) ? $i_value->modified_on:'',
			"email" => $email,
			"mobile" => $mobile
            ];
         } 
		 
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Header", "select", $query1[0]['query'], "book_appointment_header","fetch");

        if (count($getAllAppointments) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
				"data" => $data
            ], 201);
        }
        return response()->json([
            "status" => false,
            "message" => 'Data not available'
        ], 201);

    }
	 //ganashree 12-05-2021

    public function deleteAppointmentByUserIDAndstartdate(Request $request)
    {
    DB::enableQueryLog();
        $query="update Book_appointment_header set is_active = false where start_date='".$request->start_date."'
                         AND  created_by='".$request->created_by."' ";
                         //Log::info($query);
                         $response = DB::update($query);
						 
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "BookAppointment Header", "select", $query1[0]['query'], "book_appointment_header","delete");

               if ($response) {
                     return response()->json([
                         "status" => true,
                              "message" => "successfully deleted"
                                ]);
             } else {
                     return response()->json([
                          "status" => false,
                             "message" => ""
                                ]);            
        
        }
    }
        public function getAppointmentByUserIDAndDate(Request $request){
 DB::enableQueryLog();
            
			$refernce_id = [];
            $reference_checklist_id = [];
            $appointmentheader = Book_appointment_header::select('*')->where('start_date',$request->start_date)->where('created_by',$request->created_by)->where('is_active','=',true)->get();
                //$appointmentdetails = Book_appointment_details::select('*')->where('reference_header_id', $request->reference_header_id)->get();
                foreach($appointmentheader as $i => $item){
                    $id=$item->id;
                    $data['appointmentdetails']=Book_appointment_details::select('*')->where('reference_header_id',$id)->get();
                    $refernce_id[] = $id;
                }
                if (!empty($refernce_id)) {
                      $appoint_details_id = Book_appointment_details::select('reference_document_checklist_id')->where('reference_header_id',$refernce_id[0])->where('is_collected',true)->get();
                      //$data['reference_document_checklist_id'] = $appoint_details_id;
                      foreach($appoint_details_id as $item) {
                        $reference_checklist_id[] = $item->reference_document_checklist_id;
                      }
                }
                $data['reference_document_checklist_id'] = $reference_checklist_id;
                $data['appointmentheader'] = $appointmentheader;
                //$data['appointmentdetails']= $appointmentdetails;
        
                if(count($data['appointmentheader']) > 0) {
                    return response()->json([
                        "status" => true,
                        "message" => 'Data fetched successfully',
                        "data" => $data,
                        //"reference_id" => $refernce_id
                    ], 200);
                } else {
                    return response()->json([
                        "status" => false,
                        "message" => 'no records found'
                    ], 200);
                }
        
        }
		
		
	//JAYESH
	public function getRecordByUseridUser(Request $request)
        {
 DB::enableQueryLog();

            if ($request->has('user_id')) {
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Application Summary' as menu,0 as count,false as status
            UNION
            select 11 as id, 'Documents Uploaded' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from document_store
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id,'Schedule Document Collection' as menu,0 as count,false as status
            UNION
            select 13 as id,'Status' as menu,0 as count,false as status order by id");
            }

            return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data" => $getRecord
            ], 201);
	}

	/*public function getLoanEligibility(Request $request){
        $getfact_application = DB::select("select * from fact_application where folder_no ='" . $request->folder_no . "'"); 
        Log::info($getfact_application);
        $geteligibility = $getfact_application[0];
        $pro = json_encode($geteligibility);
        $obj = json_decode($pro);

        Log::info($data['eligibility'] = $obj->appln_status_cd);
        $data['eligibility'] = $obj->appln_status_cd;
        if($data['eligibility'] != "NOTELIGIBLE"){
            $getfact_application = DB::select("select * from fact_application where folder_no ='" . $request->folder_no . "'"); 
            $getfact_application_list = DB::select("select * from fact_application_list where folder_no ='" . $request->folder_no . "'");
            $getfact_product_elig = DB::select("select * from fact_product_elig where folder_no ='" . $request->folder_no . "'");
            $data['fact_application'] = $getfact_application;
            $data['fact_application_list'] = $getfact_application_list;
            $data['fact_product_elig'] = $getfact_product_elig;
            if (count($data) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data"    => $data
                ], 201);
            }
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
        }else{
            return response()->json([
                "status" => false,
                "message" => 'Loan is not eligible',
            ], 201);
        }
    }*/
	
	public function getLoanEligibility(Request $request){
         DB::enableQueryLog();

        //  select application_eligibility_results.*, bank.name as bank_name,path,loan_types.name as loan_type,
        // product.name as product_name,bank.terms as termsandcondition, bank.desc as description
        // from application_eligibility_results 
        // left join bank on bank.id = application_eligibility_results.financier_id
        // left join loan_types on loan_types.id = application_eligibility_results.loan_type_id
        // left join product on product.id = application_eligibility_results.product_id
        // where product_max_amt_flag = 'y' and folder_no ='" . $request->folder_no . "'
		$getfact_application = DB::select("SELECT A.*,B.name FinancierName,C.name ProductName FROM  public.application_eligibility_results A 
        JOIN public.bank B ON A.financier_id = B.id 
        JOIN public.master_table C ON A.product_category_id=C.id and C.master_table_id=17
        WHERE A.appln_approved_amt  = (select MAX(appln_approved_amt) from public.application_eligibility_results where folder_no='" . $request->folder_no . "') and A.folder_no='" . $request->folder_no . "'"); 
        //Log::info($getfact_application);
		
		
        
            if (count($getfact_application) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data"    => $getfact_application
                ], 201);
            }
            return response()->json([
                "status" => false,
                "message" => 'Data not available',
            ], 201);
    }

    public function getOverRule(Request $request){
        DB::enableQueryLog();

       //  select application_eligibility_results.*, bank.name as bank_name,path,loan_types.name as loan_type,
       // product.name as product_name,bank.terms as termsandcondition, bank.desc as description
       // from application_eligibility_results 
       // left join bank on bank.id = application_eligibility_results.financier_id
       // left join loan_types on loan_types.id = application_eligibility_results.loan_type_id
       // left join product on product.id = application_eligibility_results.product_id
       // where product_max_amt_flag = 'y' and folder_no ='" . $request->folder_no . "'
       $getfact_application = DB::select("SELECT A.*,B.name FinancierName,C.name ProductName FROM  public.fact_product_elig A 
       JOIN public.bank B ON A.financier_id = B.id 
       JOIN public.master_table C ON A.product_category_id=C.id and C.master_table_id=17
       WHERE A.parameter_cd in('final_loan_amount', 'final_loan_amount_abb', 'final_loan_amount_bs',
                               'final_loan_amount_cc', 'final_loan_amount_fccrn', 'final_loan_amount_fccrs',
                               'final_loan_amount_oup', 'final_loan_amount_sep', 'final_loan_amount_tom','final_loan_amount_gst') 
           and A.folder_no='" . $request->folder_no . "'"); 
       //Log::info($getfact_application);
       
       
       
           if (count($getfact_application) > 0) {
               return response()->json([
                   "status" => true,
                   "message" => 'Data fetched successfully',
                   "data"    => $getfact_application
               ], 201);
           }
           return response()->json([
               "status" => false,
               "message" => 'Data not available',
           ], 201);
   }
	
	
	public function getAllDocumentsByUser(Request $request){
        DB::enableQueryLog();
        $query = "select document_check_list.id,document_master.name,master_table.name as required_phase  from document_check_list
        left join document_authority_mapping on document_authority_mapping.id = document_check_list.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list.required_phase
        where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ")";
        $DocumentList = DB::select($query);
		
		
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Document_check_list", "select", $query1[0]['query'], "document_check_list","fetch");

        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . " and is_active =1");
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        //Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
							$fileData['base64String'] = "";
                            $fileData['base64String'] = $docMongoId->file_base64;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    $fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
                //Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }  

    }
	
	public function getAllDocumentsByUserforBank(Request $request){
        DB::enableQueryLog();
        $query = "select document_check_list_bank.id,document_master.name,master_table.name as required_phase  from document_check_list_bank
        left join document_authority_mapping on document_authority_mapping.id = document_check_list_bank.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list_bank.required_phase
        where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ")";
        $DocumentList = DB::select($query);
		
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Document_check_list Bank", "select", $query1[0]['query'], "document_check_list_bank","fetch");

        //Log::info($qq);
        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . "and is_active =1");
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        //Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = "";
                            $fileData['base64String'] = $docMongoId->file_base64;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    //$fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
               // Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }  

    }
    
	
	public function getBankDocuments(Request $request){
 DB::enableQueryLog();
       
	   $query = "select document_check_list_bank.id,document_master.name from document_check_list_bank
        left join document_authority_mapping on document_authority_mapping.id = document_check_list_bank.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list_bank.required_phase
        where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ") and required_phase = ". $request->required_phase ." and bank_id =" . $request->bank_id . "";
        
        $DocumentList = DB::select($query);

		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Document_check_list Bank", "select", $query1[0]['query'], "document_check_list_bank","fetch");

        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        } 

    }
	
	
	public function findDocsOfUserforBank(Request $request)
    {
        DB::enableQueryLog();
        $query = "select document_check_list_bank.id,document_master.name,master_table.name as required_phase  from document_check_list_bank
        left join document_authority_mapping on document_authority_mapping.id = document_check_list_bank.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list_bank.required_phase
                where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ") and required_phase = ". $request->required_phase ." and form = '" . $request->form . "'";
        $DocumentList = DB::select($query);
		
		
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Document_check_list", "select", $query1[0]['query'], "document_check_list_bank","Find");


        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . "and is_active =1");
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        //Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = $docMongoId->file_base64;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    $fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
               // Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }
    }
	
	
	public function getRecordByBanker(Request $request)
        {
 DB::enableQueryLog();

            if ($request->has('user_id')) {
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
            }

            return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data" => $getRecord
            ], 201);
	}
	
	
	
	/*public function getsidepanelByrole(Request $request){
        if($request->role_id == 2){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id, 'Application_summary' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from application_summary
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 11 as id, 'Documents Uploaded' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from document_store
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id, 'Schedule Document Collection' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from book_appointment_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 13 as id,'Status' as menu,0 as count,false as status order by id"); 

        }elseif($request->role_id == 3){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id, 'Application_summary' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from application_summary
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 11 as id, 'Documents Uploaded' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from document_store
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id, 'Schedule Document Collection' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from book_appointment_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 14 as id,'Financial Scoring' as menu,0 as count,false as status 
            UNION
            select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id");   
        }elseif($request->role_id == 5){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
        }elseif($request->role_id == 7){
            $getRecord = DB::select("select 0 as id,'Appointment List' as menu,0 as count,false as status");
        }else{
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id, 'Application_summary' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from application_summary
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 11 as id,'Status' as menu,0 as count,false as status order by id");
        }
        return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data" => $getRecord
            ], 201);

    }*/
	public function getsidepanelByrole(Request $request){
    if($request->role_id == 2){
        $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
        UNION
        select 1 as id,'Business Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 6 as id, 'Loans' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from loan
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 7 as id,'Working Capital' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from working_capital
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 10 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
		UNION
		select 12 as id,'Fat Check' as menu,0 as count,false as status
		UNION
		select 15 as id,'Status' as menu,0 as count,false as status order by id");
        // select 13 as id,'Financial Scoring' as menu,0 as count,false as status 
		// UNION
        // select 14 as id,'Loan Eligibility' as menu,0 as count,false as status
		// UNION
		
    }elseif($request->role_id == 3){
        $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
        UNION
        select 1 as id,'Business Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 6 as id, 'Loans' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from loan
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 7 as id,'Working Capital' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from working_capital
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 10 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id,'Fat Check' as menu,0 as count,false as status
        UNION
        select 13 as id,'Financial Scoring' as menu,0 as count,false as status 
        UNION
        select 14 as id,'Loan Eligibility' as menu,0 as count,false as status
        UNION
        select 15 as id,'Status' as menu,0 as count,false as status order by id");   
    }elseif($request->role_id == 5){
        $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
        UNION
        select 1 as id,'Business Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 6 as id, 'Loans' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from loan
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 7 as id,'Working Capital' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from working_capital
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id,'Status' as menu,0 as count,false as status order by id");
    }elseif($request->role_id == 7){
        $getRecord = DB::select("select 0 as id,'Appointment List' as menu,0 as count,false as status");
    }elseif($request->role_id == 8){
        $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
        UNION
        select 1 as id,'Business Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 6 as id, 'Loans' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from loan
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 7 as id,'Working Capital' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from working_capital
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 10 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id,'Fat Check' as menu,0 as count,false as status
        UNION
        select 15 as id,'Status' as menu,0 as count,false as status order by id"); 
        // select 13 as id,'Financial Scoring' as menu,0 as count,false as status 
        // UNION
        // select 14 as id,'Loan Eligibility' as menu,0 as count,false as status
        // UNION
        
    }else{
        $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
        UNION
        select 1 as id,'Business Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 6 as id, 'Loans' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from loan
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 7 as id,'Working Capital' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from working_capital
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id,'Status' as menu,0 as count,false as status order by id");
    }
    return response()->json([
        "message" => 'Data fetched successfully',
        "status" => true,
        "data" => $getRecord
        ], 201);

}
	
	public function saveApplicationSummary(Request $request){
         DB::enableQueryLog();

		$application = Application_summary::firstOrNew(['id' => $request->id]);
        $application->application_ref_no = $request->application_ref_no;
        $application->client_background = $request->client_background;
        $application->promoter_comments = $request->promoter_comments;
        $application->financial_p_and_l_comments = $request->financial_p_and_l_comments;
        $application->financial_balance_sheet_comments = $request->financial_balance_sheet_comments;
        $application->financial_ratios_comments = $request->financial_ratios_comments;
        $application->banking_analysis_comments = $request->banking_analysis_comments;
        $application->gst_analysis_comments = $request->gst_analysis_comments;
        $application->assessed_income_comments = $request->assessed_income_comments;
        $application->existing_obligations_comments = $request->existing_obligations_comments;
        $application->repayment_history_comments = $request->repayment_history_comments;
        $application->top_5_customer_comments = $request->top_5_customer_comments;
        $application->top_5_suppliers_comments = $request->top_5_suppliers_comments;
        $application->property_commets = $request->property_commets;
		$application->parent_type_id = $request->parent_type_id;
        $application->parent_id = $request->parent_id;
        $application->enable = 1;
        $application->is_active = 1;
        if (Application_summary::where('id', $request->id)->count() > 0) {
            $application->modified_on = now();
            if ($request->has('created_by')) {
                $application->modified_by = $request->created_by;
            } else {
                $application->modified_by = $request->user_id;
            }
        } else {
            if ($request->has('created_by')) {
                $application->created_by = $request->created_by;
            } else {
                $application->created_by = $request->user_id;
            }
            $application->created_on = now();
            $application->modified_on = now();
            $application->modified_by = $request->created_by;
        }
        
        $application->save();
		
		
		
		 		 $query1 = DB::getQueryLog();
        Log::info($query1[0]['query']);
        $this->callLogFileStore($request->user_id, "Application Summary", "select", $query1[0]['query'], "application_summary","Insert");


        $insert_id = $application->id;
        $data = $application->getAttributes();
        if (!$insert_id) {
            Log::error('Failed to save applicationSummary in pgsql. for ' . $request->parent_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "status" => false,
                "message" => 'Failed to save in pgsql',
            ], 417);
        }
        $data['primary_id'] = $insert_id;
		
		$message = "Application " . $request->application_ref_no . " has been submitted for eligibility computation";
        //Notification to client
        if($request->has('user_id')){
            $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/getUserdetailsbyid', [
                'id' => $request->user_id
            ]);
            $responseBody = json_decode($response->getBody());
            if(isset($responseBody) && $responseBody->status == 1){
            $email = $responseBody->data->email;
            //$email = $data['email'];
            $mobile = $responseBody->data->mobile;
            //$mobile = $data['mobile'];
            $this->getnotifications('email', $email, $message, $request->user_id,'Application has been submitted Successfully');
            $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Application has been submitted Successfully');
        } else {
                return response()->json([
                    "message" => 'No record found on this user_ id',
                    "status" => false
                ], 201);
            }
        }
		//Notifications to SCA
            $response = Http::post('http://164.52.207.42/Identitymanagement/server.php/api/getUsersByRoleid', [
                'role_id' => 3
            ]);
            $responseBody = $response;
            $dataArray = [];

            for ($i = 0; $i < count($responseBody['data']); $i++) {
                $mobile = $responseBody['data'][$i]['mobile'];
                $email = $responseBody['data'][$i]['email'];
                $this->getnotifications('email', $email, $message, $request->user_id,'Application has been submitted Successfully');
                $this->getnotifications('mobile', $mobile, $message, $request->user_id,'Application has been submitted Successfully');
            }

        if ($request->id) {
            return response()->json([
                "status" => true,
                "message" => 'Application Summary Updated Successfuly',
                "Data" => $data
            ], 201);
        } else {
            return response()->json([
                "status" => true,
                "message" => 'Application Summary Inserted Successfuly',
                "Data" => $data
            ], 201);
        }

    }
	
	
//BL LAP HL
    
	
	 public function getsidepanelByrolebasedOnLoan(Request $request){
		Log::info($request);
        DB::enableQueryLog();
      

	  if($request->loantype == 1){
        //   Log::info($request->$loantype);
        if($request->role_id == 2 ){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 10 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
		    UNION
            select 15 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
            
        }elseif($request->role_id == 1 ){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
			select 9 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 10 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 15 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 13 as id,'Financial Scoring' as menu,0 as count,true as status 
            // UNION
            // select 14 as id,'Loan Eligibility' as menu,0 as count,true as status
            // UNION
            
            
}elseif($request->role_id == 3)  {
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
			select 9 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 10 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 12 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 13 as id,'Financial Scoring' as menu,0 as count,true as status 
            UNION
            select 14 as id,'Loan Eligibility' as menu,0 as count,true as status
            UNION
            select 15 as id,'Status' as menu,0 as count,false as status order by id");			
        }elseif($request->role_id == 5){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id,'Status' as menu,0 as count,false as status order by id");
        }elseif($request->role_id == 7){
            $getRecord = DB::select("select 0 as id,'Appointment List' as menu,0 as count,false as status");
        }elseif($request->role_id == 8){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
			select 10 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 12 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Financial Scoring' as menu,0 as count,false as status 
            // UNION
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
            
        }
        else{
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id,'Status' as menu,0 as count,false as status order by id");
        }
       }elseif($request->loantype == 7 || $request->loantype == 12){
        if($request->role_id == 2 ){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,1 as count,true as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
			select 10 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 12 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
            

        }elseif($request->role_id == 1){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
			select 10 as id, 'Documents Uploaded' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from document_store
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 11 as id, 'Schedule Document Collection' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from book_appointment_header
			where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
			UNION
			select 12 as id, 'Application Summary' as menu,count(*),
			case
			when count(*) > 0 then TRUE
			ELSE FALSE
			END as status from application_summary
			where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
			parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,true as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Financial Scoring' as menu,0 as count,true as status 
            // UNION
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
            
        }elseif($request->role_id == 5){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
        }elseif($request->role_id == 7){
            $getRecord = DB::select("select 0 as id,'Appointment List' as menu,0 as count,false as status");
        }elseif($request->role_id == 8){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
             select 10 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,true as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Financial Scoring' as menu,0 as count,true as status 
            // UNION
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
            
        }
        else{
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
        }
       }else{
        if($request->role_id == 2 ){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
             select 10 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,true as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Financial Scoring' as menu,0 as count,true as status 
            // UNION
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
        }elseif($request->role_id == 1){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
             select 10 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,false as status
            UNION
            select 15 as id,'Status' as menu,0 as count,false as status order by id");   
            // select 13 as id,'Financial Scoring' as menu,0 as count,false as status 
            // UNION
            // select 14 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
        }elseif($request->role_id == 5){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
        }elseif($request->role_id == 7){
            $getRecord = DB::select("select 0 as id,'Appointment List' as menu,0 as count,false as status");
        }elseif($request->role_id == 8){
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
             select 10 as id, 'Documents Uploaded' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 11 as id, 'Schedule Document Collection' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from book_appointment_header
        where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 12 as id, 'Application Summary' as menu,count(*),
        case
        when count(*) > 0 then TRUE
        ELSE FALSE
        END as status from application_summary
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        
            UNION
            select 13 as id,'Fat Check' as menu,0 as count,true as status
            UNION
            select 16 as id,'Status' as menu,0 as count,false as status order by id"); 
            // select 14 as id,'Financial Scoring' as menu,0 as count,true as status 
            // UNION
            // select 15 as id,'Loan Eligibility' as menu,0 as count,false as status
            // UNION
        }
        else{
            $getRecord = DB::select("select 0 as id,'Profile' as menu,0 as count,false as status
            UNION
            select 1 as id,'Business Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_infos where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 2 as id ,'Promoter Information' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
            UNION
            select 3 as id,'Lets Get Started' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status
            from request where is_active = 1 and user_id = " . $request->user_id . "
            UNION
            select 4 as id, 'Financial' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from finance_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 5 as id, 'Bank Accounts' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from banking_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 6 as id, 'Loans' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from loan
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 7 as id,'Working Capital' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from working_capital
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 8 as id,'GST Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from gst_header
            where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 9 as id, 'Colateral Details' as menu,count(*),
            case
            when count(*) > 0 then TRUE
            ELSE FALSE
            END as status from hl_lap_header
            where is_active = true and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
            parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
            UNION
            select 10 as id,'Status' as menu,0 as count,false as status order by id");
        }
       }
	   
        return response()->json([
            "message" => 'Data fetched successfully',
            "status" => true,
            "data" => $getRecord
            ], 201);

    }
	
	public function findDocsforPreview(Request $request)
    {
		 DB::enableQueryLog();

		 header('Access-Control-Allow-Origin: *');

        header('Access-Control-Allow-Methods: GET, POST');

        header("Access-Control-Allow-Headers: X-Requested-With");  

        
        DB::enableQueryLog();
        $query = "select document_check_list.id,document_master.name,master_table.name as required_phase  from document_check_list
        left join document_authority_mapping on document_authority_mapping.id = document_check_list.document_master_id
        left join document_master on document_master.id = document_authority_mapping.document_id
        left join document_authority_master on document_authority_master.id = document_authority_mapping.document_authority_id
        left join pin_codes on pin_codes.city_id = document_authority_master.city_id
        left join master_table on master_table.id = document_check_list.required_phase
        where pin_codes.id in(select pin_id from customer where primary_user_id = " . $request->user_id . ") and required_phase = ". $request->required_phase ." and form = '" . $request->form . "' and document_check_list.id =". $request->id;
        $DocumentList = DB::select($query);
       // Log::info($DocumentList);
        $query1 = DB::getQueryLog();
       Log::info($query);
    
        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . "and is_active =1");
                Log::info("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id=" . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . "and is_active =1");
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        //Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = $docMongoId->file_base64;
                            $fileData['docPath'] = $docMongoId->document;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                         //Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    $fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
                //Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }
    }
	
	public function callEligibilityForResubmission(Request $request){
		
            $updateStatus = DB::select("select id,parameter_id,
           parameter_evaluation_status from proc_financial_eval_results where folder_no = '" . $request->folder_no ."' 
         and year IN ('". implode("','", $request->year) ."') and parameter_id IN ('". implode("','", $request->parameter_id) ."')"); 
           //Log::info($updateStatus);
            if(count($updateStatus) > 0){
                 $data =[];
                foreach($updateStatus as $i => $i_value){
                    foreach($request->parameter_id as $j => $j_value){
                        if($j_value == $i_value->parameter_id ){
                                $update = Proc_financial_eval_results::find($i_value->id);
                             //   Log::info($update);
                                $update->parameter_override_flag = $request->parameter_override_flag[$j];
                                $update->parameter_evaluation_override_status = $request->parameter_evaluation_override_status[$j];
                              $update->save();
                        }
                    }
                }
                $response = Http::post('http://164.52.208.120:8082/delta/server.php/api/getuserByFolderno',[
                    'folder_no' => $request->folder_no
                ]);
				//Log::info($response);

                $responseBody = json_decode($response->getBody());
                    if($responseBody->status == 1){
                        $data['business_channel_id'] = $responseBody->data->business_channel_id;
                        $business_channel_id = $data['business_channel_id']; 
                        Log::info($business_channel_id);
                    }else{
                        return response()->json([
                            "status" => false,
                            "message" => 'folder_no not found in request_table',
                            "Data" => $data,
                        ], 201);
                    }
                    $loan_type = DB::select("select short_name from loan_types where id = " . $business_channel_id);
                        //Log::info($loan_type);
                        $loan = $loan_type[0];
                        $pro = json_encode($loan);
                        $obj = json_decode($pro);

                        $loan_type_name = $obj->short_name;
                $data['folder_no'] = $request->folder_no;
                $data['product_category_code'] = $loan_type_name;
                //$data['product_cd'] = "FCCR-S";
                //$procedure = DB::select("call sp_override_elig_calc('".$data['product_category_cd']."', '".$data['product_cd']."', '".$data['folder_no']."')");
                //Log::info($procedure);
                if($data['product_category_code'] == "BL"){
                    $procedure = DB::select("call sp_final_override_elig_calc_bl ('" .$data['folder_no'] . "')");
                }else{
                    $procedure = DB::select("call sp_final_override_elig_calc_lap ('" .$data['folder_no'] . "')");
                }
                
            }
            return response()->json([
                "status" => true,
                "message" => 'Resubmission Successfull'
            ], 201);
        
        
    }
	
	
	
    
public function validationforcustomersubmit(Request $request)
    {
        $getRecord = DB::select("select 1 as id,'Business Information' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status
        from business_infos where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 2 as id ,'Promoter Information' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status
        from business_promoter_mapping where is_active = 1 and business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ")
        UNION
        select 3 as id,'Lets Get Started' as menu,count (*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status
        from request where is_active = 1 and user_id = " . $request->user_id . "
        UNION
        select 4 as id, 'Financial' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status from finance_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 5 as id, 'Bank Accounts' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status from banking_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 8 as id,'GST Details' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status from gst_header
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))
        UNION
        select 9 as id, 'Documents Uploaded' as menu,count(*)
,
        case
        when count(*)
 > 0 then TRUE
        ELSE FALSE
        END as status from document_store
        where is_active = 1 and parent_type_id in(1,2) and parent_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . ") or
        parent_id in(select promoter_id from business_promoter_mapping where business_id in(select id from business_infos where is_active = 1 and user_id = " . $request->user_id . "))");

        //Log::info($getRecord);
    
        foreach ($getRecord as $record) {
            if ($record->status === false) {
                //return false;
                return response()->json([
                    "status" => false
                ], 201);
            }
        }

        return response()->json([
            "status" => true
        ], 201);
    }
   
   
	
//jayesh

     // alternate api for find doc of user jayesh
    public function findDocsOfUserV2(Request $request)
 {
     if ($request->form == '10') {
         $query = "
         select document_master.name,document_checklist_new.id id, document_checklist_new.required_phase,document_checklist_new.document_master_id from document_checklist_new
         left join document_master on document_master.id = document_checklist_new.document_master_id where  required_phase = ". $request->required_phase ." ";
         $DocumentList = DB::select($query);
         Log::info($DocumentList);
     } else {
         $query = "
         select document_master.name,document_checklist_new.id id, document_checklist_new.required_phase,document_checklist_new.document_master_id from document_checklist_new
         left join document_master on document_master.id = document_checklist_new.document_master_id where required_phase = ". $request->required_phase ." and form = '".$request->form ."'  ";
         $DocumentList = DB::select($query);
         Log::info($DocumentList);
     }
     if (count($DocumentList)>0) {
         foreach ($DocumentList as $k => $k_value) {
             $query = "";
             if ($k_value->id == 25) {
                 $query = "select * from document_store where document_checklist_id = " . $k_value->id . " 
                 and parent_id=" . $request->parent_id . " and parent_type_id =" . $request->parent_type_id . " and 
                 interval_flag = '".$request->interval_flag."' and  is_active =1" ;
             } else {
                 $query= "select * from document_store where document_checklist_id = " . $k_value->id . " 
                     and parent_id=" . $request->parent_id . " and parent_type_id =" . $request->parent_type_id . " and is_active =1";
             }

             $documentStoreData = DB::select($query);
             $documentArray = [];
             //Log::info($documentStoreData);
             if (count($documentStoreData) > 0) {
                 foreach ($documentStoreData as $j => $j_value) {
                     //Log::info($j_value->document_upload_id);
                     $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                     //Log::info($docMongoId);
                     if ($docMongoId != null || $docMongoId != '') {
                         $fileData['id'] = $j_value->document_upload_id;
                         $fileData['file_name'] = $docMongoId->name;
                         $fileData['file_type'] = $docMongoId->file_type;
                         $fileData['modified_date'] = $docMongoId->date_and_time;
                          $fileData['base64String'] = $docMongoId->file_base64;
                         $fileData['docPath'] = $docMongoId->document;
                         $fileData['calendar_id'] = $j_value->calendar_id;
                         $fileData['calendar_name'] = $j_value->calendar_name;
                         $fileData['interval_flag'] = $j_value->interval_flag;
                     } else {
                         $fileData['file_name'] = "";
                         $fileData['file_type'] = "";
                         $fileData['modified_date'] = "";
                         $fileData['base64String'] = "";
                         $fileData['interval_flag'] = "";
                     }
                     // Log::info($j_value->document_upload_id);
                     $documentArray[$j] = $fileData;
                 }
                 //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
             } else {
                 $fileData['file_name'] = "";
                 $fileData['file_type'] = "";
                 $fileData['modified_date'] = "";
                 $fileData['base64String'] = "";
                 $fileData['interval_flag'] = "";
                 $documentArray[0] = $fileData;
             }
             //Log::info($documentArray);
             $DocumentList[$k]->documentArray = $documentArray;
         }
     }

     if (count($DocumentList) > 0) {
         return response()->json([
             "status" => true,
             "message" => 'Data fetched successfully',
             "data" => $DocumentList
         ], 201);
     } else {
         return response()->json([
             "status" => false,
             "message" => 'data not found'
         ], 200);
     }
 }
    
    public function getAllDocumentsByUserV2(Request $request){
        DB::enableQueryLog();
        $query = "select document_master.doc_type, document_master.name,document_checklist_new.id id , document_checklist_new.required_phase,document_checklist_new.document_master_id from document_checklist_new
        left join document_master on document_master.id = document_checklist_new.document_master_id order by document_master.short_order";
        $DocumentList = DB::select($query);
        //Log::info($DocumentList);
        
        $query1 = DB::getQueryLog();
        //Log::info($qq);
        if (count($DocumentList) > 0) {
            foreach ($DocumentList as $k => $k_value) {
                $parentNull = '';
                if (!empty($request->parent_id)) {
                    $parentNull = " and parent_id = " . $request->parent_id;
                }
                
                $businessId = BusinessInfo::where('name', $request->business_name)->first();
                if(!empty($businessId)){
                    $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . $parentNull . "  and parent_type_id = " . $request->parent_type_id . " and parent_id = " . $businessId->id . " and is_active = 1");
                } else {
                    $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . $parentNull . "  and parent_type_id = " . $request->parent_type_id . " and is_active = 1");
                }
                
                // $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id = " . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . " and is_active = 1");
                
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = "";
                            $fileData['base64String'] = $docMongoId->file_base64;
                            $fileData['docPath'] = $docMongoId->document;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    //$fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
                //Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }  

    }

    public function getAllGroupedByDocumentsByUserV2(Request $request){
        DB::enableQueryLog();
        $query = "select document_master.doc_type, document_master.name,document_checklist_new.id id , document_checklist_new.required_phase,document_checklist_new.document_master_id from document_checklist_new
        left join document_master on document_master.id = document_checklist_new.document_master_id where document_master.doc_type is not null order by document_master.short_order";
        $DocumentList = DB::select($query);
        //Log::info($DocumentList);
        
        $query1 = DB::getQueryLog();
        //Log::info($qq);
        if (count($DocumentList) > 0) {
            echo json_encode($DocumentList);
            foreach ($DocumentList as $k => $k_value) {
                $parentNull = '';
                if (!empty($request->parent_id)) {
                    $parentNull = " and parent_id = " . $request->parent_id;
                }
                
                $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . $parentNull . "  and parent_type_id = " . $request->parent_type_id . " and is_active = 1");
                // $documentStoreData = DB::select("select * from document_store where document_checklist_id = " . $k_value->id . " and parent_id = " . $request->parent_id . " and parent_type_id = " . $request->parent_type_id . " and is_active = 1");
                
                //Log::info($documentStoreData);
                $documentArray = [];

                //Log::info($documentStoreData);
                if (count($documentStoreData) > 0) {
                    foreach ($documentStoreData as $j => $j_value) {
                        Log::info($j_value->document_upload_id);
                        $docMongoId = Upload_document_doc::find($j_value->document_upload_id);
                        //Log::info($docMongoId);
                        if ($docMongoId != null || $docMongoId != '') {
                            $fileData['id'] = $j_value->document_upload_id;
                            $fileData['file_name'] = $docMongoId->name;
                            $fileData['file_type'] = $docMongoId->file_type;
                            $fileData['modified_date'] = $docMongoId->date_and_time;
                            $fileData['base64String'] = "";
                            $fileData['base64String'] = $docMongoId->file_base64;
                            $fileData['docPath'] = $docMongoId->document;
                        } else {
                            $fileData['file_name'] = "";
                            $fileData['file_type'] = "";
                            $fileData['modified_date'] = "";
                            $fileData['base64String'] = "";
                        }
                        // Log::info($j_value->document_upload_id);

                        $documentArray[$j] = $fileData;
                    }
                    //$fileData['file_name'] = $documentStoreData[0]->document_upload_id;
                } else {
                    $fileData['file_name'] = "";
                    $fileData['file_type'] = "";
                    $fileData['modified_date'] = "";
                    //$fileData['base64String'] = "";
                    $documentArray[0] = $fileData;
                }
                //Log::info($documentArray);
                $DocumentList[$k]->documentArray = $documentArray;
            }
        }
        if (count($DocumentList) > 0) {
            return response()->json([
                "status" => true,
                "message" => 'Data fetched successfully',
                "data" => $DocumentList
            ], 201);
        } else {

            return response()->json([
                "status" => false,
                "message" => 'data not found'
            ], 200);
        }  

    }
	
	
		
	public function callLogFileStore($userId, $formType, $queryType, $query, $tableName, $userAction)
    {
        $audit_trail = new Audit_trail();
        $audit_trail->user_id = $userId;
        $audit_trail->ip_address = $_SERVER['REMOTE_ADDR'];
        $audit_trail->form_type = $formType;
        $audit_trail->query_type = $queryType;
        $audit_trail->query = $query;
        $audit_trail->table_name = $tableName;
        $audit_trail->created_by = $userId;
        $audit_trail->created_on = now();
        $audit_trail->modified_by = $userId;
        $audit_trail->modified_on = now();
        $audit_trail->is_active = 1;
        $audit_trail->enable = true;
        $audit_trail->user_action = $userAction;
        $audit_trail->save();
        $mongo_insert_id = $audit_trail->_id;
        Log::info('mongodb insert Id' . $mongo_insert_id);
        if (!$mongo_insert_id) {
            Log::error('Failed to save File In mongodb.' . $mongo_insert_id);
            //417: “Expectation Failed.” The server is unable to meet the requirements specified in the request’s expect header field.
            return response()->json([
                "message" => 'Failed to save File In mongodb',
                "id" => null
            ], 201);
        }
    }
	
	
	//ganashree
	 public function documentAddAndEdit(Request $request) {
        if (empty($request)) {
            return;
        }
		$docmaster = DocMaster::firstOrNew(['id' => $request->id]);
        $docmaster->name = $request->name;
		 $docmaster->short_name = $request->shortname;
        $docmaster->description = $request->description;
        $docmaster->single='single';
        $docmaster->digital_verification='no';
        $docmaster->time_bound=1;
        $docmaster->enable = true;
        $docmaster->is_active=true;
        $docmaster->created_by=1;
        $docmaster->modified_by = 1;
        $docmaster->save();
		
         DB::table("document_checklist_new")
        ->insert(
            array(
                'document_master_id' => $docmaster->id,
                'required_phase' => 172,
                'required' => true,
                'original_required' => false,
                'document_type' => 'Hard',
                'length' => 10,
                'time_grain' => 7,
                'form' => $request->form,
                'enable' => true,
                'is_active' => true,
                'created_by'=> 1,
                'modified_by'=> 1,
                'created_on' => now(),
                'modified_on' => now(),

            )
        );

        $insert_id = $docmaster->id;
        if($insert_id) {
            return response()->json([
                "status" => true,
                "message" => 'Data saved successfully'
            ], 201);
        } else {
            return response()->json([
                "status" => false,
                "message" => 'Data not saved successfully'
            ], 201);
        }

    }
	
	
	  public function getDocByid(Request $request){

                $doc = DocMaster::select('*')->where('id', $request->id)->where('is_active','=',true)->get();
                if(count($doc) > 0) {
                return response()->json([
                    "status" => true,
                    "message" => 'Data fetched successfully',
                    "data" => $doc
                ], 200);
                } else {
                return response()->json([
                    "status" => false,
                    "message" => 'no records found'
                ], 200);
                }
                }

                public function deleteDoc(Request $request)
                {
                $doc = DocMaster::find($request->id);
                $doc->is_active  = 0;
                $doc->save();
                $updateId = $doc->id;
                     if ($updateId) {
                return response()->json([
                    "status" => true,
                    "message" => 'Deleted successfully',
                ], 201);
                } else {
                return response()->json([
                    "status" => false,
                    "message" => 'Failed to delete',
                ], 201);
                }
                }
				 public function getLatFileByParentId(Request $request)
                {
                    $query = "select interval_flag from document_store where parent_id = ".$request->parent_id." and interval_flag is not null order by created_on desc limit 1";
                   
                    $data = DB::select($query);
                    if (count($data) > 0) {
                        return response()->json([
                        "status" => true,
                        "message" => 'Data fetched successfully',
                        "data" => $data[0]->interval_flag
                    ], 201);
                    } else {
                        return response()->json([
                        "status" => false,
                        "message" => 'data not found'
                    ], 200);
                    }
                }
				 public function updateDoumentRecievedStatus(Request $request)
                {
                    // Log::info($request);
                    //  Log::info('------------------------------------------------');
                    
                    $tempArr = $request->arr;
                    foreach ($tempArr as $i => $ivalue) {
                         Log::info($ivalue);
                        // Log::info('------------------------------------------------');
            
                        try {
                            Log::info($ivalue['id']);
                            $book_appointment_details = Book_appointment_details::firstOrNew(['id' => $ivalue['id']]);
                            $book_appointment_details->is_collected =$ivalue['collected'];
                            $book_appointment_details->collected_by =  $request->collected_by;
                            $book_appointment_details->save();
            
                            Log::info($book_appointment_details);
                        } catch (\Exception $e) {
                        }
                    }
                    return response()->json([
                        "status" => true,
                        "message" => 'Updated succefully',
                    ], 201);
                }
}